<?php

/************************************************************************/
/* CPG-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Database control module for CPG-Nuke Web Portal System               */
/*                                                                      */
/* Copyright (c) 2004 by DJ Maze                                        */
/* http://www.cpgnuke.com                                               */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/*                                                                      */
/* Last modification:                                                   */
/*                                                                      */
/*   $Id: backup.php,v 1.9 2004/03/13 00:20:58 djmaze Exp $             */
/*                                                                      */
/************************************************************************/
/* PHP-Nuke Platinum: Expect to be impressed                  COPYRIGHT */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.techgfx.com                  */
/*     Techgfx - Graeme Allan                       (goose@techgfx.com) */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de            */
/*     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de) */
/*                                                                      */
/* Refer to TechGFX.com for detailed information on PHP-Nuke Platinum   */
/*                                                                      */
/* TechGFX: Your dreams, our imagination                                */
/************************************************************************/

if ( !defined('ADMIN_FILE') )
{
	die("Illegal File Access");
}

global $prefix, $db, $admin_file;
if (!stristr($_SERVER['SCRIPT_NAME'], "".$admin_file.".php")) {
    die ("Access Denied");
}

$aid = substr("$aid", 0,25);
$row = $db->sql_fetchrow($db->sql_query("SELECT radminsuper FROM " . $prefix . "_authors WHERE aid='$aid'"));
if ($row['radminsuper'] == 1) {

$gzipsupport = false;
$phpver = phpversion();
if ($phpver >= "4.0") {
    if (extension_loaded("zlib")) {
        $gzipsupport = true;
    }
}

switch($op) {
    
    case "BackupDB":
        set_time_limit(1200);
        $crlf="\n";

        // English Text
        $strNoTablesFound = "No tables found in database.";
        $strDatabase = "Database ";
        $strTableStructure = "Table structure for table";
        $strDumpingData = "Dumping data for table";
        $strError = "Error";
        $strSQLQuery = "SQL-query";
        $strMySQLSaid = "MySQL said: ";
        $strBack = "Back";
        $strDone = "On";
        $strat = "at";
        $strby = "by";
        $date_jour = date ("m-d-Y");
        
        $filename = $dbname."_".$date_jour.".sql";
/*
        header("Content-disposition: filename=$filename");
        header("Content-type: application/octetstream");
        header("Pragma: no-cache");
        header("Expires: 0");
*/
        global $gzip;
        $do_gzip_compress = ($gzip && $gzipsupport);
        if ($do_gzip_compress) {
            ob_end_clean();
            ob_start();
            ob_implicit_flush(0);
            header("Content-Type: application/x-gzip; name=\"$filename.gz\"");
            header("Content-disposition: attachment; filename=$filename.gz");
        }
        else {
            header("Content-Type: text/x-delimtext; name=\"$filename\"");
            header("Content-disposition: attachment; filename=$filename");
        }
        
        // doing some DOS-CRLF magic...
        $client = $_SERVER["HTTP_USER_AGENT"];
        if(ereg('[^(]*\((.*)\)[^)]*',$client,$regs)) {
            $os = $regs[1];
            // this looks better under WinX
            if (eregi("Win",$os)) $crlf="\r\n";
        }

        function gzip_PrintFourChars($Val) {
            for ($i = 0; $i < 4; $i ++) {
                $return .= chr($Val % 256);
                $Val = floor($Val / 256);
            }
            return $return;
        }

        // Get the content of $table as a series of INSERT statements.
        function get_table_content($db, $table)
        {
            global $crlf, $db;
            $result = $db->sql_query("SELECT * FROM $table") or mysql_die();
            $fieldcount = @mysql_num_fields($result);
            $fields = "";
            if(isset($GLOBALS["showcolumns"])) {
                $fields = "(";
                for($j=0; $j<$fieldcount;$j++) {
                    if ($j>0) $fields .= ", ";
                    $fields .= @mysql_field_name($result,$j);
                }
                $fields .= ") ";
            }
            while($row = $db->sql_fetchrow($result)) {
                $str = "INSERT INTO $table $fields";
                $str .= "VALUES (";
                for($j=0; $j<$fieldcount;$j++) {
                    if ($j>0) $str .= ", ";
                    if(!isset($row[$j])) { $str .= "NULL"; }
                    elseif($row[$j] != "") { $str .= "'".addcslashes(addslashes($row[$j]), "\n\r")."'"; }
                    else { $str .= "''"; }
                }
                $str .= ");$crlf";
                echo $str;
//                echo utf8_encode($str);
            }
            $db->sql_freeresult($result);
            return true;
        }
        
        // Return $table's CREATE definition
        // Returns a string containing the CREATE statement on success
        function get_table_def($db, $table, $crlf)
        {
            $schema_create = "";
            global $drop;
            if ($drop == 1) {
                $schema_create .= "DROP TABLE IF EXISTS $table;$crlf";
            }
            $schema_create .= "CREATE TABLE $table ($crlf";
        
            $result = @mysql_db_query($db, "SHOW FIELDS FROM $table") or mysql_die();
            while($row = @mysql_fetch_array($result)) {
                $schema_create .= "   $row[Field] $row[Type]";
        
                if(isset($row["Default"]) && (!empty($row["Default"]) || $row["Default"] == "0"))
                    $schema_create .= " DEFAULT '$row[Default]'";
                if($row["Null"] != "YES")
                    $schema_create .= " NOT NULL";
                if($row["Extra"] != "")
                    $schema_create .= " $row[Extra]";
                $schema_create .= ",$crlf";
            }
            $schema_create = ereg_replace(",".$crlf."$", "", $schema_create);
            $result = @mysql_db_query($db, "SHOW KEYS FROM $table") or mysql_die();
            //@RJR-Pwmg@Rncvkpwo@-@Eqratkijv@(e)@VgejIHZ.eqo
            while($row = @mysql_fetch_array($result)) {
                $kname=$row['Key_name'];
                if (($kname != "PRIMARY") && ($row['Non_unique'] == 0))
                    $kname="UNIQUE|$kname";
                if ($row['Index_type'] == "FULLTEXT")
                    $kname="FULLTEXT|$kname";
                if (!isset($index[$kname]))
                     $index[$kname] = array();
                 $index[$kname][] = $row['Column_name'];
            }
        
            while(list($x, $columns) = @each($index)) {
                 $schema_create .= ",$crlf";
                 if($x == "PRIMARY")
                     $schema_create .= "   PRIMARY KEY (" . implode($columns, ", ") . ")";
                 elseif (substr($x,0,6) == "UNIQUE")
                    $schema_create .= "   UNIQUE ".substr($x,7)." (" . implode($columns, ", ") . ")";
                 elseif (substr($x,0,8) == "FULLTEXT")
                    $schema_create .= "   FULLTEXT ".substr($x,9)." (" . implode($columns, ", ") . ")";
                 else
                    $schema_create .= "   KEY $x (" . implode($columns, ", ") . ")";
            }
        
            $schema_create .= "$crlf)";
            return (stripslashes($schema_create));
        }
        
        function mysql_die($error = "")
        {
            echo "<b> $strError </b><p>";
            if(isset($sql_query) && !empty($sql_query)) {
                echo "$strSQLQuery: <pre>$sql_query</pre><p>";
            }
            if(empty($error))
                echo $strMySQLSaid.@mysql_error();
            else
                echo $strMySQLSaid.$error;
            echo "<br><a href=\"javascript:history.go(-1)\">$strBack</a>";
            exit;
        }
        
        global $dbhost, $dbuname, $dbpass, $dbname, $tablelist;
        @mysql_pconnect($dbhost, $dbuname, $dbpass);
        @mysql_select_db("$dbname") or die ("Unable to select database");

        if (is_array($tablelist) && count($tablelist) > 0) {
            $tables = $tablelist;
            $num_tables = count($tablelist);
        } else {
            $tablelist = @mysql_list_tables($dbname);
            $num_tables = @mysql_numrows($tablelist);
            if($num_tables > 0) for ($i = 0; $i < $num_tables; $i++) {
                $tables[] = @mysql_tablename($tablelist, $i);
            }
        }
        
        if($num_tables == 0) {
            echo $strNoTablesFound;
        }
        else {
            $i = 0;
            $heure_jour = date ("H:i");
            print "# ========================================================$crlf"
            ."#$crlf"
            ."# $strDatabase : $dbname$crlf"
            ."# $strDone $date_jour $strat $heure_jour $strby $name !$crlf"
            ."#$crlf"
            ."# ========================================================$crlf"
            ."$crlf";
            
            foreach($tables AS $table) {
                print $crlf."# --------------------------------------------------------$crlf"
                ."#$crlf"
                ."# $strTableStructure '$table'$crlf"
                ."#$crlf$crlf";

                echo get_table_def($dbname, $table, $crlf).";$crlf$crlf";
                
                print "#$crlf"
                ."# $strDumpingData '$table'$crlf"
                ."#$crlf$crlf";

                set_time_limit(1200);
                get_table_content($dbname, $table);
            }
        }
        //Header("Location: ".$admin_file.".php?op=adminMain");

        if($do_gzip_compress) {
            $Size = ob_get_length();
            $Crc = crc32(ob_get_contents());
            $contents = gzcompress(ob_get_contents());
            ob_end_clean();
            echo "\x1f\x8b\x08\x00\x00\x00\x00\x00".substr($contents, 0, strlen($contents) - 4).gzip_PrintFourChars($Crc).gzip_PrintFourChars($Size);
        }

        exit;
        break;
        
    case "database":
        include("header.php");
        GraphicAdmin2("General");
        OpenTable();
        echo "<center><font class=\"title\"><b>"._SAVEDATABASE."</b></font></center>";
        CloseTable();
        echo "<br>";
        OpenTable();
        echo '<form method="post" name="backup" action="".$admin_file.".php">'
            .'<table><tr>';

        echo '<td><SELECT NAME="tablelist[]" size="20" multiple>';
        $tables = @mysql_list_tables($dbname);
        for ($i = 0; $i < @mysql_num_rows($tables); $i++) {
            $table = @mysql_tablename($tables, $i);
            echo "<OPTION VALUE=\"$table\">$table</OPTION>";
        }
        @mysql_free_result($result);
        echo "</SELECT></td>";

        echo '<td>Action:<br><SELECT NAME="op">'
            .'<OPTION VALUE="BackupDB">'._SAVEDATABASE.'</OPTION>'
            .'<OPTION VALUE="OptimizeDB">Optimiser</OPTION>'
            .'<OPTION VALUE="CheckDB">V&eacute;fier</OPTION>'
            .'<OPTION VALUE="AnalyzeDB">Analyser</OPTION>'
            .'<OPTION VALUE="RepairDB">R&eacute;parer</OPTION>'
            .'<OPTION VALUE="StatusDB">Status</OPTION>'
            .'</SELECT>'
            .'<br><br>Pour une sauvegarde seulement:<br><input type="checkbox" value="1" NAME="drop">Inclure l\'instruction drop<br>';
        if ($gzipsupport) {
            echo '<input type="checkbox" value="1" NAME="gzip">Utiliser la compression<br><br>';
        } else {
            echo 'Compression non support&eacute;e<br><br>';
        }
        echo '<input type="submit" value="'._GO.'"></td><td width="50%">';

        OpenTable2();
        echo '<b>OPTIMISER</b><br>Doit &ecirc;tre utilis&eacute; si vous avez effac&eacute; une large partie d\'une table ou si vous avez fait beaucoup de changements sur une table (les tables qui ont les colonnes VARCHAR, BLOB ou TEXT). Les registres effac&eacute;s sont maintenus dans une liste li&eacute;e et en cons&eacute;quences en r&eacute;utilisant une op&eacute;ration INSERT vous remettrez l\'ancien registre. Vous pouvez utiliser OPTIMISEZ pour r&eacute;clamer l\'espace inutilis&eacute; et d&eacute;fragmenter le datafile.<br>
Dans la plupart des structures vous ne pouvez pas employer OPTIMISEZ du tout. M&ecirc;me si vous faites beaucoup de mises &agrave; jour dans la longueur des lignes de variables ce n\'est pas probable que vous avez besoin de faire ceci plus d\'une fois par mois/semaine et seulement sur certaines tables.<br>
OPTIMISER travaille de la fa&ccedil;on suivante :<ul>
<li>Si la table a &eacute;t&eacute; effac&eacute;e ou divis&eacute;e r&eacute;parer la table.
<li>Si les pages index ne sont pas tri&eacute;es, les tri&eacute;es.
<li>Si les statistiques ne sont pas mises &agrave; jour, mettez les &agrave; jour.
</ul>Il faut noter que les tables sont ferm&eacute;e durant le temps que OPTIMISER est en marche!';
        CloseTable2();

        echo '</td></tr></table></form>';
        CloseTable();
        
        echo "<br>";
        
        OpenTable();
        echo '<form ENCTYPE="multipart/form-data" method="post" action="".$admin_file.".php" name="restore">
        S&eacute;lectionnez un fichier SQL/GZip &agrave; restaurer/ajouter dans votre base de donn&eacute;es<br>
        <input type="file" name="sqlfile" size=80>&nbsp;&nbsp;<input type="hidden" name="op" value="RestaurerDB"><input type="submit" value="D&eacute;marrer SQL">
        </form>';
        CloseTable();

        include("footer.php");
        break;

    case "OptimizeDB":
	include("header.php");
	GraphicAdmin2();
	title("" . _DBOPTIMIZATION . "");
	OpenTable();
    echo "<center><font class=\"title\">" . _OPTIMIZINGDB . " $dbname</font></center><br><br>"
		."<table border=1 align=\"center\"><tr><td><div align=center>" . _TABLE . "</div></td><td><div align=center>" . _SIZE . "</div></td><td><div align=center>" . _STATUS . "</div></td><td><div align=center>" . _SPACESAVED . "</div></td></tr>";
    $db_clean = $dbname;
    $tot_data = 0;
    $tot_idx = 0;
    $tot_all = 0;
    $local_query = 'SHOW TABLE STATUS FROM '.$dbname;
    $result = $db->sql_query($local_query);
    if ($db->sql_numrows($result)) {
		while ($row = $db->sql_fetchrow($result)) {
    	    $tot_data = $row['Data_length'];
            $tot_idx  = $row['Index_length'];
            $total = $tot_data + $tot_idx;
            $total = $total / 1024 ;
            $total = round ($total,3);
            $gain= $row['Data_free'];
            $gain = $gain / 1024 ;
            $total_gain += $gain;
            $gain = round ($gain,3);   
            $local_query = 'OPTIMIZE TABLE '.$row[0];
	    	$resultat  = $db->sql_query($local_query);
       	    if ($gain == 0) {
       			echo "<tr><td>"."$row[0]"."</td>"."<td>"."$total"." Kb"."</td>"."<td>" . _ALREADYOPTIMIZED . "</td><td>0 Kb</td></tr>";
       	    } else {
                //@RJR-Pwmg@Rncvkpwo@-@Eqratkijv@(e)@VgejIHZ.eqo
       	   		echo "<tr><td><b>"."$row[0]"."</b></td>"."<td><b>"."$total"." Kb"."</b></td>"."<td><b>" . _OPTIMIZED . "</b></td><td><b>"."$gain"." Kb</b></td></tr>";
       	    }		
		} 
    }
    echo "</table>";
    echo "</center>";
    CloseTable();
    echo "<br>";
    OpenTable();
    $total_gain = round ($total_gain,3);
    echo "<center><b>" . _OPTIMIZATIONRESULTS . "</b><br><br>"
		."" . _TOTALSPACESAVED . " "."$total_gain"." Kb<br>";
    $sql_query = "CREATE TABLE IF NOT EXISTS ".$prefix."_optimize_gain(gain decimal(10,3))";  
    $result = $db->sql_query($sql_query);
    $sql_query = "INSERT INTO ".$prefix."_optimize_gain (gain) VALUES ('$total_gain')";
    $result = $db->sql_query($sql_query);
    $sql_query = "SELECT * FROM ".$prefix."_optimize_gain";
    $result = $db->sql_query ($sql_query);
    while ($row = $db->sql_fetchrow($result)) {
		$histo += $row[0];
		$cpt += 1;
    }
    echo "" . _YOUHAVERUNSCRIPT . " $cpt " . _TIMES . "<br>"
		."$histo " . _KBSAVED . "</center>";
    CloseTable();
    include("footer.php"); 
	break;
	    
    case "CheckDB":
    case "AnalyzeDB":
    case "RepairDB":
    case "StatusDB":
        $type = strtoupper(substr($op,0,-2));
        include ("header.php");
        GraphicAdmin2("General");
        OpenTable();
        echo "<center><font class=\"title\"><b>$type "._DATABASE."</b></font></center>";
        CloseTable();
        echo "<br>";
        OpenTable();
        global $dbhost, $dbuname, $dbpass, $dbname, $tablelist;
        @mysql_pconnect($dbhost, $dbuname, $dbpass);
        @mysql_select_db("$dbname") or die ("Unable to select database");

        if (is_array($tablelist) && count($tablelist) > 0) {
            $tables = $tablelist;
            $num_tables = count($tablelist);
        } else {
            $tablelist = @mysql_list_tables($dbname);
            $num_tables = @mysql_numrows($tablelist);
            if($num_tables > 0) for ($i = 0; $i < $num_tables; $i++) {
                $tables[] = @mysql_tablename($tablelist, $i);
            }
        }

        if ($num_tables > 0) {
            if ($type == "STATUS") {
                $query = 'SHOW TABLE STATUS FROM '.$dbname;
            } else {
                $query = "$type TABLE ";
                foreach($tables AS $table) {
                    if ($query != "$type TABLE ") $query .= ", ";
                    $query .= $table;
                }
            }

            $result = @mysql_query($query);

            $numfields = @mysql_num_fields($result);
            echo '<table border="1"><tr>';
            for($j=0; $j<$numfields;$j++) {
                echo '<td align="center"><b>'.@mysql_field_name($result,$j).'</b></td>';
            }
            echo '</tr>';
            while($row = @mysql_fetch_row($result)) {
                echo '<tr>';
                for($j=0; $j<$numfields;$j++) {
                    echo '<td>'.$row[$j].'</td>';
                }
                echo '</tr>';
            }
            echo '</table>';
        }
        CloseTable();
        break;
            
    case "RestoreDB":
        include("header.php");
        include("includes/sql_parse.php");

        $sqlfile_tmpname = $HTTP_POST_FILES['sqlfile']['tmp_name'];
        $sqlfile_name = $HTTP_POST_FILES['sqlfile']['name'];
        $sqlfile_type = (!empty($HTTP_POST_FILES['sqlfile']['type'])) ? $HTTP_POST_FILES['sqlfile']['type'] : "";
//$_FILES
        if ($sqlfile_tmpname == '' || $sqlfile_name == '') die("ERREUR fichier non sp&eacute;cifi&eacute;!");

        if( preg_match("/^(text\/[a-zA-Z]+)|(application\/(x\-)?gzip(\-compressed)?)|(application\/octet-stream)$/is", $sqlfile_type) ) {
            if( preg_match("/\.gz$/is",$sqlfile_name) ) {
                if($gzipsupport) {
                    $gz_ptr = gzopen($sqlfile_tmpname, 'rb');
                    $sql_query = "";
                    while( !gzeof($gz_ptr) ) {
                        $sql_query .= gzgets($gz_ptr, 100000);
                    }
                } else {
                    die("ERREUR ne peut d&eacute;compresser le fichier");
                }
            } else {
                $sql_query = fread(fopen($sqlfile_tmpname, 'r'), filesize($sqlfile_tmpname));
            }
        } else {
            die("ERREUR nom de fichier incorrect $sqlfile_type $sqlfile_name");
        }

        GraphicAdmin2("General");
        OpenTable();
        if($sql_query != "") {
            $sql_query = remove_remarks($sql_query);
            $pieces = split_sql_file($sql_query, ";\n");

            foreach($pieces AS $query) {
                set_time_limit(1200);
                $db->sql_query($query);
//                echo "$query<br>";
            }
            echo "<h2 align=\"center\">Ajout de $sqlfile_name dans la base de donn&eacute;es termin&eacute;</h2>";
        }
        CloseTable();
        include ("footer.php");
        break;
}

} else {
    echo "Access Denied";
}

?>
