<?PHP
/************************************************************************/
#  TeamSpeak Block For PHP-NUKE: Web Portal System
#  ===============================================
# 
# Copyright (c) 2005 by Tsuchida, Butcher and PrideKillersInc =PKI= Ver 1.2
# http://www.PrideKillersInc.com
# January 2005
# - Fixes:
#   1) Combined operability from two blocks allowing user to log into a non-secure TS server by clicking onto the channel name and to log into a secure server by using the pulldown menu.
#   2) Changed standard green bullet to blinking green bullet.
#   3) Sorted main and sub channels by Sort Order (setting in TeamSpeak under "Edit Channel")
#   4) Sorted main and sub channels alphabeticly if they have the same Sort Order (setting in TeamSpeak under "Edit Channel")
#   5) Config flag for displaying the pulldown menu. Set $DisplayPullDown to 0 to remove the pulldown menu from the block display
#
# modified by: Tsuchida, Butcher and PrideKillersInc =PKI=
# http://www.PrideKillersInc.com
# Febuary 2005
# - Fixes:
#   1) Added icons for user status. Now you cna tell when users are AFK, muted, etc.
#   2) Added ability for admin to block anyone logging in anonymously.
#   3) Added ability for user to log in with a name other than the one they are logged into the website with.
#
/************************************************************************/

/*****************************************************
* Set used ID:s                                       
*****************************************************/
function usedID($usedArray,$id)
{       
    $ok = true;
    for($i=0;$i<count($usedArray);$i++)
    {   
        if($usedArray[$i]==$id) {
            $ok = false;            
        }       
    }
    return $ok;
}

/*****************************************************
* Sort based on the channel name
*****************************************************/
function compare($x, $y)
{
 if ( strtolower($x[channelname]) == strtolower($y[channelname]) )
  return 0;
 else if ( strtolower($x[channelname]) < strtolower($y[channelname]) )
  return -1;
 else
  return 1;
}

/*****************************************************
* Set User Status                                     
*****************************************************/
function setUserStatus($img)
{
    switch ($img) {
        case "1" : //Channel Commander
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/ccommander.gif\"  border=\"0\"";
        break;
        
        case "3" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/ccommander.gif\"  border=\"0\"";
        break;  
        
        case "5" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/ccommander.gif\"  border=\"0\"";
        break;
        
        case "7" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/ccommander.gif\"  border=\"0\"";
        break;      
        
        case "8" : //Away
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "9" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "10" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "11" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "12" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "13" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "14" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "15" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;          
        
        case "16" : //Microphone Muted
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;
        
        case "17" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;
        
        case "18" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;
        
        case "19" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;
        
        case "20" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;
        
        case "21" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;
        
        case "22" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;
        
        case "23" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/muted.gif\"  border=\"0\"";
        break;      
        
        case "24" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "25" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "26" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "27" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "28" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "29" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "30" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "31" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;      
        
        case "32" : //Sound Muted
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "33" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "34" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "35" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "36" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "37" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "38" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "39" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;      
        
        case "40" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "41" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "42" : 
        $img = "<img src=\"modules/Teamspeak/modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "43" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "44" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "45" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "46" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "47" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;      
        
        case "48" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "49" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "50" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "51" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "52" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "53" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "54" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "55" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "56" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;
        
        case "57" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/smuted.gif\"  border=\"0\"";
        break;      
        
        case "58" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "59" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;      
        
        case "60" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;
        
        case "61" : 
        $img = "<img src=\"modules/Teamspeak/webpost/images/icons/away.gif\"  border=\"0\"";
        break;      
        
        default :
        $img = "<img src=\"modules/Teamspeak/webpost/images/bullet_ts.gif\" border=\"0\"";
        break;      
        
    }            
    return $img;        
}

/*****************************************************
* Set User Status Text                                    
*****************************************************/
function setUserStatusText($str)
{
    switch ($str) {
        case "1" : 
        $str = "Channel Commander"; 
        break;
        
        case "2" : 
        $str = "Requests Voice";
        break;
        
        case "3" : 
        $str = "Requests Voice<br>Channel Commander";
        break;
        
        case "4" : 
        $str = "Doesnt Accept Whispers";
        break;
        
        case "5" : 
        $str = "Does not accept whispers<br>Channel Commander";
        break;
        
        case "6" : 
        $str = "Requests Voice<br>Does not accept whispers";
        break;
        
        case "7" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Channel Commander";
        break;
        
        case "8" : 
        $str = "Player is away";
        break;
        
        case "9" : 
        $str = "Player is away<br>Channel Commander";
        break;
        
        case "10" : 
        $str = "Requests Voice<br>Player is away";
        break;
        
        case "11" : 
        $str = "Requests Voice<br>Player is away<br>Channel Commander";
        break;
        
        case "12" : 
        $str = "Does not accept whispers<br>Player is away";
        break;
        
        case "13" : 
        $str = "Does not accept whispers<br>Player is away<br>Channel Commander";
        break;
        
        case "14" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Player is away";
        break;
        
        case "15" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Player is away<br>Channel Commander";
        break;  
        
        case "16" : 
        $str = "Microphone Muted";
        break;
        
        case "17" : 
        $str = "Microphone Muted<br>Channel Commander";
        break;
        
        case "18" : 
        $str = "Requests Voice<br>Microphone muted";
        break;
        
        case "19" : 
        $str = "Requests Voice<br>Microphone muted<br>Channel Commander";
        break;
        
        case "20" : 
        $str = "Does not accept whispers<br>Microphone muted";
        break;
        
        case "21" : 
        $str = "Does not accept whispers<br>Microphone Muted<br>Channel Commander";
        break;
        
        case "22" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Microphone muted";
        break;
        
        case "23" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Microphone muted<br>Channel Commander";
        break;
        
        case "24" : 
        $str = "Player is away<br>Microphone Muted";
        break;
        
        case "25" : 
        $str = "Player is away<br>Microphone Muted<br>Channel Commander";
        break;
        
        case "26" : 
        $str = "Requests Voice<br>Player is away<br>Microphone muted";
        break;
        
        case "27" : 
        $str = "Requests Voice<br>Player is away<br>Microphone muted<br>Channel Commander";
        break;
        
        case "28" : 
        $str = "Does not accept whispers<br>Player is away<br>Microphone Muted";
        break;
        
        case "29" : 
        $str = "Does not accept whispers<br>Player is away<br>Microphone Muted<br>Channel Commander";
        break;
        
        case "30" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Player is away<br>Microphone muted";
        break;
        
        case "31" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Player is away<br>Microphone muted<br>Channel Commander";
        break;
        
        case "32" : 
        $str = "Speaker/Headphone muted";
        break;
        
        case "33" : 
        $str = "Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "34" : 
        $str = "Requests Voice<br>Speaker/Headphone muted";
        break;
        
        case "35" : 
        $str = "Requests Voice<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "36" : 
        $str = "Does not accept whispers<br>Speaker/Headphone muted";
        break;
        
        case "37" : 
        $str = "Does not accept whispers<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "38" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Speaker/Headphone muted";
        break;
        
        case "39" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "40" : 
        $str = "Player is away<br>Speaker/Headphone muted";
        break;
        
        case "41" : 
        $str = "Player is away<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "42" : 
        $str = "Requests Voice<br>Player is away<br>Speaker/Headphone muted";
        break;
        
        case "43" : 
        $str = "Requests Voice<br>Player is away<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "44" : 
        $str = "Does not accept whispers<br>Player is away<br>Speaker/Headphone muted";
        break;
        
        case "45" : 
        $str = "Does not accept whispers<br>Player is away<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "46" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Player is away<br>Speaker/Headphone muted";
        break;
        
        case "47" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Player is away<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "48" : 
        $str = "Microphone muted<br>Speaker/Headphone muted";
        break;
        
        case "49" : 
        $str = "Microphone muted<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "50" : 
        $str = "Requests Voice<br>Microphone muted<br>Speaker/Headphone muted";
        break;
        
        case "51" : 
        $str = "Requests Voice<br>Microphone muted<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "52" : 
        $str = "Does not accept whispers<br>Microphone muted<br>Speaker/Headphone muted";
        break;
        
        case "53" : 
        $str = "Does not accept whispers<br>Microphone muted<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "54" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Microphone muted<br>Speaker/Headphone muted";
        break;
        
        case "55" : 
        $str = "Requests Voice<br>Does not accept whispers<br>Microphone muted<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "56" : 
        $str = "Player is away<br>Microphone muted<br>Speaker/Headphone muted";
        break;
        
        case "57" : 
        $str = "Player is away<br>Microphone muted<br>Speaker/Headphone muted<br>Channel Commander";
        break;
        
        case "58" : 
        $str = "Requests Voice<br>Player is away<br>Microphone muted<br>Speaker/Headphone muted";
        break;
        
        case "59" : 
        $str = "Requests Voice<br>Player is away<br>Microphone muted<br>Speaker/Headphone muted<br>Channel Commander";
        break;      
        
        case "60" : 
        $str = "Does not accept whispers<br>Player is away<br>Microphone muted<br>Speaker/Headphone muted<br>Microphone muted";
        break;
        
        case "61" : 
        $str = "Does not accept whispers<br>Player is away<br>Microphone muted<br>Speaker/Headphone muted<br>Microphone muted<br>Channel Commander";
        break;
        
        default :
        $str = "None";
        break;
    }
             
    return $str;        
}
?>