<?php
/************************************************************************/
#  TeamSpeak Block For PHP-NUKE: Web Portal System Ver 1.2
#  ===============================================
# 
#  Copyright (c) 2004 by **CloseUp**|Ds|
#  http://darkknights.dk
#  I have only made this script with Cut & Paste from many other scripts
# 
# modified by: Tsuchida, Butcher and PrideKillersInc =PKI=
# http://www.PrideKillersInc.com
# January 2005
# - Fixes:
#   1) Combined operability from two blocks allowing user to log into a non-secure TS server by clicking onto the channel name and to log into a secure server by using the pulldown menu.
#   2) Changed standard green bullet to blinking green bullet.
#   3) Sorted main and sub channels by Sort Order (setting in TeamSpeak under "Edit Channel")
#   4) Sorted main and sub channels alphabeticly if they have the same Sort Order (setting in TeamSpeak under "Edit Channel")
#   5) Config flag for displaying the pulldown menu. Set $DisplayPullDown to 0 to remove the pulldown menu from the block display
#
# modified by: Tsuchida, Butcher and PrideKillersInc =PKI=
# http://www.PrideKillersInc.com
# Febuary 2005
# - Fixes:
#   1) Added icons for user status. Now you cna tell when users are AFK, muted, etc.
#   2) Added ability for admin to block anyone logging in anonymously.
#   3) Added ability for user to log in with a name other than the one they are logged into the website with.
#
/************************************************************************/

if (eregi("block-TeamSpeak_nuke.php",$_SERVER['PHP_SELF'])) {
    Header("Location: index.php");
    die();
}

include_once ('blocks/TSFunction.php');

// retrieve server info
require ("TSInfo.php");
$tss2info->getInfo();
$tss2info->userName="Guest";
$serverAddress = "xxx.xxx.xxx.xxx"; // TeamSpeak IP, don't use localhost here
$serverUDPPort = "8767"; // default 8767

// This flag determins if the pulldown menu is displayed in the block. Set it to a 0 if you do not want the menu displayed.
$DisplayPullDown = 1;

// This flag determines if the user can log into the TS server is he/she is not logged into the website
$NoAnonLogIn = 1;

// Don't edit below unless you know what you are messing with
$serverAddress2 = "$serverAddress:$serverUDPPort";

$content .= "<br><center><a href=http://www.teamspeaktalk.com/index.php target=\"_blank\"><img src=modules/Teamspeak/webpost/images/TSBanner01.gif border=\"0\" alt=\"Provided by the bastards at PrideKillersInc\"></a></center>";
$content .= "<br>\n";

// Get Nuke UserName
global $user, $cookie, $user_prefix;
    cookiedecode($user);
    $username = $cookie[1];
     $sql = "SELECT user_id FROM $user_prefix"._users." WHERE username='$username'";

$ChannelOrder  = array();
$SubChannelOrder = array();
$usedArrayMenu  = array();
$usedArray  = array();
$counter = 0;

usort ($tss2info->channelList, "compare");

foreach($tss2info->channelList as $channelInfo) {
    $ChannelOrder[$counter] = $channelInfo[order];
    $counter++;
  }
sort($ChannelOrder);
$OrderCounter = 0;

if ($DisplayPullDown == 1)
{
// Create drop down for login
$content .= "<center>Channel Selection</center><br>\n";
$content .= "<!-----  drop down ----->\n";
$content .= "<TABLE BORDER=0 align=center target=_blank CELLPADDING=0 CELLSPACING=0>\n";
$content .= "<TR><FORM METHOD=GET ACTION=\"modules.php\">\n";
$content .= "<select name=\"select15\" onChange=\"window.open(this.options[this.selectedIndex].value,'_blank','height=300 width=225')\">";
$content .= "<OPTION VALUE=\"http://www.PrideKillersInc.com\">Channels";

for($ChannelCount=0;$ChannelCount<count($tss2info->channelList);$ChannelCount++)
{
  foreach($tss2info->channelList as $channelInfo) {
    $channelname = $channelInfo[channelname];

    // determine codec (verbose)
    $codec = $tss2info->getVerboseCodec($channelInfo[codec]);

    if ($channelInfo[channelid] !="id")
    {
      if ($channelInfo[order] == $ChannelOrder[$ChannelCount] and $channelInfo[parent] == -1 and usedID($usedArrayMenu ,$channelInfo[channelid]))
      {
        $content .= "<OPTION VALUE=\"modules/Teamspeak/webpost/login.php?nickname=$username&detail=1&channel=$channelname\">$channelname\n";
        $usedArrayMenu [count($usedArrayMenu )] = $channelInfo[channelid];

        //find and sort the sub channels with the same parent id as the main channel id
        $subchannelid = $channelInfo[channelid];
        $subcounter = 0;
        $SubChannelOrder = array();
        foreach($tss2info->channelList as $subchannelInfo) {
          if ($subchannelInfo[parent] == $subchannelid) {
            $SubChannelOrder[$subcounter] = $subchannelInfo[order];
            $subcounter++;
          }
        }
        sort($SubChannelOrder);
        $SubOrderCounter = 0;

        for($j=0;$j<count($SubChannelOrder);$j++) {
          foreach($tss2info->channelList as $subchannelInfo) {
            $subchannelname = $subchannelInfo[channelname];
            if ($subchannelInfo[channelid] !="id")
            {
              if ($subchannelInfo[parent] == $subchannelid and $subchannelInfo[order] == $SubChannelOrder[$j] and usedID($usedArrayMenu ,$subchannelInfo[channelid])) {
                $content .= "<OPTION VALUE=\"modules/Teamspeak/webpost/login.php?nickname=$username&detail=1&channel=$subchannelname\">-$subchannelname\n";
                $usedArrayMenu [count($usedArrayMenu )] = $subchannelInfo[channelid];
              }
            }
          }
        }
      }
    }
  }
  $counter++;
}

$content .= "</SELECT></TD></TR></FORM></TABLE>";
}

$content .= "<br>\n";

// display channel list
$content .= "<table aalign=\"center\" width=\"100%\">\n"; 
$counter = 0;

for($ChannelCount=0;$ChannelCount<count($tss2info->channelList);$ChannelCount++)
{
  foreach($tss2info->channelList as $channelInfo) {
    $channelname = $channelInfo[channelname];

    // determine codec (verbose)
    $codec = $tss2info->getVerboseCodec($channelInfo[codec]);

    // default?
    if($channelInfo[isdefault] == "1")  $isDefault = "yes"; else $isDefault = "no";

    if ($channelInfo[channelid] !="id")
    {
      if ($channelInfo[order] == $ChannelOrder[$ChannelCount] and $channelInfo[parent] == -1 and usedID($usedArray,$channelInfo[channelid]))
      {
        if ($username != "" or $NoAnonLogIn == 0)
           $content .= ("<tr><td><img src=\"modules/Teamspeak/webpost/images/bullet_channel.gif\" align=absmiddle alt=MAX&nbsp;".$channelInfo[maxplayers]."&nbsp;Players><I><a href=\"teamspeak://".$serverAddress.":".$serverUDPPort."/nickname=".$username."?loginname=?password=?channel=".$channelname."?channelpassword=\">".$channelname."</a></I></td></tr>\n");
        else
           $content .= ("<tr><td><img src=\"modules/Teamspeak/webpost/images/bullet_channel.gif\" align=absmiddle alt=MAX&nbsp;".$channelInfo[maxplayers]."&nbsp;Players><I>".$channelname."</I></td></tr>\n");

        $counter_player = 0;
        foreach($tss2info->playerList as $playerInfo) {
          if ($playerInfo[channelid] == $channelInfo[channelid]) {
            $content .=("<tr><td>&nbsp;&nbsp;".setUserStatus($playerInfo[d5])." alt=$playerInfo[playername] align=absmiddle>&nbsp;".$playerInfo[playername]."</td></tr>\n");
            $counter_player++;
         }
       }
       $usedArray[count($usedArray)] = $channelInfo[channelid];

        //find and sort the sub channels with the same parent id as the main channel id
        $subchannelid = $channelInfo[channelid];
        $subcounter = 0;
        $SubChannelOrder = array();
        foreach($tss2info->channelList as $subchannelInfo) {
          if ($subchannelInfo[parent] == $subchannelid) {
            $SubChannelOrder[$subcounter] = $subchannelInfo[order];
            $subcounter++;
          }
        }
        sort($SubChannelOrder);
        $SubOrderCounter = 0;

        for($j=0;$j<count($SubChannelOrder);$j++) {
          foreach($tss2info->channelList as $subchannelInfo) {
            $subchannelname = $subchannelInfo[channelname];
            if ($subchannelInfo[channelid] !="id")
            {
//              if ($subchannelInfo[parent] == $subchannelid) {
              if ($subchannelInfo[parent] == $subchannelid and $subchannelInfo[order] == $SubChannelOrder[$j] and usedID($usedArray ,$subchannelInfo[channelid])) {
                $content .= ("<tr><td><img src=\"modules/Teamspeak/webpost/images/bullet_sub.gif\"><img src=\"modules/Teamspeak/webpost/images/bullet_channel.gif\" align=absmiddle alt=MAX&nbsp;".$subchannelInfo[maxplayers]."&nbsp;Players><I><a href=\"teamspeak://".$serverAddress.":".$serverUDPPort."/nickname=".$username."?loginname=?password=?channel=".$subchannelInfo[channelname]."?channelpassword=\">".$subchannelInfo[channelname]."</a></I></td></tr>\n");
                $counter_player = 0;
                foreach($tss2info->playerList as $playerInfo) {
                  if ($playerInfo[channelid] == $subchannelInfo[channelid]) {
                    $content .=("<tr><td>&nbsp;&nbsp;<img src=\"modules/Teamspeak/webpost/images/bullet_sub.gif\"><img src=\"modules/Teamspeak/webpost/images/bullet_ts.gif\" alt=$playerInfo[playername] align=absmiddle>&nbsp;".$playerInfo[playername]."</td></tr>\n");
                    $counter_player++;
                  }
                }
                $usedArray[count($usedArray)] = $subchannelInfo[channelid];
              }
            }
          }
        }
        if($counter_player == 0) $content .= ("<tr><td></td></tr>\n");
      }
    }
  }
  $counter++;
}

/*
foreach($tss2info->channelList as $channelInfo) {
  $channelname = $channelInfo[channelname];

  // determine codec (verbose)
  $codec = $tss2info->getVerboseCodec($channelInfo[codec]);

  // default?
  if($channelInfo[isdefault] == "1")  $isDefault = "yes"; else $isDefault = "no";

  if ($channelInfo[channelid] != "id") {
    if($channelInfo[parent] == -1)
    {
    $content .= ("<tr><td><img src=\"webpost/images/bullet_channel.gif\" align=absmiddle alt=MAX&nbsp;".$channelInfo[maxplayers]."&nbsp;Players><I><a href=\"teamspeak://".$serverAddress.":".$serverUDPPort."/nickname=".$username."?loginname=?password=?channel=".$channelname."?channelpassword=\">".$channelname."</a></I></td></tr>\n");

//    $content .= ("<br>channel ID: ".$channelInfo[channelid]." parent ".$channelInfo[parent]." d1 ".$channelInfo[order]." d2 ".$channelInfo[d2]." d3".$channelInfo[d3]."<br>"); //VTB Test

    $counter_player = 0;
    foreach($tss2info->playerList as $playerInfo) {
      if ($playerInfo[channelid] == $channelInfo[channelid]) {
        $content .=("<tr><td>&nbsp;&nbsp;<img src=\"webpost/images/bullet_ts.gif\" alt=$playerInfo[playername] align=absmiddle>&nbsp;".$playerInfo[playername]."</td></tr>\n");
        $counter_player++;
      }
    }

    $current_channel = $channelInfo[channelid];
    if ($current_channel != -1)
    {
    foreach($tss2info->channelList as $subchannelInfo) {
      $subchannelname = $subchannelInfo[channelname];

      // determine codec (verbose)
      $subcodec = $tss2info->getVerboseCodec($subchannelInfo[codec]);
      if ($subchannelInfo[parent] == $current_channel) {
         $content .= ("<tr><td><img src=\"webpost/images/bullet_sub.gif\"><img src=\"webpost/images/bullet_channel.gif\" align=absmiddle alt=MAX&nbsp;".$subchannelInfo[maxplayers]."&nbsp;Players><I><a href=\"teamspeak://".$serverAddress.":".$serverUDPPort."/nickname=".$username."?loginname=?password=?channel=".$subchannelInfo[channelname]."?channelpassword=\">".$subchannelInfo[channelname]."</a></I></td></tr>\n");
         $counter_player = 0;
         foreach($tss2info->playerList as $playerInfo) {
           if ($playerInfo[channelid] == $subchannelInfo[channelid]) {
             $content .=("<tr><td>&nbsp;&nbsp;<img src=\"webpost/images/bullet_sub.gif\"><img src=\"webpost/images/bullet_ts.gif\" alt=$playerInfo[playername] align=absmiddle>&nbsp;".$playerInfo[playername]."</td></tr>\n");
             $counter_player++;
           }
        }
      }
    }
    }
    }
    if($counter_player == 0) $content .= ("<tr><td></td></tr>\n");
  }
  $counter++;
}// end foreach
*/

if ($counter == 0) $content .= ("<tr><td colspan=\"7\" align=\"CENTER\">Offline</td></tr>\n");
$content .= ("</table>\n</div>\n");
//$content .= "<br><center><a href=http://www.goteamspeak.com target=\"_blank\"><img src=http://www.PrideKillersInc.com/webpost/images/ngz.gif border=\"0\" alt=\"Download TeamSpeak\"></a></center>";
//Copyright Please don't remove with out my approval
$content .= ("<br><center><a href=\"http://www.PrideKillersInc.com\" target=\"_blank\">&copy; PrideKillersInc</a></center>");
?>