<?php
/***************************************************************************
*     begin                : Thu Oct 30, 2003
*     copyright            : (C) 2003 Pokemaster
*     email                : aaronboffin@hotmail.com
*
****************************************************************************/

/***************************************************************************
 * PHP-Nuke Platinum: Expect to be impressed                      COPYRIGHT
 *
 * Copyright (c) 2004 - 2006 by http://www.techgfx.com
 *     Techgfx - Graeme Allan                       (goose@techgfx.com)
 *
 * Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de
 *     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de)
 *
 * Refer to TechGFX.com for detailed information on PHP-Nuke Platinum
 *
 * TechGFX: Your dreams, our imagination
 ***************************************************************************/

define('IN_PHPBB', 1);

//
// First we do the setmodules stuff for the admin cp.
//
if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['Reports']['Settings'] = $filename;

	return;
}

//
// Load default header
//
$no_page_header = TRUE;
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_report.' . $phpEx);

$sql = "SELECT *
	FROM " . REPORT_CONFIG;
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query config information in admin_report", "", __LINE__, __FILE__, $sql);
}
else
{
	while( $set = $db->sql_fetchrow($result) )
	{
		$config_name = $set['name'];
		$config_value = $set['value'];
		$default_config[$config_name] = isset($HTTP_POST_VARS['submit']) ? str_replace("'", "\'", $config_value) : $config_value;

		$new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];

		if( isset($HTTP_POST_VARS['submit']) )
		{
			$sql = "UPDATE " . REPORT_CONFIG . " SET
				value = '" . str_replace("\'", "''", $new[$config_name]) . "'
				WHERE name = '$config_name'";
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Failed to update value for $config_name", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['submit']) )
	{
		$message = $lang['Config_updated'] . "<br /><br />" . sprintf($lang['Click_return_config'], "<a href=\"" . append_sid("admin_report.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
}

include('./page_header_admin.'.$phpEx);

//
// Output the authorisation details
//
$template->set_filenames(array(
	'body' => 'admin/report_body.tpl'
	)
);

$template->assign_vars(array(
	"S_CONFIG_ACTION" => append_sid("admin_report.$phpEx"),
    'L_TITLE' => $lang['report_title'],
    'L_EXPLAIN' => $lang['report_explain'],

    'COLOR0' => $new['color_0'],
    'COLOR1' => $new['color_1'],
    
    'L_COLOR_SET' => $lang['report_color_set'],
    'L_COLOR0' => $lang['report_color_0'],
    'L_COLOR1' => $lang['report_color_1'],
    
	"L_SUBMIT" => $lang['Submit'],
	"L_RESET" => $lang['Reset']
    )
);

$template->pparse('body');

include('./page_footer_admin.'.$phpEx);

?>
