<?php
/***************************************************************************
 *                            ranks.php
 *                            ---------
 *   begin                : 30/04/03
 *   copyright            : Ptirhiik
 *   email                : Ptirhiik@rpgnet-fr.com
 *
 ***************************************************************************/

/***************************************************************************
 * PHP-Nuke Platinum: Expect to be impressed                      COPYRIGHT
 *
 * Copyright (c) 2004 - 2006 by http://www.techgfx.com
 *     Techgfx - Graeme Allan                       (goose@techgfx.com)
 *
 * Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de
 *     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de)
 *
 * Refer to TechGFX.com for detailed information on PHP-Nuke Platinum
 *
 * TechGFX: Your dreams, our imagination
 ***************************************************************************/

if (!stristr($_SERVER['SCRIPT_NAME'], "modules.php")) {
    die ("You can't access this file directly...");
}

if ($popup != "1")
    {
	$module_name = basename(dirname(__FILE__));
	require("modules/".$module_name."/nukebb.php");
    }
    else
    {
	$phpbb_root_path = 'modules/Forums/';
    }
define('IN_PHPBB', true);
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX, $nukeuser);
init_userprefs($userdata);

//
// special ranks
$spe_ranks = array();
$sql = "SELECT * FROM " . RANKS_TABLE . " WHERE rank_special = 1 ORDER BY rank_title";
if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Couldn\'t read special ranks', '', __LINE__, __FILE__, $sql);
while ($row = $db->sql_fetchrow($result) ) $spe_ranks[] = $row;
for ($i=0; $i < count($spe_ranks); $i++ )
{
	$rank = $spe_ranks[$i]['rank_id'];
	$spe_ranks[$i]['users_list'] = '';
	$sql = "SELECT * FROM " . USERS_TABLE . " WHERE user_active = 1 AND user_rank = $rank ORDER BY username";
	if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Couldn\'t read users', '', __LINE__, __FILE__, $sql);
	while ( $row = $db->sql_fetchrow($result) )
	{
		$spe_ranks[$i]['users_list'] .= ($spe_ranks[$i]['users_list'] == '') ? '' : ', ';
		$spe_ranks[$i]['users_list'] .= '<a href="' . append_sid("profile.$phpEx?" . POST_USERS_URL . "=" . $row['user_id'] ) . '" class="gensmall">' . $row['username'] . '</a>';
	}
}

//
// standard ranks
$ranks = array();
$sql = "SELECT * FROM " . RANKS_TABLE . " WHERE rank_special <> 1 ORDER BY rank_min";
if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Couldn\'t read standard ranks', '', __LINE__, __FILE__, $sql);
while ($row = $db->sql_fetchrow($result) ) $ranks[] = $row;

$rank_max = 99999999;
for ($i=count($ranks)-1; $i >=0; $i--)
{
	$ranks[$i]['rank_max'] = $rank_max;
	$rank_min = $ranks[$i]['rank_min'];
	
	// count users
	$sql = "SELECT * FROM " . USERS_TABLE . " WHERE user_active = 1 AND user_rank = 0 AND user_posts >= $rank_min" . (($rank_max < 99999999)  ? " AND user_posts < $rank_max" : "" );
	if ( !($result = $db->sql_query($sql)) ) message_die(GENERAL_ERROR, 'Couldn\'t read users', '', __LINE__, __FILE__, $sql);
	$ranks[$i]['user_number'] = $db->sql_numrows($result);

	// store the next limit
	$rank_max = $ranks[$i]['rank_min'];
}

//
// set the page title and include the page header
//
$page_title = $lang['Ranks'];
include ('includes/page_header.'.$phpEx);
//
// template setting
//
$template->set_filenames(array(
	'body' => 'ranks_body.tpl')
);

// constants
$template->assign_vars(array(
	'L_SPECIAL_RANKS' => $lang['Special_ranks'],
	'L_USERS_LIST' => $lang['Memberlist'],
	'L_RANKS' => $lang['Ranks'],
	'L_MINI' => $lang['Rank_minimum'],
	'L_TOTAL_USERS' => $lang['Total_users'],
	'S_HIDDEN_FIELDS' => '',
	)
);

// special ranks
for ($i=0; $i < count($spe_ranks); $i++)
{
	$template->assign_block_vars('spe_ranks', array(
		'RANK_TITLE' => $spe_ranks[$i]['rank_title'],
		'RANK_IMAGE' => ($spe_ranks[$i]['rank_image'] == '') ? '' : '<img src="' . $spe_ranks[$i]['rank_image'] . '" border=0 align="center">',
		'USERS_LIST' => $spe_ranks[$i]['users_list'],
		)
	);
}

// standard ranks
for ($i=0; $i < count($ranks); $i++)
{
	$template->assign_block_vars('ranks', array(
		'RANK_TITLE' => $ranks[$i]['rank_title'],
		'RANK_IMAGE' => ($ranks[$i]['rank_image'] == '') ? '' : '<img src="' . $ranks[$i]['rank_image'] . '" border=0 align="center">',
		'RANK_MINI'  => $ranks[$i]['rank_min'],
		'RANK_TOTAL' => $ranks[$i]['user_number'],
		)
	);
}

//
// page footer
//
$template->pparse('body');
include('includes/page_tail.'.$phpEx);

?>
