<?php 

/***************************************************************************
 * PHP-Nuke Platinum: Expect to be impressed                      COPYRIGHT
 *
 * Copyright (c) 2004 - 2006 by http://www.techgfx.com
 *     Techgfx - Graeme Allan                       (goose@techgfx.com)
 *
 * Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de
 *     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de)
 *
 * Refer to TechGFX.com for detailed information on PHP-Nuke Platinum
 *
 * TechGFX: Your dreams, our imagination
 ***************************************************************************/

// standard hack prevent 
if (!stristr($_SERVER['SCRIPT_NAME'], "modules.php")) {
    die ("You can't access this file directly...");
}

if ($popup != "1"){
    $module_name = basename(dirname(__FILE__));
    require("modules/".$module_name."/nukebb.php");
}
else
{
    $phpbb_root_path = 'modules/Forums/';
}
define('IN_PHPBB', true);

include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_report.' . $phpEx);

// standard session management 
$userdata = session_pagestart($user_ip, PAGE_INDEX, $nukeuser);
init_userprefs($userdata); 

// set page title 
$page_title = $lang['report_page_title'];

// standard page header 
include('includes/page_header.'.$phpEx); 

// Settings:
$set = array();
$sql = "SELECT *
	FROM " . REPORT_CONFIG;
if( !($result = $db->sql_query($sql)) )
{
	message_die(CRITICAL_ERROR, "Could not query config information", "", __LINE__, __FILE__, $sql);
}

while ( $row = $db->sql_fetchrow($result) )
{
	$set[$row['name']] = $row['value'];
}

// Parameter
$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
$submit = ( isset($HTTP_POST_VARS['submit']) ) ? TRUE : 0;
$message = ( isset($HTTP_POST_VARS['message']) ) ? $HTTP_POST_VARS['message'] : $HTTP_GET_VARS['message'];
$info = ( isset($HTTP_POST_VARS['info']) ) ? $HTTP_POST_VARS['info'] : $HTTP_GET_VARS['info'];
$post = ( isset($HTTP_POST_VARS['post']) ) ? $HTTP_POST_VARS['post'] : $HTTP_GET_VARS['post'];
$id = ( isset($HTTP_POST_VARS['id']) ) ? $HTTP_POST_VARS['id'] : $HTTP_GET_VARS['id'];

$index = sprintf( $lang['report_index'], '<a href="' . append_sid('index.php') . '">', '</a>' );
$report_list = sprintf( $lang['report_list'], '<a href="' . append_sid('report.php') . '">', '</a>' );

if ( $userdata['user_id'] == ANONYMOUS )
{
    redirect(append_sid("login.$phpEx"));
}

if ( $userdata['user_level'] != 0 && $mode == '' && $userdata['user_id'] != ANONYMOUS )
{
    // assign template
    $template->set_filenames(array(
        'body' => 'report_list_body.tpl')
    );
    $template->assign_vars(array(
        'L_STATUS' => $lang['report_stat'],
        'L_INFO' => $lang['report_info'],
        'L_TEXT' => $lang['report_text'],
        'L_DATE' => $lang['report_date'],
        'L_USERNAME' => $lang['report_username'],
        'L_DELETE' => $lang['report_delete'],
        'L_NO_RESULTS' => $lang['report_no_results'],

        'T_NOT_FINISHED' => $set['color_0'],
        'T_FINISHED' => $set['color_1'])
    );
    
    // cat_Row
    $sql = "SELECT cat_id, cat_name FROM " . REPORT_CAT . " ORDER BY cat_id";
	if( !($cat_result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not query cats', '', __LINE__, __FILE__, $sql);
    }
    if ( $cat = $db->sql_fetchrow($cat_result) )
    {
        do
        {
            $template->assign_block_vars('catrow', array(
                'NAME' => $cat['cat_name'])
            );
            // Report_Row
            $sql = "SELECT * FROM " . REPORTS . " WHERE report_type = " . $cat['cat_id'] . " ORDER BY report_id";
	        if( !($report_result = $db->sql_query($sql)) )
            {
	           message_die(GENERAL_ERROR, 'Could not query reports', '', __LINE__, __FILE__, $sql);
            }
            if ($db->sql_numrows($report_result) == 0)
            {
                $template->assign_block_vars('catrow.switch_no_results', array());
            }
            if ( $report = $db->sql_fetchrow($report_result) )
            {
                do
	            {
                    $report_id = $report['report_id'];
                    $report_date = $report['report_date'];
                    $report_text = $report['text'];
                    if ( $report['report_status'] == 0)
                    {
                        $report_status = '<a href="modules.php?name=Forums&file=report&mode=notfinished&id=' . $report_id . '" class="notfinished"><b>' . $lang['report_stat_0'] . '</b></a>';
//										   
                    }
                    else
                    {
                        $report_status = '<a href="modules.php?name=Forums&file=report&mode=finished&id=' . $report_id . '" class="finished"><b>' . $lang['report_stat_1'] . '</b></a>';
                    }
                    if ( $report['report_type'] == 1 )
                    {
                        $report_info = '<a href="' . append_sid("viewtopic.php?p=" . $report['report_info']) . '">' . $lang['Post'] . ' #' . $report['report_info'] . '</a>';
                    }
                    else
                    {
                        $report_info = $report['report_info'];
                    }

                    $user_id = $report['report_user_id'];
                    $sql = "SELECT username
	                    FROM " . USERS_TABLE . "
                        WHERE user_id = $user_id";
	                if( !($user_result = $db->sql_query($sql)) )
                    {
	                   message_die(GENERAL_ERROR, 'Could not get userdata', '', __LINE__, __FILE__, $sql);
                    }
                    if ( $user = $db->sql_fetchrow($user_result) )
                    {
                        $user_name = $user['username'];
                    }

                    $template->assign_block_vars('catrow.reportrow', array(
                        'ID' => $report_id,
                        'STATUS' => $report_status,
                        'DATE' => create_date($board_config['default_dateformat'], $report_date, $board_config['board_timezone']),
                        'INFO' => $report_info,
                        'TEXT' => $report_text,
                        'USERNAME' => $user_name,
                        'USERLINK' => append_sid("profile.$phpEx?mode=viewprofile&amp;u=$user_id"),
                        'DELETE' => append_sid("modules.php?name=Forums&file=report&mode=delete&id=$report_id"))
                    );
                }
                while ( $report = $db->sql_fetchrow($report_result) );
                $db->sql_freeresult($report_result);
            }
        }
        while ( $cat = $db->sql_fetchrow($cat_result) );
        $db->sql_freeresult($cat_result);
    }
}
else if ( $mode == 'delete' && $id != '' && $userdata['user_id'] != ANONYMOUS && $userdata['user_level'] != 0 )
{
    $sql  = "DELETE FROM " . REPORTS . " WHERE report_id = $id";
    if( !($result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not delete report', '', __LINE__, __FILE__, $sql);
    } else
    {
        message_die(GENERAL_MESSAGE, $lang['report_deleted'] . $report_list . $index, 'Information');
    }
}
else if ( $mode == 'finished' && $id != '' && $userdata['user_id'] != ANONYMOUS && $userdata['user_level'] != 0 )
{
    $sql = "UPDATE " . REPORTS . " SET report_status = 0 WHERE report_id = $id";
    if( !($result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not delete report', '', __LINE__, __FILE__, $sql);
    } else
    {
        message_die(GENERAL_MESSAGE, $lang['report_not_finished'] . $report_list . $index, 'Information');
    }
}
else if ( $mode == 'notfinished' && $id != '' && $userdata['user_id'] != ANONYMOUS && $userdata['user_level'] != 0 )
{
    $sql = "UPDATE " . REPORTS . " SET report_status = 1 WHERE report_id = $id";
    if( !($result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not delete report', '', __LINE__, __FILE__, $sql);
    } else
    {
        $msg = sprintf( $lang['report_finished'], '<a href="' . append_sid("report.php") . '">', '</a>' );
        $msg = sprintf( $msg, '<a href="' .  append_sid("index.php") . '">', '</a>' );
        message_die(GENERAL_MESSAGE, $lang['report_finished'] . $report_list . $index, 'Information');
    }
}
else if ( $mode == 'finish' && $post != '' && $userdata['user_id'] != ANONYMOUS && $userdata['user_level'] != 0 )
{
    $sql = "UPDATE " . REPORTS . " SET report_status = 1 WHERE report_info = $post";
    if( !($result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not delete report', '', __LINE__, __FILE__, $sql);
    }
    else
    {
        $msg = sprintf($lang['report_finish'], '<a href="' . append_sid('viewtopic.php?p=' . $post) . '">', '</a>');
        message_die(GENERAL_MESSAGE, $msg, 'Information');
    }
}
else if ( $mode != '' && $userdata['user_id'] != ANONYMOUS )
{
    // assign template
    $template->set_filenames(array(
        'body' => 'report_body.tpl')
    );
    // cat_Row
    $sql = "SELECT * FROM " . REPORT_CAT . " WHERE cat_param = '$mode'";
	if( !($cat_result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not query cats', '', __LINE__, __FILE__, $sql);
    }
    if ($db->sql_numrows($cat_result) == 0)
    {
        message_die(GENERAL_MESSAGE, $lang['report_auth'], 'Information');
    }
    if ( $cat = $db->sql_fetchrow($cat_result) )
    {
        if ( $mode == 'reportpost' )
        {
            $template->assign_block_vars('switch_report_post_on', array());
        } else
        {
            $template->assign_block_vars('switch_report_post_off', array());
        }
        do
        {
            if ( $mode == 'reportpost' )
            {
                $hidden_fields = '<input type="hidden" name="mode" value="reportpost" /><input type="hidden" name="post" value="' . $post . '" />';
                $info_show = '<a href="' . append_sid("viewtopic.php?p=" . $post) . '">' . $lang['Post'] . ' #' . $post . '</a>';
                $info = $post;
                $type = 1;
                if ( $post == '' )
                {
                    message_die(GENERAL_MESSAGE, $lang['report_auth'], 'Information');
                }
                
                $sql = "SELECT * FROM " . REPORTS . " WHERE report_type = 1 AND report_info = $post";
                if( !($result = $db->sql_query($sql)) )
                {
	                message_die(GENERAL_ERROR, 'Could not query report', '', __LINE__, __FILE__, $sql);
                }
                if ($db->sql_numrows($result) != 0)
                {
                    message_die(GENERAL_MESSAGE, $lang['report_not_send'], 'Information');
                }
                $title = $lang['report_Report_post'];
            }
            else
            {
                $hidden_fields = '<input type="hidden" name="mode" value="' . $cat['cat_param'] . '" />';
                $type = $cat['cat_id'];
                $title = $cat['cat_name'];
            }
    
            $template->assign_vars(array(
                'S_ACTION' => append_sid("report.php"),
                'S_HIDDEN_FORM_FIELDS' => $hidden_fields,
        
                'L_TITLE' => $title,
                'L_EXPLAIN' => $cat['cat_explain'],
                'L_DATE' => $lang['report_date'],
                'L_INFO' => $lang['report_info'],
                'L_USER' => $lang['report_username'],
                'L_SUBMIT' => $lang['Submit'],
        
                'DATE' => create_date($board_config['default_dateformat'], time(), $board_config['board_timezone']),
                'INFO' => $info_show,
                'USERNAME' => $userdata['username'],
                'USERLINK' => append_sid("profile.$phpEx?mode=viewprofile&amp;u=" . $userdata['user_id']))
            );

            if ( $submit )
            {
                // Get ID of new report
                $sql = "SELECT max(report_id) as max_id FROM " . REPORTS;
                if( !($result = $db->sql_query($sql)) )
                {
	               message_die(GENERAL_ERROR, 'Could not query reports', '', __LINE__, __FILE__, $sql);
                }
                if ( $row = $db->sql_fetchrow($result) )
                {
                    $report_id = $row['max_id'] +1;
                    $db->sql_freeresult($result);
                }

                // Get Date
                $date = time();
        
                // Get UserID
                $user_id = $userdata['user_id'];
        
                // Send to DB
                $sql  = "INSERT INTO " . REPORTS . "
                  (report_id, report_type, report_status, report_date, report_user_id, report_info, text)
                  VALUES ($report_id, $type, 0, $date, $user_id, '$info', '$message')";
                if( !($result = $db->sql_query($sql)) )
                {
	               message_die(GENERAL_ERROR, 'Could not query reports', '', __LINE__, __FILE__, $sql);
                } else
                {
                    message_die(GENERAL_MESSAGE, $lang['report_send'] . $index, 'Information');
                }
            }
        }
        while ( $cat = $db->sql_fetchrow($cat_result) );
        $db->sql_freeresult($cat_result);
    }
}
else
{
	message_die(GENERAL_MESSAGE, $lang['report_auth'], 'Information');
}

$template->pparse('body'); 

// standard page footer 
include('includes/page_tail.'.$phpEx); 

?>
