<?php
// ==========================================
// PHP-NUKE: Shout Box
// ==========================
//
// Copyright (c) 2004 by Aric Bolf (SuperCat)
// http://www.OurScripts.net
//
// Copyright (c) 2002 by Quiecom
// http://www.Quiecom.com
//
// This program is free software. You can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation
// ===========================================

if (!stristr($_SERVER['SCRIPT_NAME'], "modules.php")) {
    die ("You can't access this file directly...");
}

$index = 1;

include("config.php");
global $db, $user, $cookie, $prefix, $username;
cookiedecode($user);
$username = $cookie[1];
if ($username == "") { $username = "Anonymous"; }
$sql = "select * from ".$prefix."_shoutbox_conf";
$result = $db->sql_query($sql);
$conf = $db->sql_fetchrow($result);

//do IP test then ban if on list
if($conf[6] == "yes") {
	$sql = "select * from ".$prefix."_shoutbox_ipblock";
	$ipresult = $db->sql_query($sql);
	while ($badips = $db->sql_fetchrow($ipresult)) {
		if($_SERVER['REMOTE_ADDR'] == $badips[1]) {
			$Action = "UserBanned";
		}
	}
}
//do name test then ban if on list (only applies to registered users)
if($conf[7] == "yes") {
	$sql = "select * from ".$prefix."_shoutbox_nameblock";
	$nameresult = $db->sql_query($sql);
	while ($badname = $db->sql_fetchrow($nameresult)) {
		if($username == $badname[1]) {
			$Action = "UserBanned";
		}
	}
}

function searchHistory($where, $sbsearchtext, $results, $style, $timeframe, $order) {
	include("config.php");
	global $db, $user, $cookie, $prefix, $username, $AvatarFound;
	include("header.php");
	$module_name = basename(dirname(__FILE__));
	get_lang($module_name);
	cookiedecode($user);
	$username = $cookie[1];
	if ($username == "") {
		$username = "Anonymous";
	}
	// search form
	OpenTable();
	showSearchBox($sbsearchtext, $where, $style, $results, $timeframe, $order);
	echo "<table cellpadding=\"3\" cellspacing=\"0\" width=\"90%\" border=\"0\" align=\"center\">\n";
	echo "<tr><td align=\"center\"><a href=\"modules.php?name=Shout_Box&amp;page=1\">"._SHOUTHISTORY."</a></td></tr></table>";
	CloseTable();
	echo "<br />";
	// show results
	OpenTable();
	if ($results > 50) { $results = 50; }
	if ($results < 10) { $results = 10; }

	echo "<table cellpadding=\"3\" cellspacing=\"0\" width=\"90%\" border=\"0\" align=\"center\">\n";
	echo "<tr><td align=\"center\"><span class=\"title\">"._SEARCHRESULTS."</span></td></tr>\n";
	//echo "<tr><td><table cellpadding=\"0\" width=\"100%\" cellspacing=\"0\" border=\"0\"><tr><td width=\"50%\" align=\"right\"><img width=\"50\" height=\"39\" src=\"modules/Shout_Box/history.gif\" alt=\"\" /></td><td width=\"50%\" align=\"left\" valign=\"middle\"><span class=\"title\">"._SEARCHRESULTS."</span></td></tr></table></td></tr>\n";
	// build SQL query based on user choices
	//$sql = "select * from ".$prefix."_shoutbox WHERE name='$sbsearchtext' ORDER BY id desc LIMIT $results";
	// search by Nicknames only
	if ($where == 'Nicknames') {
		$SearchArray = explode(" ",$sbsearchtext);
		$c = count($SearchArray);
		$d = 0;
		$sql = "select * from ".$prefix."_shoutbox WHERE name";
		foreach($SearchArray as $SearchPart) {
			$d++;
			if ($style == 'Exact') {
				$sql .= "='".$SearchPart."'";
			} else {
				$sql .= " LIKE '%".$SearchPart."%'";
			}
			if ($d < $c) { $sql .= " OR name"; }
		}
	} elseif ($where == 'Both') {
	// search by Nicknames and Shouts
		if ($style == 'Exact') {
			$sql = "select * from ".$prefix."_shoutbox WHERE name='$sbsearchtext' OR comment='$sbsearchtext'";
		} else {
			$SearchArray = explode(" ",$sbsearchtext);
			$c = count($SearchArray);
			$d = 0;
			$sql = "select * from ".$prefix."_shoutbox WHERE name";
			foreach($SearchArray as $SearchPart) {
				$d++;
				$sql .= " LIKE '%".$SearchPart."%' OR comment LIKE '%".$SearchPart."%'";
				if ($d < $c) { $sql .= " OR name"; }
			}
		}
	} else {
	// search by Shouts only
		if ($style == 'Exact') {
			$sql = "select * from ".$prefix."_shoutbox WHERE comment LIKE '%".$sbsearchtext."%'";
		} else {
			$SearchArray = explode(" ",$sbsearchtext);
			$c = count($SearchArray);
			$d = 0;
			$sql = "select * from ".$prefix."_shoutbox WHERE comment";
			foreach($SearchArray as $SearchPart) {
				$d++;
				$sql .= " LIKE '%".$SearchPart."%'";
				if ($d < $c) { $sql .= " AND comment"; }
			}
		}
	}
	if (($order == '') OR ($order == 'newest')) { $sql .= " ORDER BY id desc"; }
	else { $sql .= " ORDER BY id asc"; }
	$sql .= " LIMIT $results";
	// end building SQL query
	$result = $db->sql_query($sql);
	$numrows = $db->sql_numrows($result);
	if ($numrows > 0) {
		$sqlz = "select * from ".$prefix."_shoutbox_conf";
		$resultz = $db->sql_query($sqlz);
		$conf = $db->sql_fetchrow($resultz);
		$post = 0;
		$loop = 0;
		$flag = 1;

		$ThemeSel = get_theme();
		$sql = "select * from ".$prefix."_shoutbox_themes WHERE themeName='$ThemeSel'";
		$resultT = $db->sql_query($sql);
		$rowColor = $db->sql_fetchrow($resultT);

		while ($row = $db->sql_fetchrow($result)) {
			if ($flag == 1) { $bgcolor = $rowColor[5]; }
			if ($flag == 2) { $bgcolor = $rowColor[6]; }
			$comment = str_replace('src=', 'src="', $row[2]);
			$comment = str_replace('.gif>', '.gif" alt="" />', $comment);
			$comment = str_replace('.jpg>', '.jpg" alt="" />', $comment);
			$comment = str_replace('.png>', '.png" alt="" />', $comment);
			$comment = str_replace('.bmp>', '.bmp" alt="" />', $comment);

			$sqlN = "SELECT * FROM ".$prefix."_users WHERE username='$row[1]'";
			$nameresultN = $db->sql_query($sqlN);
			$rowN = $db->sql_fetchrow($nameresultN);

			// Disallow Anonymous users from seeing links to users' accounts
			if ($username == "Anonymous") {
				if (($rowN[user_avatar]) && ($rowN[user_avatar] != "blank.gif") && ($rowN[user_avatar] != "gallery/blank.gif") && (stristr($rowN[user_avatar],'.') == TRUE)) {
					echo "<tr><td style=\"background-color: $bgcolor;\">";
					echo "<table cellpadding=\"1\" cellspacing=\"0\" width=\"100%\" border=\"0\">";
					echo "<tr><td valign='top' style=\"background-color: $bgcolor;\">";
					$row_avatar = $rowN[user_avatar];
					$av_found = findAvatar($row_avatar);
					echo "$av_found";
					echo "<td valign='top' width='100%' style=\"background-color: $bgcolor;\"><span class=\"content\">";
					echo "<b>$row[1]:</b> $comment<br />";
					if ($conf[3] == "yes") { echo "$row[3]"; }
					if ($conf[4] == "yes") { echo " $row[4]"; }
					echo "</span></td></tr></table>";
					echo "</td></tr>\n";
				} else {
					echo "<tr><td style=\"background-color: $bgcolor;\"><span class=\"content\">";
					echo "<b>$row[1]:</b> $comment<br />";
					if ($conf[3] == "yes") { echo "$row[3]"; }
					if ($conf[4] == "yes") { echo " $row[4]"; }
					echo "</span></td></tr>\n";
				}
			} else {
				// check to see if nickname is a user in the DB and not Anonymous
				if (($rowN) && ($rowN[username] != "Anonymous")) {
					if (($rowN[user_avatar]) && ($rowN[user_avatar] != "blank.gif") && ($rowN[user_avatar] != "gallery/blank.gif") && (stristr($rowN[user_avatar],'.') == TRUE)) {
						echo "<tr><td style=\"background-color: $bgcolor;\">";
						echo "<table cellpadding=\"1\" cellspacing=\"0\" width=\"100%\" border=\"0\">";
						echo "<tr><td valign='top' style=\"background-color: $bgcolor;\">";
						$row_avatar = $rowN[user_avatar];
						$av_found = findAvatar($row_avatar);
						echo "$av_found";
						echo "<td valign='top' width='100%' style=\"background-color: $bgcolor;\"><span class=\"content\"><b><a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;username=$row[1]\">$row[1]</a>:</b> $comment<br />";
						if ($conf[3] == "yes") { echo "$row[3]"; }
						if ($conf[4] == "yes") { echo " $row[4]"; }
						// registered users edit/delete posts
						if (($conf[11] == "yes") && ($username == $row[1])) {
							echo " &#91; <a title=\""._EDIT."\" href=\"modules.php?name=Shout_Box&amp;Action=Edit&amp;shoutID=$row[0]&amp;page=$page\">"._EDIT."</a> | <a title=\""._DELETE."\" href=\"modules.php?name=Shout_Box&amp;Action=Delete&amp;shoutID=$row[0]&amp;page=$page\">"._DELETE."</a> &#93;";
						}
						echo "</span></td></tr></table>";
						echo "</td></tr>\n";
					} else {
						echo "<tr><td style=\"background-color: $bgcolor;\"><span class=\"content\">";
						echo "<b><a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;username=$row[1]\">$row[1]</a>:</b> $comment<br />";
						if ($conf[3] == "yes") { echo "$row[3]"; }
						if ($conf[4] == "yes") { echo " $row[4]"; }
						// registered users edit/delete posts
						if (($conf[11] == "yes") && ($username == $row[1])) {
							echo " &#91; <a title=\""._EDIT."\" href=\"modules.php?name=Shout_Box&amp;Action=Edit&amp;shoutID=$row[0]&amp;page=$page\">"._EDIT."</a> | <a title=\""._DELETE."\" href=\"modules.php?name=Shout_Box&amp;Action=Delete&amp;shoutID=$row[0]&amp;page=$page\">"._DELETE."</a> &#93;";
						}
						echo "</span></td></tr>\n";
					}
				} else {
					echo "<tr><td style=\"background-color: $bgcolor;\"><span class=\"content\">";
					echo "<b>$row[1]:</b> $comment<br />";
					if ($conf[3] == "yes") { echo "$row[3]"; }
					if ($conf[4] == "yes") { echo " $row[4]"; }
					echo "</span></td></tr>\n";
				}
			}
			if ($flag == 1) { $flag = 2; }
			elseif ($flag == 2) { $flag =1; }
		}
	} else {
		echo "<tr><td><table cellpadding=\"3\" cellspacing=\"0\" border=\"1\" align=\"center\">\n";
		echo "<tr><td align=\"center\">"._NORESULTS."</td></tr></table></td></tr>";
	}
	echo "</table>";
	CloseTable();
	include("footer.php");
}

function showSearchBox($sbsearchtext, $where, $style, $results, $timeframe, $order) {
	echo "<form name=\"shoutform3\" method=\"post\" action=\"\" style=\"margin-bottom: 0px;\">\n";
	echo "<table cellpadding=\"3\" cellspacing=\"0\" width=\"95%\" border=\"0\" align=\"center\">\n";
	echo "<tr><td align=\"center\"><span class=\"title\">"._SEARCHBOX."</span></td></tr>\n";
	//echo "<tr><td width=\"50%\" align=\"right\"><img width=\"50\" height=\"39\" src=\"modules/Shout_Box/search.jpg\" alt=\"\" /></td><td width=\"50%\" align=\"left\" valign=\"middle\"><span class=\"title\">"._SEARCHBOX."</span></td></tr>\n";
	echo "<tr><td colspan=\"2\" align=\"center\" nowrap=\"nowrap\" valign=\"middle\">";

	if (($where == 'Shouts') OR ($where == '')) { $wSEL1 = " selected=\"selected\""; } else { $wSEL1 = ""; }
	if ($where == 'Nicknames') { $wSEL2 = " selected=\"selected\""; } else { $wSEL2 = ""; }
	if ($where == 'Both') { $wSEL3 = " selected=\"selected\""; } else { $wSEL3 = ""; }
	echo "<select name=\"where\">
	<option value=\"Shouts\"$wSEL1>"._SHOUTS."</option>
	<option value=\"Nicknames\"$wSEL2>"._SBNICKNAMES."</option>
	<option value=\"Both\"$wSEL3>"._SBBOTH."</option></select>&nbsp;&nbsp;";

	if (($style == 'Any') OR ($style == '')) { $sSEL1 = " selected=\"selected\""; } else { $sSEL1 = ""; }
	if ($style == 'Exact') { $sSEL2 = " selected=\"selected\""; } else { $sSEL2 = ""; }
	echo "<select name=\"style\">
	<option value=\"Any\"$sSEL1>"._FUZZY."</option>
	<option value=\"Exact\"$sSEL2>"._EXACTPHRASE."</option></select>&nbsp;&nbsp;";

	if (($results == 10) OR ($results == '')) { $rSEL10 = " selected=\"selected\""; } else { $rSEL10 = ""; }
	if ($results == 20) { $rSEL20 = " selected=\"selected\""; } else { $rSEL20 = ""; }
	if ($results == 30) { $rSEL30 = " selected=\"selected\""; } else { $rSEL30 = ""; }
	if ($results == 50) { $rSEL50 = " selected=\"selected\""; } else { $rSEL50 = ""; }
	echo "<select name=\"results\">
	<option value=\"10\"$rSEL10>10 "._SBRESULTS."</option>
	<option value=\"20\"$rSEL20>20 "._SBRESULTS."</option>
	<option value=\"30\"$rSEL30>30 "._SBRESULTS."</option>
	<option value=\"50\"$rSEL50>50 "._SBRESULTS."</option></select>&nbsp;&nbsp;";

//	Search by time frame:
// 	if (($timeframe == 0) OR ($timeframe == '')) { $tfSEL0 = " selected=\"selected\""; } else { $tfSEL0 = ""; }
// 	if ($timeframe == 3) { $tfSEL3 = " selected=\"selected\""; } else { $tfSEL3 = ""; }
// 	if ($timeframe == 6) { $tfSEL6 = " selected=\"selected\""; } else { $tfSEL6 = ""; }
// 	if ($timeframe == 12) { $tfSEL12 = " selected=\"selected\""; } else { $tfSEL12 = ""; }
// 	echo "<select name=\"timeframe\">
// 	<option value=\"0\"$tfSEL0>"._ANYTIME."</option>
// 	<option value=\"3\"$tfSEL3>"._PAST3MO."</option>
// 	<option value=\"6\"$tfSEL6>"._PAST6MO."</option>
// 	<option value=\"12\"$tfSEL12>"._PASTYEAR."</option></select>";

	if (($order == 'newest') OR ($order == '')) { $oSEL1 = " selected=\"selected\""; } else { $oSEL1 = ""; }
	if ($order == 'oldest') { $oSEL2 = " selected=\"selected\""; } else { $oSEL2 = ""; }
	echo "<select name=\"order\">
	<option value=\"newest\"$oSEL1>"._NEWESTFIRST."</option>
	<option value=\"oldest\"$oSEL2>"._OLDESTFIRST."</option></select>";

	echo "</td></tr><tr><td colspan=\"2\" align=\"center\" nowrap=\"nowrap\" valign=\"middle\">";
	echo "<input type=\"text\" name=\"sbsearchtext\" value=\"$sbsearchtext\" size=\"53\" maxlength=\"100\" />&nbsp;&nbsp;";
	echo "<input type=\"hidden\" name=\"Action\" value=\"Search\" /><input type=\"submit\" name=\"button\" value=\""._SBSEARCH."\" /></td></tr>";
	echo "</table></form>";
}

function shoutDelete($page, $shoutID) {
	global $db, $user, $cookie, $prefix;
	$sql = "select * from ".$prefix."_shoutbox_conf";
	$result = $db->sql_query($sql);
	$conf = $db->sql_fetchrow($result);
	if ($conf[11] == "yes") {
		$sql = "select * from ".$prefix."_shoutbox where id='$shoutID'";
		$nameresult = $db->sql_query($sql);
		$row = $db->sql_fetchrow($nameresult);
		include("config.php");
		cookiedecode($user);
		$username = $cookie[1];
		if ($row[1] == $username) {
			$sqlD = "DELETE FROM ".$prefix."_shoutbox WHERE id='$shoutID'";
			$db->sql_query($sqlD);
		}
	}
	Header("Location: modules.php?name=Shout_Box&page=$page");
	exit;
}

function shoutEdit($page, $shoutID, $ShoutError) {
	include("config.php");
	global $db, $user, $cookie, $prefix;
	include("header.php");
	$module_name = basename(dirname(__FILE__));
	get_lang($module_name);
	$sql = "select * from ".$prefix."_shoutbox_conf";
	$result = $db->sql_query($sql);
	$conf = $db->sql_fetchrow($result);
	OpenTable();
	if ($conf[11] == "yes") {
		$sql = "select * from ".$prefix."_shoutbox where id='$shoutID'";
		$nameresult = $db->sql_query($sql);
		$row = $db->sql_fetchrow($nameresult);
		cookiedecode($user);
		$username = $cookie[1];
		if ($row[1] == $username) {
			// strip out link code here (added back in later if saved)
			$ShoutComment = $row[2];
			$ShoutComment = ereg_replace("&#91;<a target=\"_blank\" href=\"", "",$ShoutComment);
			$ShoutComment = ereg_replace("&#91;<a href=\"", "",$ShoutComment);
			$ShoutComment = ereg_replace("\">URL</a>&#93;", "",$ShoutComment);
			$ShoutComment = ereg_replace("\">FTP</a>&#93;", "",$ShoutComment);
			$ShoutComment = ereg_replace("\">IRC</a>&#93;", "",$ShoutComment);
			$ShoutComment = ereg_replace("\">TeamSpeak</a>&#93;", "",$ShoutComment);
			$ShoutComment = ereg_replace("\">AIM</a>&#93;", "",$ShoutComment);
			$ShoutComment = ereg_replace("\">Gopher</a>&#93;", "",$ShoutComment);
			$ShoutComment = ereg_replace("\">E-Mail</a>&#93;", "",$ShoutComment);

			$i = 0;
			$ShoutNew = '';
			$ShoutArray = explode(" ",$ShoutComment);
			foreach($ShoutArray as $ShoutPart) {
				if (eregi("mailto:", $ShoutPart)) { // find mailto:
					$ShoutPart = eregi_replace("mailto:", "",$ShoutPart); // strip out mailto:
					$ShoutPart = eregi_replace("%", " ",$ShoutPart);
					$ShoutPart = trim($ShoutPart);
					// decode address to ascii
					$c = 0;
					$AddyArray = explode(" ",$ShoutPart);
					foreach($AddyArray as $AddyPart) {
						$AddyNew[$c] = chr(hexdec($AddyPart));
						$c++;
					}
					$ShoutPart = implode("",$AddyNew);
					$ShoutNew[$i] = "mailto:$ShoutPart"; // add mailto: back in
				} else { $ShoutNew[$i] = $ShoutPart; }
				$i++;
			}
			$ShoutComment = implode(" ",$ShoutNew);

			// strip smilies code here (added back in later if saved)
			$sql = "select * from ".$prefix."_shoutbox_emoticons";
			$eresult = $db->sql_query($sql);
			while ($emoticons = $db->sql_fetchrow($eresult)) {
				$ShoutComment = str_replace($emoticons[2],$emoticons[1],$ShoutComment);
			}

			echo "<form name=\"shoutedit\" method=\"post\" action=\"\" style=\"margin-bottom: 0px;\">\n";
			echo "<table cellpadding=\"3\" cellspacing=\"0\" width=\"90%\" border=\"0\" align=\"center\">\n";
			echo "<tr><td align=\"center\"><span class=\"title\">"._SHOUTBOXEDIT."<br /><br /></span></td></tr>\n";
			if (($ShoutError) && ($ShoutError != 'none')) {
				echo "<tr><td style=\"background: #FF3333;\"><span class=\"content\"><b>"._SB_NOTE.":</b> $ShoutError</span></td></tr>";
			}
			echo "<tr><td align=\"center\"><input type=\"hidden\" name=\"shoutID\" value=\"$shoutID\" /><input type=\"text\" name=\"ShoutComment\" size=\"70\" value=\"$ShoutComment\" maxlength=\"2500\" />";
			echo "<input type=\"hidden\" name=\"page\" value=\"$page\" /><input type=\"hidden\" name=\"Action\" value=\"Save\" />&nbsp;&nbsp;<input type=\"submit\" name=\"button\" value=\""._UPDATE."\" /></td></tr>";
			echo "<tr><td align=\"center\"><a href=\"modules.php?name=Shout_Box&amp;page=$page\">"._SHOUTHISTORY."</a></td></tr>";
			echo "</table></form>";
		} else {
			echo ""._EDITINGOTHERSDISALLOWED."";
		}
	} else {
		echo ""._EDITINGDISABLEDBYADMIN."";
	}
	CloseTable();
	include("footer.php");
}

function shoutSave($page, $shoutID, $ShoutComment) {
	include("config.php");
	global $db, $user, $cookie, $prefix;
	$module_name = basename(dirname(__FILE__));
	get_lang($module_name);
	$sql = "select * from ".$prefix."_shoutbox_conf";
	$result = $db->sql_query($sql);
	$conf = $db->sql_fetchrow($result);
	if ($conf[11] == "yes") {
		$sql = "select * from ".$prefix."_shoutbox where id='$shoutID'";
		$nameresult = $db->sql_query($sql);
		$row = $db->sql_fetchrow($nameresult);
		include("config.php");
		cookiedecode($user);
		$username = $cookie[1];
		if ($row[1] == $username) {
			$ShoutComment = trim($ShoutComment); // remove whitespace off ends of shout
			$num = strlen($ShoutComment);
			if($num < 1){ $ShoutError =""._SHOUTTOOSHORT.""; }
			if ($num > 2500) { $ShoutError = ""._SHOUTTOOLONG.""; }
			if(!$ShoutComment){ $ShoutError =""._NOSHOUT.""; }

			if (eregi("javascript:(.*)", $ShoutComment)) { $ShoutError = ""._JSINSHOUT.""; }

// 			$ShoutComment = ereg_replace("([^ ]{42})","\\1",$ShoutComment);
			$ShoutComment = htmlspecialchars($ShoutComment, ENT_QUOTES);
			$ShoutComment = ereg_replace("&amp;amp;", "&amp;",$ShoutComment);

			// Are URLs allowed in shouts?
			if($conf[10] == "no") {
				// Scan to see if theres a link in the shout
				$extensions = array('http:','ftp:','irc:','teamspeak:','gopher:','aim:goim','mailto:','www\.','\.com','\.net','\.org','\.mil','\.gov','\.info','\.us','\.biz','\.tv','\.cc','\.ws','\.name','\.pro','\.co\.uk','\.ca','\.de','\.jp','\.ro','\.be','\.fm','\.ms','\.tc','\.co\.za','\.co\.nz','\.ph','\.dk','\.st','\.ac','\.gs','\.vg','\.sh','\.kz','\.as','\.lt','\.to','\.co\.il');
				$extCount = count($extensions);
				for ($num = 0; $num < $extCount; $num++) {
					if (eregi("$extensions[$num]", $ShoutComment)) {
						$ShoutError = ""._URLNOTALLOWED."";
						break;
					}
				}
			}

			// Scan for links in the shout. If there is, replace it with [URL]
			$i = 0;
			$ShoutNew = '';
			$ShoutArray = explode(" ",$ShoutComment);
			foreach($ShoutArray as $ShoutPart) {
				if (eregi("http:\/\/", $ShoutPart)) {
					// fix for users adding text to the beginning of links: HACKhttp://www.website.com
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"http://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a target=\"_blank\" href=\"$ShoutPart\">URL</a>&#93;";
				} elseif (eregi("ftp:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"ftp://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a target=\"_blank\" href=\"$ShoutPart\">FTP</a>&#93;";
				} elseif (eregi("irc:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"irc://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href=\"$ShoutPart\">IRC</a>&#93;";
				} elseif (eregi("teamspeak:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"teamspeak://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href=\"$ShoutPart\">TeamSpeak</a>&#93;";
				} elseif (eregi("aim:goim", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"aim:goim");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href=\"$ShoutPart\">AIM</a>&#93;";
				} elseif (eregi("gopher:\/\/", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"gopher://");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutNew[$i] = "&#91;<a href=\"$ShoutPart\">Gopher</a>&#93;";
				} elseif (eregi("mailto:", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"mailto:");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					// email encoding to stop harvesters
					$ShoutPart = bin2hex($ShoutPart);
					$ShoutPart = chunk_split($ShoutPart, 2, '%');
					$ShoutPart = '%' . substr($ShoutPart, 0, strlen($ShoutPart) - 1);
					$ShoutNew[$i] = "&#91;<a href=\"$ShoutPart\">E-Mail</a>&#93;";
				} elseif (eregi("www\.", $ShoutPart)) {
					$ShoutPartL = strtolower($ShoutPart);
					$spot = strpos($ShoutPartL,"www.");
					if ($spot > 0) { $ShoutPart = substr($ShoutPart, $spot); }
					$ShoutPart = "http://" . $ShoutPart;
					$ShoutNew[$i] = "&#91;<a target=\"_blank\" href=\"$ShoutPart\">URL</a>&#93;";
				} elseif ((eregi("@", $ShoutPart)) AND (eregi(".", $ShoutPart))) {
					// email encoding to stop harvesters
					$ShoutPart = bin2hex($ShoutPart);
					$ShoutPart = chunk_split($ShoutPart, 2, '%');
					$ShoutPart = '%' . substr($ShoutPart, 0, strlen($ShoutPart) - 1);
					$ShoutNew[$i] = "&#91;<a href=\"mailto:$ShoutPart\">E-Mail</a>&#93;";
				} elseif (eregi("\.(com|net|org|mil|gov|info|us|biz|tv|cc|ws|name|pro|co\.uk|ca|de|jp|ro|be|fm|ms|tc|co\.za|co\.nz|ph|dk|st|ac|gs|vg|sh|kz|as|lt|to|co\.il)", $ShoutPart)) {
					$ShoutPart = "http://" . $ShoutPart;
					$ShoutNew[$i] = "&#91;<a target=\"_blank\" href=\"$ShoutPart\">URL</a>&#93;";
				} elseif (strlen(html_entity_decode($ShoutPart, ENT_QUOTES)) > 21) {
					$ShoutNew[$i] = htmlspecialchars(wordwrap(html_entity_decode($ShoutPart, ENT_QUOTES), 21, " ", 1), ENT_QUOTES);
				} else { $ShoutNew[$i] = $ShoutPart; }
				$i++;
			}
			$ShoutComment = implode(" ",$ShoutNew);

			//Smilies from database
			$ShoutArrayReplace = explode(" ",$ShoutComment);
			$ShoutArrayScan = $ShoutArrayReplace;
			$sql = "select * from ".$prefix."_shoutbox_emoticons";
			$eresult = $db->sql_query($sql);
			while ($emoticons = $db->sql_fetchrow($eresult)) {
				$i = 0;
				foreach($ShoutArrayScan as $ShoutPart) {
					if ($ShoutPart == $emoticons[1]) { $ShoutArrayReplace[$i] = $emoticons[2]; }
					$i++;
				}
			}
			$ShoutComment = implode(" ",$ShoutArrayReplace);

			//look for bad words, then censor them.
			if($conf[8] == "yes") {
				$ShoutArrayReplace = explode(" ",$ShoutComment);
				$ShoutArrayScan = $ShoutArrayReplace;
				$sql = "select * from ".$prefix."_shoutbox_censor";
				$cresult = $db->sql_query($sql);
				while ($censor = $db->sql_fetchrow($cresult)) {
					$i = 0;
					foreach($ShoutArrayScan as $ShoutPart) {
						if ($ShoutPart == $censor[1]) { $ShoutArrayReplace[$i] = $censor[2]; }
						$i++;
					}
				}
				$ShoutComment = implode(" ",$ShoutArrayReplace);

				/*
				// Phrase censor - Needs work before implementing
				$sql = "select * from ".$prefix."_shoutbox_emoticons";
				$eresult = $db->sql_query($sql);
				while ($emoticons = $db->sql_fetchrow($eresult)) {
					$ShoutComment = str_replace($emoticons[1],$emoticons[2],$ShoutComment);
				}
				*/
			}

			if (!$ShoutError) {
				$sqlU = "UPDATE ".$prefix."_shoutbox set comment='$ShoutComment' WHERE id='$shoutID'";
				$db->sql_query($sqlU);
			} else {
				Header("Location: modules.php?name=Shout_Box&Action=Edit&shoutID=$shoutID&page=$page&ShoutError=$ShoutError");
				exit;
			}
		}
	}
	Header("Location: modules.php?name=Shout_Box&page=$page");
	exit;
}

function findAvatar($row_avatar) {
	global $db, $prefix;
	// Find avatar path
	// modules/Forums/images/avatars/gallery
	$sql = "SELECT * FROM ".$prefix."_bbconfig WHERE config_name='avatar_gallery_path'";
	$result = $db->sql_query($sql);
	$avatar_gallery_path = $db->sql_fetchrow($result);
	// modules/Forums/images/avatars
	$sql = "SELECT * FROM ".$prefix."_bbconfig WHERE config_name='avatar_path'";
	$result = $db->sql_query($sql);
	$avatar_path = $db->sql_fetchrow($result);
	if (eregi('http://',$row_avatar) == TRUE) {
		// offsite avatars
		$AvatarFound = "<img src=\"$row_avatar\" alt=\"\" /></td>";
	} else {
		$agp = "$avatar_gallery_path[config_value]/$row_avatar";
		$ap = "$avatar_path[config_value]/$row_avatar";
		if (file_exists($agp) == TRUE) {
			$AvatarFound = "<img src=\"$avatar_gallery_path[config_value]/$row_avatar\" alt=\"\" /></td>";
		} elseif (file_exists($ap) == TRUE) {
			$AvatarFound = "<img src=\"$avatar_path[config_value]/$row_avatar\" alt=\"\" /></td>";
		} else {
			$AvatarFound = "<img src=\"$avatar_path[config_value]/blank.gif\" alt=\"\" /></td>";
		}
	}
	return $AvatarFound;
}

function showHistory($page) {
	include("config.php");
	global $db, $user, $cookie, $prefix, $username, $AvatarFound;
	include("header.php");
	$module_name = basename(dirname(__FILE__));
	get_lang($module_name);
	cookiedecode($user);
	$username = $cookie[1];
	if ($username == "") {
		$username = "Anonymous";
	}
	$sql = "select * from ".$prefix."_shoutbox_conf";
	$result = $db->sql_query($sql);
	$conf = $db->sql_fetchrow($result);

	// count number of shouts in DB
	$sql = "SELECT id FROM ".$prefix."_shoutbox";
	$result = $db->sql_query($sql);
	$numrows = $db->sql_numrows($result);
	$shout_pages = 1;
	while ($numrows >= 50) {
		$shout_pages++;
		$numrows = ($numrows - 50);
	}
	if ($shout_pages == 0) { $shout_pages = 1; }
	if (!$page) { $page = 1; }
	if ($page < 1) { $page = 1; }
	if ($page > $shout_pages) { $page = $shout_pages; }
	if ($page > 1) {
		$offset = ($page * 50);
		$offset1 = ($offset - 50);
	} else { $offset1 = 0; }

	// search form
	OpenTable();
	$sbsearchtext = '';
	$where = '';
	$style = '';
	$results = '';
	$timeframe = '';
	$order = '';
	showSearchBox($sbsearchtext, $where, $style, $results, $timeframe, $order);
	CloseTable();
	echo "<br />";
	OpenTable();
	$post = 0;
	$loop = 0;
	$flag = 1;

	$ThemeSel = get_theme();
	$sql = "select * from ".$prefix."_shoutbox_themes WHERE themeName='$ThemeSel'";
	$result = $db->sql_query($sql);
	$rowColor = $db->sql_fetchrow($result);

	echo "<form name=\"shoutform2\" method=\"post\" action=\"\" style=\"margin-bottom: 0px;\">\n";
	echo "<table cellpadding=\"3\" cellspacing=\"0\" width=\"90%\" border=\"0\" align=\"center\">\n";
	echo "<tr><td align=\"center\"><span class=\"title\">"._SHOUTBOXHISTORY."</span></td></tr>\n";
	//echo "<tr><td><table cellpadding=\"0\" width=\"100%\" cellspacing=\"0\" border=\"0\"><tr><td width=\"45%\" align=\"right\"><img width=\"50\" height=\"39\" src=\"modules/Shout_Box/history.gif\" alt=\"\" /></td><td width=\"55%\" align=\"left\" valign=\"middle\"><span class=\"title\">"._SHOUTBOXHISTORY."</span></td></tr></table></td></tr>\n";
	$sql = "SELECT * FROM ".$prefix."_shoutbox ORDER BY id desc LIMIT ".$offset1.",50";
	$resultt = $db->sql_query($sql);
	while ($row = $db->sql_fetchrow($resultt)) {
		if ($flag == 1) { $bgcolor = $rowColor[5]; }
		if ($flag == 2) { $bgcolor = $rowColor[6]; }
		$comment = str_replace('src=', 'src="', $row[2]);
		$comment = str_replace('.gif>', '.gif" alt="" />', $comment);
		$comment = str_replace('.jpg>', '.jpg" alt="" />', $comment);
		$comment = str_replace('.png>', '.png" alt="" />', $comment);
		$comment = str_replace('.bmp>', '.bmp" alt="" />', $comment);

		$sqlN = "SELECT * FROM ".$prefix."_users WHERE username='$row[1]'";
		$nameresultN = $db->sql_query($sqlN);
		$rowN = $db->sql_fetchrow($nameresultN);

		// Disallow Anonymous users from seeing links to users' accounts
		if ($username == "Anonymous") {
			if (($rowN[user_avatar]) && ($rowN[user_avatar] != "blank.gif") && ($rowN[user_avatar] != "gallery/blank.gif") && (stristr($rowN[user_avatar],'.') == TRUE)) {
				echo "<tr><td style=\"background-color: $bgcolor;\">";
				echo "<table cellpadding=\"1\" cellspacing=\"0\" width=\"100%\" border=\"0\">";
				echo "<tr><td valign='top' style=\"background-color: $bgcolor;\">";
				$row_avatar = $rowN[user_avatar];
				$av_found = findAvatar($row_avatar);
				echo "$av_found";
				echo "<td valign='top' width='100%' style=\"background-color: $bgcolor;\"><span class=\"content\">";
				echo "<b>$row[1]:</b> $comment<br />";
				if ($conf[3] == "yes") { echo "$row[3]"; }
				if ($conf[4] == "yes") { echo " $row[4]"; }
				echo "</span></td></tr></table>";
				echo "</td></tr>\n";
			} else {
				echo "<tr><td style=\"background-color: $bgcolor;\"><span class=\"content\">";
				echo "<b>$row[1]:</b> $comment<br />";
				if ($conf[3] == "yes") { echo "$row[3]"; }
				if ($conf[4] == "yes") { echo " $row[4]"; }
				echo "</span></td></tr>\n";
			}
		} else {
			// check to see if nickname is a user in the DB and not Anonymous
			if (($rowN) && ($rowN[username] != "Anonymous")) {
				if (($rowN[user_avatar]) && ($rowN[user_avatar] != "blank.gif") && ($rowN[user_avatar] != "gallery/blank.gif") && (stristr($rowN[user_avatar],'.') == TRUE)) {
					echo "<tr><td style=\"background-color: $bgcolor;\">";
					echo "<table cellpadding=\"1\" cellspacing=\"0\" width=\"100%\" border=\"0\">";
					echo "<tr><td valign='top' style=\"background-color: $bgcolor;\">";
					$row_avatar = $rowN[user_avatar];
					$av_found = findAvatar($row_avatar);
					echo "$av_found";
					echo "<td valign='top' width='100%' style=\"background-color: $bgcolor;\"><span class=\"content\"><b><a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;username=$row[1]\">$row[1]</a>:</b> $comment<br />";
					if ($conf[3] == "yes") { echo "$row[3]"; }
					if ($conf[4] == "yes") { echo " $row[4]"; }
					// registered users edit/delete posts
					if (($conf[11] == "yes") && ($username == $row[1])) {
						echo " &#91; <a title=\""._EDIT."\" href=\"modules.php?name=Shout_Box&amp;Action=Edit&amp;shoutID=$row[0]&amp;page=$page\">"._EDIT."</a> | <a title=\""._DELETE."\" href=\"modules.php?name=Shout_Box&amp;Action=Delete&amp;shoutID=$row[0]&amp;page=$page\">"._DELETE."</a> &#93;";
					}
					echo "</span></td></tr></table>";
					echo "</td></tr>\n";
				} else {
					echo "<tr><td style=\"background-color: $bgcolor;\"><span class=\"content\">";
					echo "<b><a href=\"modules.php?name=Your_Account&amp;op=userinfo&amp;username=$row[1]\">$row[1]</a>:</b> $comment<br />";
					if ($conf[3] == "yes") { echo "$row[3]"; }
					if ($conf[4] == "yes") { echo " $row[4]"; }
					// registered users edit/delete posts
					if (($conf[11] == "yes") && ($username == $row[1])) {
						echo " &#91; <a title=\""._EDIT."\" href=\"modules.php?name=Shout_Box&amp;Action=Edit&amp;shoutID=$row[0]&amp;page=$page\">"._EDIT."</a> | <a title=\""._DELETE."\" href=\"modules.php?name=Shout_Box&amp;Action=Delete&amp;shoutID=$row[0]&amp;page=$page\">"._DELETE."</a> &#93;";
					}
					echo "</span></td></tr>\n";
				}
			} else {
				echo "<tr><td style=\"background-color: $bgcolor;\"><span class=\"content\">";
				echo "<b>$row[1]:</b> $comment<br />";
				if ($conf[3] == "yes") { echo "$row[3]"; }
				if ($conf[4] == "yes") { echo " $row[4]"; }
				echo "</span></td></tr>\n";
			}
		}
		if ($flag == 1) { $flag = 2; }
		elseif ($flag == 2) { $flag =1; }
	}
	echo "<tr><td align=\"center\">";

	$num3 = ($page-1);
	$num4 = ($page+1);

	if ($shout_pages > 10) {
		$shout_menu = "<br /><center><table border=\"0\" width=\"10%\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"100%\" align=\"center\" nowrap=\"nowrap\"><span class=\"content\">\n";
		if ($page > 1) {
			$shout_menu .= "<a title=\""._PAGE." $num3\" href=\"modules.php?name=Shout_Box&amp;page=$num3\">"._PREVIOUS."</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
		}
		$shout_menu .= ""._PAGE." $page / $shout_pages\n";

		if ($page < $shout_pages) {
			$shout_menu .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a title=\""._PAGE." $num4\" href=\"modules.php?name=Shout_Box&amp;page=$num4\">"._NEXT."</a>\n";
		}
		$shout_menu .= "</span><br /><br /></td>\n";
		$shout_menu .= "</tr><tr>";
		$shout_menu .= "<td align=\"left\" nowrap=\"nowrap\"><table align=\"left\" cellspacing=\"1\" cellpadding=\"2\" style=\"height: 8; background: $rowColor[4];\"><tr valign=\"middle\">\n";
		$WrapCount = 0;
		for ($count = 1; $count <= $shout_pages; $count++) {
			if ($page == $count) {
				$shout_menu .= "<td style=\"background: $rowColor[6]; border: 1;\" align=\"center\"><a title=\""._PAGE." $count\" href=\"modules.php?name=Shout_Box&amp;page=$count\">&nbsp;$count&nbsp;</a></td>\n";
			} else {
				$shout_menu .= "<td style=\"background: $rowColor[5]; border: 1;\" align=\"center\"><a title=\""._PAGE." $count\" href=\"modules.php?name=Shout_Box&amp;page=$count\">&nbsp;$count&nbsp;</a></td>\n";
			}
			$WrapCount ++;
			if (($WrapCount == 15) AND ($shout_pages > $count)) {
				$shout_menu .= "</tr><tr>";
				$WrapCount = 0;
			}
		}
		if (($WrapCount > 0) AND ($WrapCount < 15) AND ($shout_pages > 15)) {
			while ($WrapCount < 15) {
				$shout_menu .= "<td style=\"background: $rowColor[5]; border: 1;\" align=\"center\">&nbsp;</td>";
				$WrapCount++;
			}
		}
		$shout_menu .= "</tr></table>\n";
		$shout_menu .= "</td></tr></table></center>\n";
	} else {
		$shout_menu = "<br /><center><table border=\"0\" width=\"10%\" cellspacing=\"0\" cellpadding=\"0\"><tr><td width=\"100%\" align=\"left\" nowrap=\"nowrap\"><span class=\"content\">"._PAGE." $page / $shout_pages&nbsp;&nbsp;\n";
		if ($page < 2) {
			$shout_menu .= "</span></td>\n";
		} else {
			$shout_menu .= "&nbsp;&nbsp;&nbsp;<a title=\""._PAGE." $num3\" href=\"modules.php?name=Shout_Box&amp;page=$num3\">"._PREVIOUS."</a>&nbsp;</span></td>\n";
		}
		$shout_menu .= "<td align=\"left\" nowrap=\"nowrap\"><table align=\"left\" cellspacing=\"1\" cellpadding=\"2\" style=\"height: 8; background: #B6B6B6;\"><tr valign=\"middle\">\n";
		for ($count = 1; $count <= $shout_pages; $count++) {
			if ($page == $count) {
				$shout_menu .= "<td style=\"background: $rowColor[6]; border: 1;\" align=\"center\">&nbsp;<a title=\""._PAGE." $count\" href=\"modules.php?name=Shout_Box&amp;page=$count\">$count</a>&nbsp;</td>\n";
			} else {
				$shout_menu .= "<td style=\"background: $rowColor[5]; border: 1;\" align=\"center\">&nbsp;<a title=\""._PAGE." $count\" href=\"modules.php?name=Shout_Box&amp;page=$count\">$count</a>&nbsp;</td>\n";
			}
		}
		$shout_menu .= "</tr></table>\n";
		if ($page < $shout_pages) {
			$shout_menu .= "</td><td><span class=\"content\">&nbsp;<a title=\""._PAGE." $num4\" href=\"modules.php?name=Shout_Box&amp;page=$num4\">"._NEXT."</a></span></td></tr></table></center>\n";
		} else {
			$shout_menu .= "</td></tr></table></center>\n";
		}
	}
	// End menu build

	echo "$shout_menu</td></tr></table></form>\n";

	CloseTable();
	include("footer.php");
}

function showBanned() {
	include("config.php");
	include("header.php");
	$module_name = basename(dirname(__FILE__));
	get_lang($module_name);
	OpenTable();
	echo "<br /><p class=\"title\" align=\"center\"><b>"._YOUAREBANNEDM."</b></p><br />";
	CloseTable();
	include("footer.php");
}

switch($Action) {

		case "UserBanned":
		showBanned();
		break;

		case "Search":
		searchHistory($where, $sbsearchtext, $results, $style, $timeframe, $order);
		break;

		case "Delete":
		shoutDelete($page, $shoutID);
		break;

		case "Edit":
		if ($ShoutError == '') { $ShoutError = 'none'; }
		shoutEdit($page, $shoutID, $ShoutError);
		break;

		case "Save":
		shoutSave($page, $shoutID, $ShoutComment);
		break;

		default:
		showHistory($page);
		break;

}

?>
