<?php

// ######################################################################
// # PHP-Nuke                                                           #
// #====================================================================#
// #  Copyright (c) 2003 - Francisco Burzi                              #
// #  http://phpnuke.org/                                               #
// #====================================================================#
// # Paladin's Web Links                                                #
// #====================================================================#
// #  Copyright (c) 2003 - Darren Poulton (paladin@intaleather.com.au)  #
// #  http://paladin.intaleather.com.au/                                #
// #                                                                    #
// #  Developed from the PHP-Nuke 6.5 Standard Web Links Module         #
// #  Copyright (c) 2003 - Francisco Burzi                              #
// #  http://phpnuke.org/                                               #
// #                                                                    #
// #  Updated 2004-09-04 for PHP-Nuke 7.5                               #
// #  by SPCDATA http://www.nextnet.se                                  #
// #  Added new SQL abstraction layer and added lang definition         #
// #====================================================================#
// #  Use of this program is goverened by the terms of the GNU General  #
// #     Public License (GPL - version 1 or 2) as published by the      #
// #           Free Software Foundation (http://www.gnu.org/)           #
/************************************************************************/
/* PHP-Nuke Platinum: Expect to be impressed                  COPYRIGHT */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.techgfx.com                  */
/*     Techgfx - Graeme Allan                       (goose@techgfx.com) */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de            */
/*     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de) */
/*                                                                      */
/* Refer to TechGFX.com for detailed information on PHP-Nuke Platinum   */
/*                                                                      */
/* TechGFX: Your dreams, our imagination                                */
/************************************************************************/

if (!stristr($_SERVER['SCRIPT_NAME'], "modules.php")) {
    die ("You can't access this file directly...");
}

require_once("mainfile.php");
$module_name = basename(dirname(__FILE__));
get_lang($module_name);
$pagetitle = "- "._WEBLINKS."";
require_once("modules/Web_Links/l_config.php");

$index = $viewrightblocks;

// Fluffy's Scanner
if (!function_exists('ac_Get_Title_From_Page')) { 
	function getpagetitle($file, $bytes) { 
		$filename = @fopen("$file", "r"); 
		$data = @fread($filename, $bytes); 
		@fclose($filename); 
		preg_match_all ("/<title>(.*?)<\/title>/i", $data, $remotetitle); 
		$ptitle = $remotetitle[1][0]; 
		return $ptitle; 
	} 
}
//

// ######################################################################
// FUNCTIONS :: START
// ######################################################################

// ######################################################################
// FUNCTION : switchColor($color)
// ######################################################################
function switchColor($color) {
        global $bgcolor1;
        if ($color == $bgcolor1) { $outColor = $bgcolor1; } else { $outColor = $bgcolor1; }
        return $outColor;
}

// ######################################################################
// FUNCTION : getparent($parentid,$title)
// ######################################################################
function getparent($parentid,$title) {
    global $prefix, $db;
    $result = $db->sql_query("select cid, title, parentid from ".$prefix."_links_categories where cid=$parentid order by title ");
    list($cid, $ptitle, $pparentid) = $db->sql_fetchrow($result);
    if ($ptitle!="") $title=$ptitle."/".$title;
    if ($pparentid!=0) {
        $title=getparent($pparentid,$ptitle);
    }
    return $title;
}

// ######################################################################
// FUNCTION : getparentlink($parentid,$title)
// ######################################################################
function getparentlink($parentid,$title) {
    global $prefix, $db;
    $result=$db->sql_query("select cid, title, parentid from ".$prefix."_links_categories where cid=$parentid");
    list($cid, $ptitle, $pparentid) = $db->sql_fetchrow($result);
    if ($ptitle!="") $title="<a href=modules.php?name=Web_Links&l_op=viewlink&cid=$cid>$ptitle</a>/".$title;
    if ($pparentid!=0) {
            $title=getparentlink($pparentid,$ptitle);
    }
    return $title;
}

// ######################################################################
// FUNCTION : menu($mainlink)
// ######################################################################
function menu($mainlink) {
    global $module_name;
    OpenTable();
    echo "<form action=\"modules.php?name=Web_Links&l_op=search&amp;query=$query\" method=\"post\">"
        ."<center><font class=\"content\"><input type=\"text\" size=\"25\" name=\"query\"> <input type=\"submit\" value=\""._SEARCH."\"></font>"
        ."</form>";
    echo "<font class=\"content\">[ ";
    if ($mainlink>0) {
        echo "<a href=\"modules.php?name=Web_Links\">"._LINKSMAIN."</a> | ";
    }
    echo "<a href=\"modules.php?name=Web_Links&l_op=AddLink\">"._ADDLINK."</a>"
        ." | <a href=\"modules.php?name=Web_Links&l_op=NewLinks\">"._NEW."</a>"
        ." | <a href=\"modules.php?name=Web_Links&l_op=MostPopular\">"._POPULAR."</a>"
        ." | <a href=\"modules.php?name=Web_Links&l_op=TopRated\">"._TOPRATED."</a>"
        ." | <a href=\"modules.php?name=Web_Links&l_op=RandomLink\">"._RANDOM."</a> ]"
        ."</font></center>";
    CloseTable();
}

// ######################################################################
// FUNCTION : SearchForm()
// ######################################################################
function SearchForm() {
    echo "<form action=\"modules.php?name=Web_Links&l_op=search&query=$query\" method=\"post\">"
        ."<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">"
        ."<tr><td><font class=\"content\"><input type=\"text\" size=\"25\" name=\"query\"> <input type=\"submit\" value=\""._SEARCH."\"></td></tr>"
        ."</table>"
        ."</form>";
}

// ######################################################################
// FUNCTION : linkinfomenu($lid, $ttitle)
// ######################################################################
function linkinfomenu($lid, $ttitle) {
    global $module_name, $user;
    $ttitle = stripslashes($ttitle);
    echo "<br><font class=\"content\">[ "
        ."<a href=\"modules.php?name=Web_Links&l_op=viewlinkcomments&amp;lid=$lid&amp;ttitle=$ttitle\">"._LINKCOMMENTS."</a>"
        ." | <a href=\"modules.php?name=Web_Links&l_op=viewlinkdetails&amp;lid=$lid&amp;ttitle=$ttitle\">"._ADDITIONALDET."</a>"
        ." | <a href=\"modules.php?name=Web_Links&l_op=viewlinkeditorial&amp;lid=$lid&amp;ttitle=$ttitle\">"._EDITORREVIEW."</a>"
        ." | <a href=\"modules.php?name=Web_Links&l_op=modifylinkrequest&amp;lid=$lid\">"._MODIFY."</a>";
    if (is_user($user)) {
        echo " | <a href=\"modules.php?name=Web_Links&l_op=brokenlink&amp;lid=$lid\">"._REPORTBROKEN."</a>";
    }
    echo " ]</font>";
}

// ######################################################################
// FUNCTION : index()
// ######################################################################
function index() {
    global $prefix, $db, $bgcolor1, $bgcolor3, $user, $admin, $db, $show_links_num, $show_links_info, $show_links_inum, $admin_file;
    include("header.php");
    title("$sitename: "._WEBLINKS."");
    $mainlink = 0;
    menu($mainlink);
    echo "<br>";
    OpenTable();
    echo "<center><font class=\"title\"><b>"._LINKSMAINCAT."</b></font></center><br>";
    echo "<table border=\"0\" cellspacing=\"10\" cellpadding=\"0\" align=\"center\"><tr>";
    $result = $db->sql_query("select cid, title, cdescription from ".$prefix."_links_categories where parentid=0 order by title");
    $count = 0;
    while(list($cid, $title, $cdescription) = $db->sql_fetchrow($result)) {
                if ($show_links_num == 1) {
                    $cnumrows = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_links_links WHERE cid='$cid'"));
                    $cnumm = " ($cnumrows)";
                } else { $cnumm = ""; }
                if ($cnumrows > 0) { $folder = "modules/Web_Links/images/openfolder.gif"; } else { $folder = "modules/Web_Links/images/closedfolder.gif"; }
                if (is_admin($admin)) { $folderImg = "<A HREF=\"".$admin_file.".php?op=LinksModCat&amp;cat=$cid\"><IMG SRC=\"$folder\" BORDER=0 ALT=\""._EDIT."\"></A>"; } else { $folderImg = "<IMG SRC=\"$folder\" BORDER=0 ALT=\"$title2\">"; }
                echo "<td><font class=\"title\">$folderImg <a href=\"modules.php?name=Web_Links&l_op=viewlink&amp;cid=$cid\"><b>$title</b></a></font>$cnumm";
                categorynewlinkgraphic($cid);
                if ($cdescription) {
                    echo "<br><font class=\"content\">$cdescription</font><br>";
                } else {
                    echo "<br>";
                }
                $result2 = $db->sql_query("select cid, title from ".$prefix."_links_categories where parentid=$cid order by title");
                $space = 0;
                while(list($cid, $stitle) = $db->sql_fetchrow($result2)) {
                if ($space>0) { echo "<br>"; }
            if ($show_links_num == 1) {
                        $cnumrows2 = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_links_links WHERE cid='$cid'"));
                                $cnum = " ($cnumrows2)";
                    } else { $cnumrows2 = ""; }
                    echo "<font class=\"content\"><a href=\"modules.php?name=Web_Links&l_op=viewlink&amp;cid=$cid\">$stitle</a></font>$cnum";
                    $space++;
                }
                if ($count<1) {
                    echo "</td><td>&nbsp;&nbsp;&nbsp;&nbsp;</td>";
                    $dum = 1;
                }
                $count++;
                if ($count==2) {
                    echo "</td></tr><tr>";
                    $count = 0;
                    $dum = 0;
                }
    }
    if ($dum == 1) {
        echo "</tr></table>";
    } elseif ($dum == 0) {
        echo "<td></td></tr></table>";
    }
    $result=$db->sql_query("select * from ".$prefix."_links_links");
    $numrows = $db->sql_numrows($result);
    $result=$db->sql_query("select * from ".$prefix."_links_categories");
    $catnum = $db->sql_numrows($result);
    echo "<br><br><center><font class=\"content\">"._THEREARE." <b>$numrows</b> "._LINKS." "._AND." <b>$catnum</b> "._CATEGORIES." "._INDB."</font></center>";
    CloseTable();
    if ($show_links_info == 1) {
            echo "<BR>";
            OpenTable();
            echo "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=3 WIDTH=100%>"
                    ."<TR><TD WIDTH=50% VALIGN=TOP ALIGN=CENTER>";
//                OpenTable2();
                echo "<DIV ALIGN=CENTER CLASS=\"title\">"._NEWLINKS."</DIV>";
//                CloseTable2();
            echo "</TD><TD WIDTH=50% VALIGN=TOP ALIGN=CENTER>";
//                OpenTable2();
                echo "<DIV ALIGN=CENTER CLASS=\"title\">"._MOSTPOPULAR." $show_links_inum</DIV>";
//                CloseTable2();
            echo "</TD></TR>"
                    ."<TR><TD WIDTH=50% VALIGN=TOP ALIGN=CENTER>";
                OpenTable2();
                $content = "";
                $content .= "<TABLE BORDER=0 WIDTH=\"100%\">";
                $color = $bgcolor3;
                $sql = "SELECT lid, title, hits FROM ".$prefix."_links_links ORDER BY date DESC LIMIT 0, $show_links_inum";
                $result = $db->sql_query($sql);
                while ($row = $db->sql_fetchrow($result)) {
                    $title2 = ereg_replace("_", " ", $row[title]);
                    $color = switchColor($color);
                    $content .= "<TR><TD BGCOLOR=\"$color\" ALIGN=LEFT><a href=\"modules.php?name=Web_Links&amp;l_op=viewlinkdetails&amp;lid=$row[lid]&amp;ttitle=$row[title]\">$title2</a></TD>";
                    $content .= "<TD BGCOLOR=\"$color\" ALIGN=CENTER WIDTH=\"20\">$row[hits]</TD></TR>";
                }
                echo "$content</TABLE>";
                CloseTable2();
            echo "[ <A HREF=\"modules.php?name=Web_Links&amp;l_op=NewLinks\">"._NEWLINKS."</A> ]</TD><TD WIDTH=50% VALIGN=TOP ALIGN=CENTER>";
                OpenTable2();
                $content = "";
                $content .= "<TABLE BORDER=0 WIDTH=\"100%\">";
                $color = $bgcolor3;
                $sql = "SELECT lid, title, hits FROM ".$prefix."_links_links ORDER BY hits DESC LIMIT 0, $show_links_inum";
                $result = $db->sql_query($sql);
                while ($row = $db->sql_fetchrow($result)) {
                    $title2 = ereg_replace("_", " ", $row[title]);
                    $color = switchColor($color);
                    $content .= "<TR><TD BGCOLOR=\"$color\" ALIGN=LEFT><a href=\"modules.php?name=Web_Links&amp;l_op=viewlinkdetails&amp;lid=$row[lid]&amp;ttitle=$row[title]\">$title2</a></TD>";
                    $content .= "<TD BGCOLOR=\"$color\" ALIGN=CENTER WIDTH=\"20\">$row[hits]</TD></TR>";
                }
                echo "$content</TABLE>";
                CloseTable2();
            echo "[ <A HREF=\"modules.php?name=Web_Links&amp;l_op=MostPopular\">"._MOSTPOPULAR." "._LINKS."</A> ]</TD></TR>"
                    ."</TABLE>";
            CloseTable();
        }
    include("footer.php");
}

// ######################################################################
// FUNCTION : AddLink()
// ######################################################################
function AddLink() {
// Fluffy's Scanner (+ , $url, $cookie)
    global $prefix, $db, $user, $links_anonaddlinklock, $url, $cookie;
//
    include("header.php");
    title("$sitename: "._WEBLINKS."");
    $mainlink = 1;
    menu(1);
// Fluffy's Scanner
	if ($url != "") {
		$meta = get_meta_tags($url);
		$pdescription = $meta['description'];
		$ptitle = getpagetitle($url, 2048);
	}
	$result = $db->sql_query("SELECT user_email FROM ".$prefix."_users WHERE username='$cookie[1]'");
	list($umail) = $db->sql_fetchrow($result);
//
    echo "<br>";
    OpenTable();
    echo "<center><font class=\"title\"><b>"._ADDALINK."</b></font></center><br><br>";
    if (is_user($user) || $links_anonaddlinklock == 1) {  /* 06-24-01 Bug fix : changed $links_anonaddlinklock != 1 to $links_anonaddlinklock == 1 */
// Fluffy's Scanner
			CloseTable();
			OpenTable();
			echo "<center><font class=\"title\"><b>" . _SCANURL . "</b></font><br><br>"
				."" . _SCANURLINFO . ""
				."<form method=\"post\" action=\"modules.php?name=Web_Links&l_op=AddLink\">"
				.""._PAGEURL.": <input type=\"text\" name=\"url\" size=\"50\" maxlength=\"100\" value=\"http://\"><br><br>"
				."<input type=\"submit\" value=\"" . _DOSCAN . "\"></center><br><br>"
				."</form>";
			CloseTable();
			OpenTable();
//
            echo "<b>"._INSTRUCTIONS.":</b><br>"
            ."<strong><big>&middot;</big></strong> "._SUBMITONCE."<br>"
            ."<strong><big>&middot;</big></strong> "._POSTPENDING."<br>"
            ."<strong><big>&middot;</big></strong> "._USERANDIP."<br>"
                ."<form method=\"post\" action=\"modules.php?name=Web_Links&l_op=Add\">"
// Fluffy's Scanner (+ value=\"$ptitle\")
                .""._PAGETITLE.": <input type=\"text\" name=\"title\" size=\"50\" maxlength=\"100\" value=\"$ptitle\"><br>"
// Fluffy's Scanner (replaced 'value=\"http://\"' with 'value=\"$url\"')
                .""._PAGEURL.": <input type=\"text\" name=\"url\" size=\"50\" maxlength=\"100\" value=\"$url\"><br>";
            echo ""._CATEGORY.": <select name=\"cat\">";
            $result2=$db->sql_query("select cid, title, parentid from ".$prefix."_links_categories order by parentid,title");
            while(list($cid2, $ctitle2, $parentid2) = $db->sql_fetchrow($result2)) {
                    if ($parentid2!=0) $ctitle2=getparent($parentid2,$ctitle2);
                echo "<option value=\"$cid2\">$ctitle2</option>";
            }
            echo "</select><br><br>"
// Fluffy's Scanner (+ $pdescription)
                .""._LDESCRIPTION."<br><textarea name=\"description\" cols=\"60\" rows=\"5\">$pdescription</textarea><br><br><br>"
// Fluffy's Scanner (+  value=\"$cookie[1]\")
                .""._YOURNAME.": <input type=\"text\" name=\"auth_name\" size=\"30\" maxlength=\"60\" value=\"$cookie[1]\"><br>"
// Fluffy's Scanner (+  value=\"$umail\")
                .""._YOUREMAIL.": <input type=\"text\" name=\"email\" size=\"30\" maxlength=\"60\" value=\"$umail\"><br><br>"
                ."<input type=\"hidden\" name=\"l_op\" value=\"Add\">"
                ."<input type=\"submit\" value=\""._ADDURL."\"> "._GOBACK."<br><br>"
                ."</form>";
    }else {
            echo "<center>"._LINKSNOTUSER1."<br>"
            .""._LINKSNOTUSER2."<br><br>"
                .""._LINKSNOTUSER3."<br>"
                .""._LINKSNOTUSER4."<br>"
                .""._LINKSNOTUSER5."<br>"
                .""._LINKSNOTUSER6."<br>"
                .""._LINKSNOTUSER7."<br><br>"
                .""._LINKSNOTUSER8."";
    }
    CloseTable();
    include("footer.php");
}

// ######################################################################
// FUNCTION : Add($title, $url, $auth_name, $cat, $description, $email)
// ######################################################################
function Add($title, $url, $auth_name, $cat, $description, $email) {
    global $prefix, $db, $user;
    $result = $db->sql_query("select url from ".$prefix."_links_links where url='$url'");
    $numrows = $db->sql_numrows($result);
    if ($numrows>0) {
        include("header.php");
        title("$sitename: "._WEBLINKS."");
        menu(1);
        echo "<br>";
        OpenTable();
        echo "<center><b>"._LINKALREADYEXT."</b><br><br>"
            .""._GOBACK."";
        CloseTable();
        include("footer.php");
    } else {
        if(is_user($user)) {
            $user2 = base64_decode($user);
            $cookie = explode(":", $user2);
            cookiedecode($user);
            $submitter = $cookie[1];
    }
// Check if Title exist
    if ($title=="") {
        include("header.php");
        title("$sitename: "._WEBLINKS."");
        menu(1);
        echo "<br>";
        OpenTable();
        echo "<center><b>"._LINKNOTITLE."</b><br><br>"
            .""._GOBACK."";
        CloseTable();
        include("footer.php");
    }
// Check if URL exist
    if ($url=="") {
        include("header.php");
        title("$sitename: "._WEBLINKS."");
        menu(1);
        echo "<br>";
        OpenTable();
        echo "<center><b>"._LINKNOURL."</b><br><br>"
            .""._GOBACK."";
        CloseTable();
        include("footer.php");
    }
// Check if Description exist
    if ($description=="") {
        include("header.php");
        title("$sitename: "._WEBLINKS."");
        menu(1);
        echo "<br>";
        OpenTable();
        echo "<center><b>"._LINKNODESC."</b><br><br>"
            .""._GOBACK."";
        CloseTable();
        include("footer.php");
    }
    $cat = explode("-", $cat);
    if ($cat[1]=="") {
        $cat[1] = 0;
    }
    $title = stripslashes(check_html(FixQuotes($title, "nohtml")));
    $url = stripslashes(check_html($url, "nohtml"));
    $description = stripslashes(check_html(FixQuotes($description, "html")));
    $auth_name = stripslashes(check_html($auth_name, "nohtml"));
    $email = stripslashes(check_html($email, "nohtml"));
    $db->sql_query("insert into ".$prefix."_links_newlink values (NULL, '$cat[0]', '$cat[1]', '$title', '$url', '$description', '$auth_name', '$email', '$submitter')");
    include("header.php");
    title("$sitename: "._WEBLINKS."");
    menu(1);
    echo "<br>";
    OpenTable();
    echo "<center><b>"._LINKRECEIVED."</b><br>";
    if ($email != "") {
        echo _EMAILWHENADD;
    } else {
        echo _CHECKFORIT;
    }
    CloseTable();
    include("footer.php");
    }
}

// ######################################################################
// FUNCTION : RandomLink()
// ######################################################################
function RandomLink() {
    global $prefix, $db;
    $result = $db->sql_query("select * from ".$prefix."_links_links");
    $numrows = $db->sql_numrows($result);
    if ($numrows == 1) {
        $random = 1;
    } else {
        srand((double)microtime()*1000000);
        $random = rand(1,$numrows);
    }
    $result2 = $db->sql_query("select url from ".$prefix."_links_links where lid='$random'");
    list($url) = $db->sql_fetchrow($result2);
    $db->sql_query("update ".$prefix."_links_links set hits=hits+1 where lid=$random");
    Header("Location: $url");
}

// ######################################################################
// FUNCTION : newlinkgraphic($datetime, $time)
// ######################################################################
function newlinkgraphic($datetime, $time) {
    global $module_name;
    echo "&nbsp;";
    setlocale (LC_TIME, $locale);
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
    $datetime = strftime(""._LINKSDATESTRING."", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
    $datetime = ucfirst($datetime);
    $startdate = time();
    $count = 0;
    while ($count <= 7) {
        $daysold = date("Y.m.d", $startdate);
        if ("$daysold" == "$datetime") {
                if ($count<=1) {
                echo "<img src=\"modules/$module_name/images/newred.gif\" alt=\""._NEWTODAY."\">";
            }
            if ($count<=3 && $count>1) {
                echo "<img src=\"modules/$module_name/images/newgreen.gif\" alt=\""._NEWLAST3DAYS."\">";
            }
            if ($count<=7 && $count>3) {
                echo "<img src=\"modules/$module_name/images/newblue.gif\" alt=\""._NEWTHISWEEK."\">";
            }
        }
        $count++;
        $startdate = (time()-(86400 * $count));
    }
}

// ######################################################################
// FUNCTION : categorynewlinkgraphic($cat)
// ######################################################################
function categorynewlinkgraphic($cat) {
    global $prefix, $db, $module_name;
    $newresult = $db->sql_query("select date from ".$prefix."_links_links where cid=$cat order by date desc limit 1");
    list($time)=$db->sql_fetchrow($newresult);
    echo "&nbsp;";
    setlocale (LC_TIME, $locale);
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $time, $datetime);
    $datetime = strftime(""._LINKSDATESTRING."", mktime($datetime[4],$datetime[5],$datetime[6],$datetime[2],$datetime[3],$datetime[1]));
    $datetime = ucfirst($datetime);
    $startdate = time();
    $count = 0;
    while ($count <= 7) {
        $daysold = date("Y.m.d", $startdate);
        if ("$daysold" == "$datetime") {
                if ($count<=1) {
                echo "<img src=\"modules/$module_name/images/newred.gif\" alt=\""._CATNEWTODAY."\">";
            }
            if ($count<=3 && $count>1) {
                echo "<img src=\"modules/$module_name/images/newgreen.gif\" alt=\""._CATLAST3DAYS."\">";
            }
            if ($count<=7 && $count>3) {
                echo "<img src=\"modules/$module_name/images/newblue.gif\" alt=\""._CATTHISWEEK."\">";
            }
        }
        $count++;
        $startdate = (time()-(86400 * $count));
    }
}

// ######################################################################
// FUNCTION : popgraphic($hits)
// ######################################################################
function popgraphic($hits) {
    global $module_name;
    include("modules/Web_Links/l_config.php");
    if ($hits>=$popular) {
        echo "&nbsp;<img src=\"modules/$module_name/images/pop.gif\" alt=\""._POPULAR."\">";
    }
}

// ######################################################################
// FUNCTION : convertorderbyin($orderby)
// ######################################################################
function convertorderbyin($orderby) {
    if ($orderby == "titleA")        $orderby = "title ASC";
    if ($orderby == "dateA")        $orderby = "date ASC";
    if ($orderby == "hitsA")        $orderby = "hits ASC";
    if ($orderby == "ratingA")        $orderby = "linkratingsummary ASC";
    if ($orderby == "titleD")        $orderby = "title DESC";
    if ($orderby == "dateD")        $orderby = "date DESC";
    if ($orderby == "hitsD")        $orderby = "hits DESC";
    if ($orderby == "ratingD")        $orderby = "linkratingsummary DESC";
    return $orderby;
}

// ######################################################################
// FUNCTION : convertorderbytrans($orderby)
// ######################################################################
function convertorderbytrans($orderby) {
    if ($orderby == "hits ASC")                        $orderbyTrans = ""._POPULARITY1."";
    if ($orderby == "hits DESC")                $orderbyTrans = ""._POPULARITY2."";
    if ($orderby == "title ASC")                $orderbyTrans = ""._TITLEAZ."";
    if ($orderby == "title DESC")                $orderbyTrans = ""._TITLEZA."";
    if ($orderby == "date ASC")                        $orderbyTrans = ""._DATE1."";
    if ($orderby == "date DESC")                $orderbyTrans = ""._DATE2."";
    if ($orderby == "linkratingsummary ASC")        $orderbyTrans = ""._RATING1."";
    if ($orderby == "linkratingsummary DESC")        $orderbyTrans = ""._RATING2."";
    return $orderbyTrans;
}

// ######################################################################
// FUNCTION : convertorderbyout($orderby)
// ######################################################################
function convertorderbyout($orderby) {
    if ($orderby == "title ASC")                $orderby = "titleA";
    if ($orderby == "date ASC")                        $orderby = "dateA";
    if ($orderby == "hits ASC")                        $orderby = "hitsA";
    if ($orderby == "linkratingsummary ASC")        $orderby = "ratingA";
    if ($orderby == "title DESC")                $orderby = "titleD";
    if ($orderby == "date DESC")                $orderby = "dateD";
    if ($orderby == "hits DESC")                $orderby = "hitsD";
    if ($orderby == "linkratingsummary DESC")        $orderby = "ratingD";
    return $orderby;
}

// ######################################################################
// FUNCTION : visit($lid)
// ######################################################################
function visit($lid) {
    global $prefix, $db;
    $db->sql_query("update ".$prefix."_links_links set hits=hits+1 where lid=$lid");
    $result = $db->sql_query("select url from ".$prefix."_links_links where lid=$lid");
    list($url) = $db->sql_fetchrow($result);
    Header("Location: $url");
}

// ######################################################################
// FUNCTION : detecteditorial($lid, $ttitle)
// ######################################################################
function detecteditorial($lid, $ttitle) {
    global $prefix, $db;
    $resulted2 = $db->sql_query("select adminid from ".$prefix."_links_editorials where linkid=$lid");
    $recordexist = $db->sql_numrows($resulted2);
    if ($recordexist != 0) {
        echo " | <a href=\"modules.php?name=Web_Links&l_op=viewlinkeditorial&amp;lid=$lid&amp;ttitle=$ttitle\">"._EDITORIAL."</a>";
    }
}

// ######################################################################
// FUNCTION : linkfooter($lid,$ttitle)
// ######################################################################
function linkfooter($lid,$ttitle) {
        $ttitle = stripslashes($ttitle);
    echo "<font class=\"content\">[ <a href=\"modules.php?name=Web_Links&l_op=visit&amp;lid=$lid\" target=\"_blank\">"._VISITTHISSITE."</a> | <a href=\"modules.php?name=Web_Links&l_op=ratelink&amp;lid=$lid&amp;ttitle=$ttitle\">"._RATETHISSITE."</a> ]</font><br><br>";
    linkfooterchild($lid);
}

// ######################################################################
// FUNCTION : linkfooterchild($lid)
// ######################################################################
function linkfooterchild($lid) {
    include("modules/Web_Links/l_config.php");
    if ($useoutsidevoting = 1) {
        echo "<br><font class=\"content\">"._ISTHISYOURSITE." <a href=\"modules.php?name=Web_Links&l_op=outsidelinksetup&amp;lid=$lid\">"._ALLOWTORATE."</a></font>";
    }
}

// ######################################################################
// FUNCTION : completevoteheader()
// ######################################################################
function completevoteheader() {
    menu(1);
    echo "<br>";
    OpenTable();
}

// ######################################################################
// FUNCTION : completevotefooter($lid, $ttitle, $ratinguser)
// ######################################################################
function completevotefooter($lid, $ttitle, $ratinguser) {
    global $prefix, $db;
    include("modules/Web_Links/l_config.php");
    $result=$db->sql_query("select url FROM ".$prefix."_links_links WHERE lid=$lid");
    list($url)=$db->sql_fetchrow($result);
    echo "<font class=\"content\">"._THANKSTOTAKETIME." $sitename. "._LETSDECIDE."</font><br><br><br>";
    if ($ratinguser=="outside") {
        echo "<center><font class=\"content\">".WEAPPREACIATE." $sitename!<br><a href=\"$url\">"._RETURNTO." $ttitle</a></font><center><br><br>";
        $result=$db->sql_query("select title FROM ".$prefix."_links_links where lid=$lid");
        list($title)=$db->sql_fetchrow($result);
        $ttitle = ereg_replace (" ", "_", $title);
    }
    echo "<center>";
    linkinfomenu($lid,$ttitle);
    echo "</center>";
    CloseTable();
}

// ######################################################################
// FUNCTION : completevote($error)
// ######################################################################
function completevote($error) {
    include("modules/Web_Links/l_config.php");
    if ($error == "none") echo "<center><font class=\"content\"><b>"._COMPLETEVOTE1."</b></font></center>";
    if ($error == "anonflood") echo "<center><font class=\"option\"><b>"._COMPLETEVOTE2."</b></font></center><br>";
    if ($error == "regflood") echo "<center><font class=\"option\"><b>"._COMPLETEVOTE3."</b></font></center><br>";
    if ($error == "postervote") echo "<center><font class=\"option\"><b>"._COMPLETEVOTE4."</b></font></center><br>";
    if ($error == "nullerror") echo "<center><font class=\"option\"><b>"._COMPLETEVOTE5."</b></font></center><br>";
    if ($error == "outsideflood") echo "<center><font class=\"option\"><b>"._COMPLETEVOTE6."</b></font></center><br>";
}

// ######################################################################
// FUNCTION : addrating($ratinglid, $ratinguser, $rating, $ratinghost_name, $ratingcomments)
// ######################################################################
function addrating($ratinglid, $ratinguser, $rating, $ratinghost_name, $ratingcomments) {
    global $prefix, $db, $cookie, $user;
    $passtest = "yes";
    include("header.php");
    include("modules/Web_Links/l_config.php");
    title("$sitename: "._WEBLINKS."");
    completevoteheader();
    if(is_user($user)) {
        $user2 = base64_decode($user);
           $cookie = explode(":", $user2);
        cookiedecode($user);
        $ratinguser = $cookie[1];
    } else if ($ratinguser=="outside") {
        $ratinguser = "outside";
    } else {
        $ratinguser = "$anonymous";
    }
    $results3 = $db->sql_query("SELECT title FROM ".$prefix."_links_links WHERE lid=$ratinglid");
    while(list($title)=$db->sql_fetchrow($results3))
    $ttitle = $title;
    /* Make sure only 1 anonymous from an IP in a single day. */
    $ip = $_SERVER["REMOTE_HOST"];
    if (empty($ip)) {
       $ip = $_SERVER["REMOTE_ADDR"];
    }
    /* Check if Rating is Null */
    if ($rating=="--") {
        $error = "nullerror";
        completevote($error);
        $passtest = "no";
    }
    /* Check if Link POSTER is voting (UNLESS Anonymous users allowed to post) */
    if ($ratinguser != $anonymous && $ratinguser != "outside") {
            $result=$db->sql_query("select submitter from ".$prefix."_links_links where lid=$ratinglid");
            while(list($ratinguserDB)=$db->sql_fetchrow($result)) {
                if ($ratinguserDB==$ratinguser) {
                    $error = "postervote";
                    completevote($error);
                $passtest = "no";
                }
           }
    }
    /* Check if REG user is trying to vote twice. */
    if ($ratinguser!=$anonymous && $ratinguser != "outside") {
            $result=$db->sql_query("select ratinguser from ".$prefix."_links_votedata where ratinglid=$ratinglid");
            while(list($ratinguserDB)=$db->sql_fetchrow($result)) {
                if ($ratinguserDB==$ratinguser) {
                    $error = "regflood";
                completevote($error);
                $passtest = "no";
            }
        }
    }
    /* Check if ANONYMOUS user is trying to vote more than once per day. */
    if ($ratinguser==$anonymous){
            $yesterdaytimestamp = (time()-(86400 * $anonwaitdays));
            $ytsDB = Date("Y-m-d H:i:s", $yesterdaytimestamp);
            $result=$db->sql_query("select * FROM ".$prefix."_links_votedata WHERE ratinglid=$ratinglid AND ratinguser='$anonymous' AND ratinghostname = '$ip' AND TO_DAYS(NOW()) - TO_DAYS(ratingtimestamp) < $anonwaitdays");
        $anonvotecount = $db->sql_numrows($result);
            if ($anonvotecount >= 1) {
                $error = "anonflood";
            completevote($error);
                $passtest = "no";
            }
    }
    /* Check if OUTSIDE user is trying to vote more than once per day. */
    if ($ratinguser=="outside"){
            $yesterdaytimestamp = (time()-(86400 * $outsidewaitdays));
            $ytsDB = Date("Y-m-d H:i:s", $yesterdaytimestamp);
            $result=$db->sql_query("select * FROM ".$prefix."_links_votedata WHERE ratinglid=$ratinglid AND ratinguser='outside' AND ratinghostname = '$ip' AND TO_DAYS(NOW()) - TO_DAYS(ratingtimestamp) < $outsidewaitdays");
        $outsidevotecount = $db->sql_numrows($result);
            if ($outsidevotecount >= 1) {
                $error = "outsideflood";
            completevote($error);
                $passtest = "no";
            }
    }
    /* Passed Tests */
    if ($passtest == "yes") {
            $comment = stripslashes(FixQuotes($comment));
            /* All is well.  Add to Line Item Rate to DB. */
         $db->sql_query("INSERT into ".$prefix."_links_votedata values (NULL,'$ratinglid', '$ratinguser', '$rating', '$ip', '$ratingcomments', now())");
        /* All is well.  Calculate Score & Add to Summary (for quick retrieval & sorting) to DB. */
        /* NOTE: If weight is modified, ALL links need to be refreshed with new weight. */
        /*         Running a SQL statement with your modded calc for ALL links will accomplish this. */
        $voteresult = $db->sql_query("select rating, ratinguser, ratingcomments FROM ".$prefix."_links_votedata WHERE ratinglid = $ratinglid");
        $totalvotesDB = $db->sql_numrows($voteresult);
        include ("modules/Web_Links/voteinclude.php");
        $db->sql_query("UPDATE ".$prefix."_links_links SET linkratingsummary=$finalrating,totalvotes=$totalvotesDB,totalcomments=$truecomments WHERE lid = $ratinglid");
        $error = "none";
        completevote($error);
    }
    completevotefooter($ratinglid, $ttitle, $ratinguser);
    include("footer.php");
}

// ######################################################################
// FUNCTION : ratelink($lid, $user, $ttitle)
// ######################################################################
function ratelink($lid, $user, $ttitle) {
    include("header.php");
    menu(1);
    echo "<br>";
    OpenTable();
    $transfertitle = ereg_replace ("_", " ", $ttitle);
    $transfertitle = stripslashes($transfertitle);
    $displaytitle = $transfertitle;
    global $prefix, $db, $cookie, $datetime;
    $ip = $_SERVER["REMOTE_HOST"];
    if (empty($ip)) {
       $ip = $_SERVER["REMOTE_ADDR"];
    }
    echo "<b>$displaytitle</b>"
        ."<ul><font class=\"content\">"
        ."<li>"._RATENOTE1.""
        ."<li>"._RATENOTE2.""
        ."<li>"._RATENOTE3.""
        ."<li>"._RATENOTE4.""
        ."<li>"._RATENOTE5."";
    if(is_user($user)) {
            $user2 = base64_decode($user);
           $cookie = explode(":", $user2);
        echo "<li>"._YOUAREREGGED.""
            ."<li>"._FEELFREE2ADD."";
        cookiedecode($user);
        $auth_name = $cookie[1];
    } else {
        echo "<li>"._YOUARENOTREGGED.""
            ."<li>"._IFYOUWEREREG."";
        $auth_name = "$anonymous";
    }
    echo "</ul>"
            ."<form method=\"post\" action=\"modules.php?name=Web_Links\">"
        ."<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\" width=\"100%\">"
        ."<tr><td width=\"25\" nowrap></td>"
        ."<tr><td width=\"25\" nowrap></td><td width=\"550\">"
        ."<input type=\"hidden\" name=\"ratinglid\" value=\"$lid\">"
        ."<input type=\"hidden\" name=\"ratinguser\" value=\"$auth_name\">"
        ."<input type=\"hidden\" name=\"ratinghost_name\" value=\"$ip\">"
        ."<font class=content>"._RATETHISSITE.""
        ."<select name=\"rating\">"
        ."<option>--</option>"
        ."<option>10</option>"
        ."<option>9</option>"
        ."<option>8</option>"
        ."<option>7</option>"
        ."<option>6</option>"
        ."<option>5</option>"
        ."<option>4</option>"
        ."<option>3</option>"
        ."<option>2</option>"
        ."<option>1</option>"
        ."</select></font>"
        ."<font class=\"content\"><input type=\"submit\" value=\""._RATETHISSITE."\"></font>"
        ."<br><br>";
    if(is_user($user)) {
        echo "<b>"._SCOMMENTS.":</b><br><textarea wrap=\"virtual\" cols=\"50\" rows=\"10\" name=\"ratingcomments\"></textarea>"
             ."<br><br><br>"
                 ."</font></td>";
    } else {
        echo"<input type=\"hidden\" name=\"ratingcomments\" value=\"\">";
    }
    echo "</tr></table></form>";
    echo "<center>";
    linkfooterchild($lid);
    echo "</center>";
    CloseTable();
    include("footer.php");
}

if (isset($ratinglid) && isset ($ratinguser) && isset ($rating)) {
    $ret = addrating($ratinglid, $ratinguser, $rating, $ratinghost_name, $ratingcomments);
}

// ######################################################################
// FUNCTION : rateinfo($lid)
// ######################################################################
function rateinfo($lid) {
    global $prefix, $db;
    $db->sql_query("update ".$prefix."_links_links set hits=hits+1 where lid=$lid");
    $result = $db->sql_query("select url from ".$prefix."_links_links where lid=$lid");
    list($url) = $db->sql_fetchrow($result);
    Header("Location: $url");
}

// ######################################################################
// FUNCTION : brokenlink($lid)
// ######################################################################
function brokenlink($lid) {
    global $prefix, $db, $user, $module_name;
    if (is_user($user)) {
        include("header.php");
        include("modules/Web_Links/l_config.php");
        title("$sitename: "._WEBLINKS."");
        $user2 = base64_decode($user);
        $cookie = explode(":", $user2);
        cookiedecode($user);
        $ratinguser = $cookie[1];
        menu(1);
        echo "<br>";
        $result = $db->sql_query("select cid, title, url, description from ".$prefix."_links_links where lid=$lid");
        list($cid, $title, $url, $description) = $db->sql_fetchrow($result);
        OpenTable();
        echo "<center><font class=\"option\"><b>"._REPORTBROKEN."</b></font><br><br><br><font class=\"content\">";
        echo "<form action=\"modules.php?name=Web_Links\" method=\"post\">";
        echo "<input type=\"hidden\" name=\"lid\" value=\"$lid\">";
        echo "<input type=\"hidden\" name=\"cid\" value=\"$cid\">";
        echo "<input type=\"hidden\" name=\"title\" value=\"$title\">";
        echo "<input type=\"hidden\" name=\"url\" value=\"$url\">";
        echo "<input type=\"hidden\" name=\"description\" value=\"$description\">";
        echo "<input type=\"hidden\" name=\"modifysubmitter\" value=\"$ratinguser\">";
        echo ""._THANKSBROKEN."<br><br>";
        echo "<input type=\"hidden\" name=\"l_op\" value=\"brokenlinkS\"><input type=\"submit\" value=\""._REPORTBROKEN."\"></center></form>";
        CloseTable();
        include("footer.php");
    } else {
        Header("Location: modules.php?name=$module_name");
    }
}

// ######################################################################
// FUNCTION : brokenlinkS($lid,$cid, $title, $url, $description, $modifysubmitter)
// ######################################################################
function brokenlinkS($lid,$cid, $title, $url, $description, $modifysubmitter) {
    global $prefix, $db, $user, $module_name;
    if (is_user($user)) {
        include("modules/Web_Links/l_config.php");
            $user2 = base64_decode($user);
           $cookie = explode(":", $user2);
        cookiedecode($user);
        $ratinguser = $cookie[1];
        $db->sql_query("insert into ".$prefix."_links_modrequest values (NULL, $lid, $cid, 0, '$title', '$url', '$description', '$ratinguser', 1)");
        include("header.php");
        title("$sitename: "._WEBLINKS."");
        menu(1);
        echo "<br>";
        OpenTable();
        echo "<br><center>"._THANKSFORINFO."<br><br>"._LOOKTOREQUEST."</center><br>";
        CloseTable();
        include("footer.php");
    } else {
        Hader("Location: modules.php?name=$module_name");
    }
}

// ######################################################################
// FUNCTION : modifylinkrequest($lid)
// ######################################################################
function modifylinkrequest($lid) {
    include("header.php");
    include("modules/Web_Links/l_config.php");
    title("$sitename: "._WEBLINKS."");
    global $prefix, $db, $user;
    if(is_user($user)) {
            $user2 = base64_decode($user);
           $cookie = explode(":", $user2);
        cookiedecode($user);
        $ratinguser = $cookie[1];
    } else {
        $ratinguser = "$anonymous";
    }
    menu(1);
    echo "<br>";
    OpenTable();
    $blocknow = 0;
    if ($blockunregmodify == 1 && $ratinguser=="$anonymous") {
        echo "<br><br><center>"._ONLYREGUSERSMODIFY."</center>";
        $blocknow = 1;
    }
    if ($blocknow != 1) {
            $result = $db->sql_query("select cid, sid, title, url, description from ".$prefix."_links_links where lid=$lid");
            echo "<center><font class=\"option\"><b>"._REQUESTLINKMOD."</b></font><br><font class=\"content\">";
            while(list($cid, $sid, $title, $url, $description) = $db->sql_fetchrow($result)) {
                $title = stripslashes($title);
            $description = stripslashes($description);
                echo "<form action=\"modules.php?name=Web_Links\" method=\"post\">"
                .""._LINKID.": <b>$lid</b></center><br><br><br>"
                .""._LINKTITLE.":<br><input type=\"text\" name=\"title\" value=\"$title\" size=\"50\" maxlength=\"100\"><br><br>"
                .""._URL.":<br><input type=\"text\" name=\"url\" value=\"$url\" size=\"50\" maxlength=\"100\"><br><br>"
                .""._DESCRIPTION.": <br><textarea name=\"description\" cols=\"60\" rows=\"10\">$description</textarea><br><br>";
            $result2=$db->sql_query("select cid, title from ".$prefix."_links_categories order by title");
            echo "<input type=\"hidden\" name=\"lid\" value=\"$lid\">"
                ."<input type=\"hidden\" name=\"modifysubmitter\" value=\"$ratinguser\">"
                .""._CATEGORY.": <select name=\"cat\">";

        $result2=$db->sql_query("select cid, title, parentid from ".$prefix."_links_categories order by title");
        while(list($cid2, $ctitle2, $parentid2) = $db->sql_fetchrow($result2)) {
                if ($cid2==$cid) {
                        $sel = "selected";
                } else {
                        $sel = "";
                }
                if ($parentid2!=0) $ctitle2=getparent($parentid2,$ctitle2);
            echo "<option value=\"$cid2\" $sel>$ctitle2</option>";
        }
                echo "</select><br><br>"
                ."<input type=\"hidden\" name=\"l_op\" value=\"modifylinkrequestS\">"
                ."<input type=\"submit\" value=\""._SENDREQUEST."\"></form>";
            }
    }
    CloseTable();
    include("footer.php");
}

// ######################################################################
// FUNCTION : modifylinkrequestS($lid, $cat, $title, $url, $description, $modifysubmitter)
// ######################################################################
function modifylinkrequestS($lid, $cat, $title, $url, $description, $modifysubmitter) {
    include("modules/Web_Links/l_config.php");
    global $prefix, $db, $user;
    if(is_user($user)) {
        $user2 = base64_decode($user);
        $cookie = explode(":", $user2);
        cookiedecode($user);
        $ratinguser = $cookie[1];
    } else {
        $ratinguser = "$anonymous";
    }
    $blocknow = 0;
    if ($blockunregmodify == 1 && $ratinguser=="$anonymous") {
        include("header.php");
        title("$sitename: "._WEBLINKS."");
        menu(1);
        echo "<br>";
        OpenTable();
        //@RJR-Pwmg@Rncvkpwo@-@Eqratkijv@(e)@VgejIHZ.eqo
        echo "<center><font class=\"content\">"._ONLYREGUSERSMODIFY."</font></center>";
        $blocknow = 1;
        CloseTable();
        include("footer.php");
    }
    if ($blocknow != 1) {
            $cat = explode("-", $cat);
            if ($cat[1]=="") {
                $cat[1] = 0;
            }
            $title = stripslashes(FixQuotes($title));
            $url = stripslashes(FixQuotes($url));
            $description = stripslashes(FixQuotes($description));
            $db->sql_query("insert into ".$prefix."_links_modrequest values (NULL, $lid, $cat[0], $cat[1], '$title', '$url', '$description', '$ratinguser', 0)");
            include("header.php");
            title("$sitename: "._WEBLINKS."");
        menu(1);
        echo "<br>";
        OpenTable();
            echo "<center><font class=\"content\">"._THANKSFORINFO." "._LOOKTOREQUEST."</font></center>";
            CloseTable();
        include("footer.php");
    }
}

// ######################################################################
// SWITCHBOARD
// ######################################################################

switch($l_op) {

    case "menu":
    menu($mainlink);
    break;

    case "AddLink":
    AddLink();
    break;

    case "NewLinks":
    require_once("new.php");
    NewLinks($newlinkshowdays);
    break;

    case "NewLinksDate":
    require_once("new.php");
    NewLinksDate($selectdate);
    break;

    case "TopRated":
    require_once("top.php");
    TopRated($ratenum, $ratetype);
    break;

    case "MostPopular":
    require_once("pop.php");
    MostPopular($ratenum, $ratetype);
    break;

    case "RandomLink":
    RandomLink();
    break;

    case "viewlink":
    require_once("view.php");
    viewlink($cid, $min, $orderby, $show);
    break;

    case "brokenlink":
    brokenlink($lid);
    break;

    case "modifylinkrequest":
    modifylinkrequest($lid);
    break;

    case "modifylinkrequestS":
    modifylinkrequestS($lid, $cat, $title, $url, $description, $modifysubmitter);
    break;

    case "brokenlinkS":
    brokenlinkS($lid,$cid, $title, $url, $description, $modifysubmitter);
    break;

    case "visit":
    visit($lid);
    break;

    case "Add":
    Add($title, $url, $auth_name, $cat, $description, $email);
    break;

    case "search":
    require_once("search.php");
    search($query, $min, $orderby, $show);
    break;

    case "rateinfo":
    rateinfo($lid, $user, $title);
    break;

    case "ratelink":
    ratelink($lid, $user, $ttitle);
    break;

    case "addrating":
    addrating($ratinglid, $ratinguser, $rating, $ratinghost_name, $ratingcomments, $user);
    break;

    case "viewlinkcomments":
    require_once("comments.php");
    viewlinkcomments($lid, $ttitle);
    break;

    case "outsidelinksetup":
    require_once("outside.php");
    outsidelinksetup($lid);
    break;

    case "viewlinkeditorial":
    require_once("editorial.php");
    viewlinkeditorial($lid, $ttitle);
    break;

    case "viewlinkdetails":
    require_once("details.php");
    viewlinkdetails($lid, $ttitle);
    break;

    default:
    index();
    break;

}

?>