<?php

/**************************************************************************/
/* PHP-NUKE: Advanced Content Management System                           */
/* ============================================                           */
/*                                                                        */
/* This is the language module with all the system messages               */
/*                                                                        */
/* If you made a translation, please go to my website and send to me      */
/* the translated file. Please keep the original text order by modules,   */
/* and just one message per line, also double check your translation!     */
/*                                                                        */
/* You need to change the second quoted phrase, not the capital one!      */
/*                                                                        */
/* If you need to use double quotes (") remember to add a backslash (\),  */
/* so your entry will look like: This is \"double quoted\" text.          */
/* And, if you use HTML code, please double check it.                     */
/**************************************************************************/
/* PHP-Nuke Platinum: Expect to be impressed                    COPYRIGHT */
/*                                                                        */
/* Copyright (c) 2004 - 2006 by http://www.techgfx.com                    */
/*     Techgfx - Graeme Allan                         (goose@techgfx.com) */
/*                                                                        */
/* Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de              */
/*     MrFluffy - Axel Conrads                   (axel@conrads-berlin.de) */
/*                                                                        */
/* Refer to TechGFX.com for detailed information on PHP-Nuke Platinum     */
/*                                                                        */
/* TechGFX: Your dreams, our imagination                                  */
/**************************************************************************/
/* Pour le module Scrolling-Messages v0.2 */
define("_MESSAGE","Message"); 
define("_VALIDATE","Submit");
define("_CONFIG","Configuration");
define("_SCROLLINGDIRECTION","Scrolling Direction");
define("_SCROLLING","Scrolling News");
define("_NBRMESSAGESSHOWN","Number of Messages to Display" );
define("_ORDRE","Display Order");
define("_SPEED","Speed Display"); 
define("_CANCEL","Cancel"); 

/*****************************************************/
/* From file : admin/modules/cblocks.php             */
/*****************************************************/
define("_CB_CONTENT","Content");
define("_CB_BLOCKS","Center Blocks");
define("_CB_ADMIN","Center Block Administration");
define("_CB_ADMIN1","Center Block Top Administration");
define("_CB_ADMIN2","Center Block Bottom Administration");
define("_CB_CONFIG","Center Block Configuration");
define("_CB_CONFIG1","Center Block Top Configuration");
define("_CB_CONFIG2","Center Block Bottom Configuration");
define("_CB_ACTIVE","Activate Center Blocks");
define("_CB_NUMBER","Number of blocks to include");
define("_CB_HEIGHT","Minimum Center Block Height");
define("_CB_LIST1","Center Block Top List");
define("_CB_LIST2","Center Block Bottom List");
define("_CB_BLOCK","Block");
define("_CB_TITLE","Title");
define("_CB_FILENAME","Filename");
define("_CB_NONE","None");
define("_CB_SPEC","Width Type");
define("_CB_PIX","Pixels");
define("_CB_PER","Percent");
define("_CB_WID","Width");
define("_CB_SAVE","    Save Settings    ");

/* For a new installation only!, to upgrade v2.0 -> v2.1, go to corresponding folder !*/
/* Add these lines at the end of the file /admin/languages/lang-english.php */
define("_SOMMAIRE","Menu");
define("_SOMADMINTITLE","Administration Menu");
define("_SOMMSGNOTNUM","The value of this field must be numeric, please modify.");
define("_SOMMSGVOID","You must enter a value for this field !");
define("_SOMATTNSUPPRCAT","Attention&nbsp;!!&nbsp;&nbsp; You cannot cancel if you delete a category ! (The 'Cancel' button does not re-create the deleted category)");
define("_SOMWEIGHT","Weight");
define("_SOMCATEGORIES","Categories");
define("_SOMCATNAME","Category's name");
define("_SOMIMGNAME","Image file's name");
define("_SOMCATLINK","Link on this category");
define("_SOMCATMODS","Modules in this category");
define("_SOMNOIMG","[No image]");
define("_SOMHR","Horizontal rule");
define("_SOMCENTER","Center title");
define("_SOMBGCOLOR","Background color");
define("_SOMEXTLINK","External link");
define("_SOMMISEENPAGE","Display");
define("_TARGETBLANK","Open in a new window");
define("_SOMACTION","Action");
define("_SOMSUPPR","[Delete]");
define("_SOMADDCAT","Add a new category");
define("_SOMNEWCATEGORY","Add a new category :");
define("_SOMCANCEL","CANCEL");
define("_SOMPOST","SAVE YOUR MODIFICATIONS");
define("_SOMREMARKS","<strong>Remarks :</strong><br><br>"
	."- The WEIGHT is used to order categories (categories with a lower WEIGHT are displayed first). [number between 0 and 98]<br><br>"
	."- You can create a category without a name : in this case, the image will not be displayed.<br>"
	."&nbsp;&nbsp;(useful if you are using only horizontal rules to separate categories)<br><br>"
	."- The IMAGE FILE'S NAME (for the category) is an image file inside /images/sommaire/. You can also put a FLASH file (.swf)."
	."<br>&nbsp;&nbsp;The IMAGE (for category's content) is an image file inside /images/sommaire/categories/."
	."<br>&nbsp;&nbsp;When you add an image file in these folders, it is automatically added in its list box.<br>"
	."&nbsp;&nbsp;If you don't want to display an image before a category's name, put 'null.gif' (transparent 20x20 px image) in the field.<br><br>"
	."- THE LINK ON THE CATEGORY could be any internet url or an url relative to your site.<br>"
	."&nbsp;&nbsp;If you put an external link (beginnning with 'http://' or 'ftp://'), the link will be opened in a new window.<br>"
	."&nbsp;&nbsp;If you put a relative url ('modules.php?name=Your_Account&op=new_user'), the link will open in the current window.<br>"
	."&nbsp;&nbsp;To open an internal link in a new window, put the exact, full  url of your site.<br>"
	."&nbsp;&nbsp;To open an external link in the current window, type 'HTTP://' (in uppercase).<br><br>"
	."- The BACKGROUND COLOR must be a color code or a standard color name.<br>"
	."&nbsp;&nbsp;ex: 'red' : <font color=\"red\">RED</font>  --  '#ff0000' : <font color=\"#ff0000\">RED</font><br><br>"
	."- The CLASS used to display categories' names msut be an existing class in all your themes.<br>"
	."&nbsp;&nbsp;The classes are in the file /themes/YOURTHEME/style/style.css.<br>"
	."&nbsp;&nbsp;You can add your own class, for example you can add this line in the style sheets of your themes :<br>"
	."&nbsp;&nbsp;<i>.sommaire		{FONT-FAMILY: Verdana,Helvetica; FONT-SIZE: 12px; COLOR: #363636; FONT-WEIGHT: bold}   </i><br>");
define("_SOMCATCONTENT","Category's content");
define("_SOMLINKURL","link's URL");
define("_SOMLINKTEXT","link's text");
define("_SOMIMAGE","Image");
define("_SOMINVALIDWEIGHT","The WEIGHT value is invalid for the category");
define("_SOMMUSTBENUM"," This value MUST be a number between 0 and 98 !!");
define("_SOMCATS","The categories");
define("_SOMAND","and");
define("_SOMSAMEWEIGHT","have the same WEIGHT !!");
define("_SOMMODIFWEIGHT","Return back to the previous page and modify the WEIGHT value of one of these categories.");
define("_SOMBACKADMIN","Back to Menu administration");
define("_SOMSUCCESS","Your block has been successfully updated !");
define("_SOMGOADMIN","Configure your Menu");
define("_SOMUPGRADESUCCESS","Your Menu was successfully upgraded !!");
define("_SOMV1DETECTED","Sommaire parametrable v.1.0 detected !");
define("_SOMCLICKTOUPGRADE","To upgrade your menu, click");
define("_SOMHERE","HERE");
define("_SOMWARNINGDELETECAT","Are you sure you want to delete the category");
define("_SOMGENERALOPTIONS","General Options");
define("_SOMDISPLAYMEMBERSONLYMODULES","Display of 'members only' modules");
define("_SOMCATEGORIESCLASS","Class for categories' names");
define("_SOMDISPLAYMODULENORMAL","Normal (always displayed)");
define("_SOMDISPLAYMODULEWITHICON","Displayed with icon");
define("_SOMDISPLAYMODULEWITHICONFORVISTORS","for visitors");
define("_SOMDISPLAYMODULEINVISIBLE","Invisible for visitors");
define ("_SOMYES","Yes");
define ("_SOMNO","No");
define("_SOMMAIREREMARKSTWO","<br>- You can create a popup, to do so, enter in the field 'url' of external link :<br>"
		."&nbsp;&nbsp;<i>javascript:window.open('http://www.url.com','popup_sommaire','directories=no,menubar=no,status=no,location=no,scrollbars=no,resizable=no')</i><br>"
		."<br>&nbsp;&nbsp;You can modify display options (display scrollbars, etc...)<br>"
		."&nbsp;&nbsp;See <a href=\"http://www.toutjavascript.com/savoir/savoir15.php3\">Tout Javascript - les popups</a> for more details.<br><br>");
define("_SOMMAIREHR","Horiz. rule");
define("_SOMBOLD","Bold");
define("_SOMLISTBOX","Drop down box");
define("_SOMSENDTOHAVEMORE","Save your modifications to add new links.");
define("_SOMDISPLAYCLASSES","Display :");
define("_SOMMODULESCLASS","CSS class used for modules/external links");
define("_SOMAUTODETECTNEW","Automatic detection of news");
define("_SOMSINCE","New for");
define("_SOMNBDAYS","days");
define("_SOMDYNAMICMENU","Dynamic menu");
define("_SOMJSSAVEBEFORE","Do you want to save your modifications before deleting this category ?");
define("_SOMEDITLINKTITLE","Edit a link...");
define("_SOMMOREOPTIONS","More options");
define("_SOMCLASS","CSS class");
define("_SOMATTENTIONMOREOPTIONS","<strong>Attention !</strong><br>If you modify in sommaire's admin panel the general CSS class for categories, or for modules/links, or the time 'New!' icon is displayed, the specific values of a category or a module/link will be overwritten.");
define("_SOMMOREOPTIONSUCCESS","Your modifications are applied !");
define("_SOMSENDTOVALIDATE","(You should validate all modifications in the main sommaire panel for your modifications to be finally confirmed)");
define("_SOMCLOSE","Close the window");
define("_SOMTARGETBLANK","Link opened in a new window. To open in the same window, begin url with HTTP:// (uppercase)");
define("_SOMTARGETNONE","Link opened in the same window. To open in a new window, begin url with http:// (lowercase)");
define("_SOMNOTABLEPB","Sommaire Parametrable is unable to access its database tables.Please verify that you have installed correctly, and READ THE FAQ !");
/* End of Sommaire Paramtrable v2.1 modifications */

/********************* Nouvelles Dfinitions : NukeClan 1.0.6 *************/
define("_DEFIRECRUTEMENT","Challenge & Recrutment");
define("_CHARTE","Chart");
define("_MATCHS","Matchs");
define("_RANKTITLE","Player Ranks & Tags");
define("_MEMBRESTEAMS","Members & Teams");
define("_LESTRAINS","Trainings");
define("_CALENDAR","Calendar");
define("_COTISATIONS","Contributions");
define("_MVTEAMS","Teams Only");
define("_WHATTEAMS","What Teams ?");
define("_WHATGRDESC","What Teams ?");
define("_TEAMSPEAK","Teamspeak");
define("_TOURNOIS","Tournaments");
define("_MIRCMOD","IRC Module");
/**************************************************************************/

define("_BANINDEX","Ban Request");
define("_DOWNLOAD","Downloads");
define("_ENCYCLOPEDIA","Encyclopedia");
define("_FAQ","F.A.Q.");
define("_NEWS","News");
define("_REVIEWS","Reviews");
define("_ADMPOLLS","Survey / Polls");
define("_TOPICS","Topics");
define("_WEBLINKS","Web Links");
define("_SEND","Send");
define("_URL","URL");
define("_EMAIL","Email");
define("_FUNCTIONS","Functions");
define("_YES","Yes");
define("_NO","No");
define("_REQUIRED","(required)");
define("_SAVECHANGES","Save Changes");
define("_OK","Ok!");
define("_SAVE","Save");
define("_ID","ID");
define("_SUBJECT","Subject");
define("_WHOSONLINE","Who's Online");
define("_ARTICLES","Articles");
define("_ALL","All");
define("_PREVIEW","Preview");
define("_EXTRAINFO","Extra Info");
define("_YOUARELOGGEDOUT","You are now logged out!");
define("_HOMECONFIG","Home Configuration");
define("_DESCRIPTION","Description");
define("_HOMEPAGE","HomePage");
define("_NAME","Name");
define("_FROM","From");
define("_TO","To");
define("_SUBMIT","Submit");
define("_SHOW","Show");
define("_DAYS","days");
define("_STAFF","Staff");
define("_ADMINID","Admin ID");
define("_ADMINLOGIN","Administration System Login");
define("_EDITADMINS","Edit Admins");
define("_PREFERENCES","Site Configuration");
define("_ADMINMENU","Administration Menu");
define("_BANNERSADMIN","Banners Administration");
define("_ADMINLOGOUT","Logout / Exit");
define("_LAST","Last");
define("_GO","Go!");
define("_CURRENTPOLL","Current Poll");
define("_STORYID","Story ID");
define("_REMOVECOMMENTS","Delete Comments");
define("_SURETODELCOMMENTS","Are you sure you want to delete selected Comment and all its replies?");
define("_BLOCKSADMIN","Blocks Administration");
define("_BLOCKS","Blocks");
define("_TITLE","Title");
define("_POSITION","Position");
define("_WEIGHT","Weight");
define("_STATUS","Status");
define("_LEFTBLOCK","Left Block");
define("_LEFT","Left");
define("_RIGHTBLOCK","Right Block");
define("_RIGHT","Right");
define("_ACTIVE","Active");
define("_DEACTIVATE","Deactivate");
define("_INACTIVE","Inactive");
define("_ACTIVATE","Activate");
define("_TYPE","Type");
define("_ADDNEWBLOCK","Add a New Block");
define("_RSSFILE","RSS/RDF file URL");
define("_ONLYHEADLINES","(Only for Headlines)");
define("_CONTENT","Content");
define("_ACTIVATE2","Activate:");
define("_REFRESHTIME","Refresh Time");
define("_HOUR","Hour");
define("_CREATEBLOCK","Create Block");
define("_EDITBLOCK","Edit Block");
define("_BLOCK","Block");
define("_SAVEBLOCK","Save Block");
define("_BLOCKACTIVATION","Block Activation");
define("_BLOCKPREVIEW","This is the preview for Block");
define("_WANT2ACTIVATE","Do you want to Activate this block?");
define("_ARESUREDELBLOCK","Are you sure you want to remove Block");
define("_RSSFAIL","There is a problem with the RSS file URL");
define("_RSSTRYAGAIN","Please check the URL and RSS file name, then try again.");
define("_RSSCONTENT","(RSS/RDF Content)");
define("_IFRSSWARNING","If you fill the URL the content you write will not be displayed!");
define("_BLOCKUP","Block UP");
define("_BLOCKDOWN","Block DOWN");
define("_SETUPHEADLINES","(Select Custom and write the URL or just select a Site from the list to grab news headlines)");
define("_HEADLINESADMIN","Headlines Administration");
define("_ADDHEADLINE","Add Headline");
define("_EDITHEADLINE","Edit Headlines");
define("_SURE2DELHEADLINE","WARNING: Are you sure you want to delete this Headline?");
define("_CUSTOM","Custom");
define("_AUTHORSADMIN","Author's Administration");
define("_MODIFYINFO","Modify Info");
define("_DELAUTHOR","Delete Author");
define("_ADDAUTHOR","Add a New Administrator");
define("_PERMISSIONS","Permissions");
define("_USERS","Users");
define("_SUPERUSER","Super User");
define("_SUPERWARNING","WARNING: If Super User is checked, the user will get full access!");
define("_ADDAUTHOR2","Add Author");
define("_RETYPEPASSWD","Retype Password");
define("_FORCHANGES","(For Changes Only)");
define("_COMPLETEFIELDS","You must complete all compulsory fields");
define("_CREATIONERROR","Author's Creation Error");
define("_AUTHORDELSURE","Are you sure you want to delete");
define("_AUTHORDEL","Delete Autor");
define("_REQUIREDNOCHANGE","(required, can't be changed later)");
define("_PUBLISHEDSTORIES","This administrator has published stories");
define("_SELECTNEWADMIN","Please select a new admin to re-assign them");
define("_GODNOTDEL","*(GOD account can't be deleted)");
define("_MAINACCOUNT","God Admin*");
define("_ADD","Add");
define("_DAY","Day");
define("_AUTOMATEDARTICLES","Programmed Articles");
define("_NOAUTOARTICLES","There are no programmed articles");
define("_WARNING","Warning");
define("_NOFUNCTIONS","---------");
define("_WHOLINKS","Who's linking our site?");
define("_DELETEREFERERS","Delete Referers");
define("_SITENAME","Site Name");
define("_PASSWDNOMATCH","Sorry, the new passwords doesn't match. Go Back and Try Again");
define("_SITECONFIG","Web Site Configuration");
define("_GENSITEINFO","General Site Info");
define("_SITEURL","Site URL");
define("_SITELOGO","Site Logo");
define("_SITESLOGAN","Site Slogan");
define("_ADMINEMAIL","Administrator Email");
define("_ITEMSTOP","Number of Items in Top Page");
define("_STORIESHOME","Stories Number in Home");
define("_OLDSTORIES","Stories in Old Articles Box");
define("_ACTULTRAMODE","Activate Ultramode?");
define("_DEFAULTTHEME","Default Theme for your site");
define("_SELLANGUAGE","Select the Language for your Site");
define("_LOCALEFORMAT","Locale Time Format");
define("_BANNERSOPT","Banners Options");
define("_STARTDATE","Site Start Date");
define("_ACTBANNERS","Activate Banners in your site?");
define("_FOOTERMSG","Footer Messages");
define("_FOOTERLINE1","Footer Line 1");
define("_FOOTERLINE2","Footer Line 2");
define("_FOOTERLINE3","Footer Line 3");
define("_BACKENDCONF","Backend Configuration");
define("_BACKENDTITLE","Backend Title");
define("_BACKENDLANG","Backend Language");
define("_MAIL2ADMIN","Mail New Stories to Admin");
define("_NOTIFYSUBMISSION","Notify new submissions by email?");
define("_EMAIL2SENDMSG","Email to send the message");
define("_EMAILSUBJECT","Email Subject");
define("_EMAILMSG","Email Message");
define("_EMAILFROM","Email Account (From)");
define("_COMMENTSMOD","Comments Moderation");
define("_MODTYPE","Type of Moderation");
define("_MODADMIN","Moderation by Admin");
define("_MODUSERS","Moderation by Users");
define("_NOMOD","No Moderation");
define("_COMMENTSOPT","Comments Option");
define("_COMMENTSLIMIT","Comments Limit in Bytes");
define("_ANONYMOUSNAME","Anonymous Default Name");
define("_GRAPHICOPT","Graphics Options");
define("_ADMINGRAPHIC","Graphics in Administration Menu?");
define("_MISCOPT","Miscelaneous Options");
define("_PASSWDLEN","Minimum users password length");
define("_MAXREF","How Many Referers you want as Maximum?");
define("_COMMENTSPOLLS","Activate Comments in Polls?");
define("_ALLOWANONPOST","Allow Anonymous to Post?");
define("_ACTIVATEHTTPREF","Activate HTTP Referers?");
define("_SIZE","Size");
define("_MESSAGES","Welcome Messages");
define("_MESSAGESADMIN","Messages Administration");
define("_MESSAGETITLE","Title");
define("_MESSAGECONTENT","Content");
define("_EXPIRATION","Expiration");
define("_VIEWPRIV","Who can View This:");
define("_MVADMIN","Administrators Only");
define("_MVUSERS","Registered Users Only");
define("_MVANON","Anonymous Users Only");
define("_MVALL","All Visitors");
define("_CHANGEDATE","Change start date to today?");
define("_IFYOUACTIVE","(If you Active this Message now, the start date will be today)");
define("_FILENAME","Filename");
define("_FILEINCLUDE","(Select a custom Block to be included. All other fields will be ignored)");
define("_BLOCKFILE","(Block File)");
define("_COMMENTSARTICLES","Activate Comments in Articles?");
define("_MULTILINGUALOPT","Multilingual Options");
define("_ACTMULTILINGUAL","Activate Multilingual features? ");
define("_ACTUSEFLAGS","Display flags instead of a dropdown box? ");
define("_LANGUAGE","Language");
define("_EDITMSG","Edit message");
define("_ADDMSG","Add message");
define("_ALLMESSAGES","Overview messages");
define("_VIEW","Visible to");
define("_REMOVEMSG","Are you sure you want to remove this message ? ");
define("_MODULES","Modules");
define("_MODULESADMIN","Modules Administration");
define("_MODULESADDONS","Modules and Addons");
define("_MODULESACTIVATION","See your Modules/Addons current status and change it by Activating or Deactivating them.<br>New Modules copied on the <i>/modules/</i> directory will be automaticaly added with <i>Inactive</i> status to the database when you reload this page.<br>If you want to remove a module just delete it from the <i>/modules/</i> directory, the system will automaticaly update your database to show the changes.");
define("_NEWSLETTER","Newsletter");
define("_MASSMAIL","A Massive e-mail to ALL users");
define("_ANEWSLETTER","A Newsletter to subscribed users only");
define("_WHATTODO","What do you want to send?");
define("_SUBSCRIBEDUSERS","Subscribed Users");
define("_NYOUAREABOUTTOSEND","You're about to send a Newsletter to subscribed users.");
define("_NUSERWILLRECEIVE","Users will receive this Newsletter.");
define("_REVIEWTEXT","Please review and check your text:");
define("_NAREYOUSURE2SEND","Are you sure to send this Newsletter now?");
define("_MYOUAREABOUTTOSEND","You're about to send a Massive e-mail to ALL registered users.");
define("_MUSERWILLRECEIVE","Users will receive this Mail.");
define("_MAREYOUSURE2SEND","Are you sure to send this Massive Email now?");
define("_POSSIBLESPAM","Please note that some users may feel disturbed by massive email and may consider this as Spam!");
define("_MASSEMAIL","Massive Email");
define("_MANYUSERSNOTE","WARNING! There are many users that will receive this text. Please wait until the script finish the operation. This can take some minutes to complete!");
define("_NLUNSUBSCRIBE","=========================================================\nYou're receiving this Newsletter because you selected to receive it from your user page at $sitename.\nYou can unsubscribe from this service by clicking in the following URL:\n\n$nukeurl/modules.php?name=Your_Account&op=edituser\"\n\nthen select \"No\" from the option to Receive Newsletter by Email and save your changes, if you need more assistance please contact $sitename administrator.");
define("_NEWSLETTERSENT","The Newsletter has been sent.");
define("_MASSEMAILSENT","Massive Email to all registered users has been sent.");
define("_MASSEMAILMSG","=========================================================\nYou're receiving this email because you're a registered user of $sitename. We hope that this email didn't disturbed you and in some manner contributes to improve our services.");
define("_FIXBLOCKS","Fix Block's Weight Conflicts");
define("_SAVEDATABASE","Database Backup");
define("_SAVEDATABASELINK","Backup Manager");
define("_DBOPTIMIZATION","Database Optimization");
define("_OPTIMIZINGDB","Optimizing the Database:");
define("_TABLE","Table");
define("_SPACESAVED","Space Saved");
define("_ALREADYOPTIMIZED","Already optimized");
define("_OPTIMIZED","Optimized!");
define("_OPTIMIZATIONRESULTS","Optimization Results");
define("_TOTALSPACESAVED","Total Space Saved:");
define("_YOUHAVERUNSCRIPT","You have run this script:");
define("_KBSAVED","Kb saved since its first execution!");
define("_TIMES","times");
define("_CUSTOMTITLE","Custom Title");
define("_CHANGEMODNAME","Change Module Name");
define("_CUSTOMMODNAME","Custom Module Name:");
define("_MODULEEDIT","Modules Edit");
define("_BLOCKFILE2","FILE");
define("_BLOCKSYSTEM","SYSTEM");
define("_DEFHOMEMODULE","Default Homepage Module");
define("_MODULEINHOME","Module Loaded in the Homepage:");
define("_CHANGE","Change");
define("_INHOME","In Home");
define("_MODULEHOMENOTE","<b>-= WARNING =-</b><br>Bold module's title represents the module you have in the Homepage.<br>You can't Deactivate or Restrict this module while it's the default one!<br>If you delete the module's directory you'll see and error in the Homepage.<br>Also, this module has been replaced with <i>Home</i> link in the modules block.");
define("_PUTINHOME","Put in Home");
define("_SURETOCHANGEMOD","Are you sure you want to change your Homepage from");
define("_CENTERBLOCK","Center Block");
define("_ADMINISTRATION","Administration");
define("_NOADMINYET","There are no Administrators Accounts yet, proceeed to create the Super User:");
define("_CREATEUSERDATA","Do you want to create a normal user with the same data?");
define("_NORMAL","Normal");
define("_INACTIVEBANNERS","Inactive Banners");
define("_CENTERUP","Center Up");
define("_CENTERDOWN","Center Down");
define("_NOTINMENU","[ <big><strong>&middot;</strong></big> ] means a module which name and link will not be visible in Modules Block");
define("_SHOWINMENU","Visible in Modules Block?");
define("_BANNERS","Banners");
define("_ALTTEXT","Alternate Text");
define("_MUSTBEINIMG","must be in /images/ directory. Valid only for AvantGo module");
define("_USERSOPTIONS","Users Options");
define("_BROADCASTMSG","Activate Broadcast Messages?");
define("_MYHEADLINES","Activate Headlines Reader?");
define("_USERSHOMENUM","Let users change News number in Home?");
define("_CENSOROPTIONS","Censure Options");
define("_CENSORMODE","Censor Mode");
define("_NOFILTERING","No filtering");
define("_EXACTMATCH","Exact match");
define("_MATCHBEG","Match word at the beginning");
define("_MATCHANY","Match anywhere in the text");
define("_CENSORREPLACE","Replace Censored Words with:");
define("_SECURITYCODE","Security Code");
define("_TYPESECCODE","Type Security Code Here");
define("_UGROUPS","Edit Points");
define("_POINTS","Points");
define("_USERSCOUNT","Users Count");
define("_ADDNEWGROUP","Add New Users Group");
define("_GTITLE","Group Name");
define("_POINTSNEEDED","Points Needed");
define("_ONLYNUMVAL","Use numeric values only");
define("_CREATEGROUP","Create This Group");
define("_NOGROUPS","There aren't any Users Group created at this time");
define("_POINTSSYSTEM","Points System");
define("_UPDATE","Update");
define("_EDITGROUP","Edit Users Group");
define("_SAVEGROUP","Save Group");
define("_GROUPSADMIN","Users Group Administration");
define("_GROUPADDERROR","Group Creation Error!");
define("_GROUPDELETE","Delete Users Group");
define("_SUREGRPDEL1","Are you sure you want to remove/delete the group?:");
define("_NONUMVALUE","The value of the Points isn't numeric. Go back and fix it.");
define("_GROUP","Group");
define("_UGROUP","Users Group");
define("_VALIDIFREG","Valid only if Registered Users are selected above");
define("_POINTS01","Journal Entry");
define("_DESC01","Personal user's Journal entry. Valid for publics and privates entries");
define("_POINTS02","Journal Comment");
define("_DESC02","Each comment posted in a public user's Journal");
define("_POINTS03","Recommendation to a Friend");
define("_DESC03","Each time a user send the link to our site to a friend via Recommend Us Module");
define("_POINTS04","News Submission Published");
define("_DESC04","News that the user sends from Submit News module and then published by the administrator");
define("_POINTS05","News Comment");
define("_DESC05","Comment published for any article and/or news");
define("_POINTS06","News Sent to a Friend");
define("_DESC06","Each article's or news has an option to send it to a friend. Points valid for each time the user sends the article to a friend");
define("_POINTS07","News Article Rating");
define("_DESC07","Each time a user votes for any article");
define("_POINTS08","Vote in Surveys");
define("_DESC08","Each vote registered for any survey, actual or old ones are valid");
define("_POINTS09","Comment in Surveys");
define("_DESC09","Comment published for any actual or old survey");
define("_POINTS10","Forum New Post");
define("_DESC10","Each time the user opens a new thread in the Forums");
define("_POINTS11","Forum Answer Post");
define("_DESC11","Forums threads answered or replied");
define("_POINTS12","Review Comment");
define("_DESC12","Comment published for any review in the Reviews module");
define("_POINTS13","Page View");
define("_DESC13","Get points for each page view generated by the user. Valid for any page of the site");
define("_POINTS14","Visit to a WebLink");
define("_DESC14","Each time a user clicks to visit any resource on WebLinks module");
define("_POINTS15","Rate to any WebLink");
define("_DESC15","Each time a user votes for a resource in WebLinks module");
define("_POINTS16","Comment to any WebLink");
define("_DESC16","Comments posted on any resource in the WebLink module");
define("_POINTS17","Download of a File");
define("_DESC17","Each time a user clicks to download any file or resource on Downloads module");
define("_POINTS18","Rate to any Download");
define("_DESC18","Each time a user votes for a resource in Downloads module");
define("_POINTS19","Comment to any Download");
define("_DESC19","Comments posted on any resource in the Downloads module");
define("_POINTS20","Broadcast Message");
define("_DESC20","Each time a user publish a public message using the Broadcast message system");
define("_POINTS21","Click on any Banner");
define("_DESC21","The best way to give back a user something is to give him some points for banner clicks on your site");
define("_AFTEREXPIRATION","After Expiration");
define("_SUBUSERS","Subscribed Users");
define("_SUBVISIBLE","Visible to Subscribers:");
define("_IPBANSYSTEM","IP Ban System");
define("_BANNEWIP","Ban a new IP Address");
define("_IPBANNED","Banned IP Addresses");
define("_BANDATE","Ban Date");
define("_UNBAN","UnBan");
define("_IPNUMERIC","And IP address should be numeric");
define("_IPENTERED","IP address entered:");
define("_ERROR","ERROR:");
define("_IPOUTRANGE","IP address is out of range");
define("_IPSTARTZERO","And IP address can't start with 0");
define("_IPLOCALHOST","You can't ban the localhost IP address");
define("_SUCCESS","Success!!");
define("_THEIP","The IP address");
define("_HASBEENBANNED","has been banned from this site");
define("_SURETOBANIP","Are you sure you want to UNBAN the following IP address:");
define("_IPYOURS","You can't ban your own IP address!");
define("_REASON","Reason");
define("_CATEGORY","Category");
define("_ADDMAINCATEGORY","Add a MAIN Category");
define("_MODCATEGORY","Modify a Category");

/*****************************************************/
/* Addon - Whos Online v.0.9.1                 START */
/*****************************************************/
define("_who0a","Who is Online");
define("_who00","<b>4n Who is online?</b><br><i>Version 0.91</i>");
define("_who01","Back to ");
define("_who02","Server Time: ");
define("_who03"," Users Currently Online");
define("_who04","Username");
define("_who05","IP-Adress");
define("_who06","Host Name");
define("_who07","Time Online");
define("_who08","Edit member");
define("_who09","Refresh");
define("_who10","From");
define("_who11","Newest member");
define("_who12","Number of members:");
define("_who13","Member Informations");
define("_who14","Guest");
define("_who15","Unknown domain");
define("_who16","Not a domain");
define("_who17","At this time there are");
define("_who18","Guest(s) and");
define("_who19","Member(s) online.");
define("_who20","Delete member");
define("_whocopy","4nWhoIsOnline by <a href=\"http://warpspeed.4thdimension.de\" target=\"_blank\">www.warp-speed.de</a> @ <a href=\"http://www.4thdimension.de\" target=\"_blank\">4thDimension.de</a> Networking.");
/*****************************************************/
/* Addon - Whos Online v.0.9.1                   END */
/*****************************************************/

/*****************************************************/
/* Addon - Blocks Manager v.1.0.0              START */
/*****************************************************/
define("_BLOCKS_MANAGER","Blocks Manager");
define("_BLOCKMGR","Management of the position of the blocks per module");
define("_BLOCKMGR_MODULEDROP","List blocks of the module :");
define("_BLOCKMGR_ADDNEWBLOCK","Add/Remove selected block(s) to/from select module(s)");
define("_BLOCKMGR_ACTIVE_BLOCKS","Inactive Blocks");
define("_BLOCKMGR_INACTIVE_BLOCKS","Avtive Blocks");
define("_BLOCKMGR_ADD_BLOCK","Add");
define("_BLOCKMGR_REMOVE_BLOCK","Remove");
define("_BLOCKMGR_TITLE","Title");
define("_BLOCKMGR_POSITION","Position");
define("_BLOCKMGR_WEIGHT","Weight");
define("_BLOCKMGR_STATUS","Status");
define("_BLOCKMGR_VIEW","Visible to");
define("_BLOCKMGR_LANGUAGE","Language");
define("_BLOCKMGR_LEFT","Left");
define("_BLOCKMGR_CENTERUP","Centre up");
define("_BLOCKMGR_CENTERDOWN","Centre down");
define("_BLOCKMGR_RIGHT","Right");
define("_BLOCKMGR_BLOCKUP","to go up");
define("_BLOCKMGR_BLOCKDOWN","to go down");
define("_BLOCKMGR_DEACTIVATE","Deactivate");
define("_BLOCKMGR_ACTIVATE","Activate");
define("_BLOCKMGR_INACTIVE","Inactive");
define("_BLOCKMGR_ACTIVE","Active");
/*****************************************************/
/* Addon - Blocks Manager v.1.0.0                END */
/*****************************************************/

/*****************************************************/
/* Module - NukeC v.3.0.0b2                    START */
/*****************************************************/
define("_NUKEC","NukeC 30<BR>Administration");
/*****************************************************/
/* Module - NukeC v.3.0.0b2                      END */
/*****************************************************/

/*****************************************************/
/* Addon - Conditional Blocks v.1.1.1          START */
/*****************************************************/
define("_WHERE","Location");
define("_WHERE2","Visible in which Modules:");
/*****************************************************/
/* Addon - Conditional Blocks v.1.1.1            END */
/*****************************************************/

?>
