<?php

/**************************************************************************/
/* PHP-NUKE: Advanced Content Management System                           */
/* ============================================                           */
/*                                                                        */
/* This is the language module with all the system messages               */
/*                                                                        */
/* If you made a translation, please go to my website and send to me      */
/* the translated file. Please keep the original text order by modules,   */
/* and just one message per line, also double check your translation!     */
/*                                                                        */
/* You need to change the second quoted phrase, not the capital one!      */
/*                                                                        */
/* If you need to use double quotes (") remember to add a backslash (\),  */
/* so your entry will look like: This is \"double quoted\" text.          */
/* And, if you use HTML code, please double check it.                     */
/**************************************************************************/
/* PHP-Nuke Platinum: Expect to be impressed                    COPYRIGHT */
/*                                                                        */
/* Copyright (c) 2004 - 2006 by http://www.techgfx.com                    */
/*     Techgfx - Graeme Allan                         (goose@techgfx.com) */
/*                                                                        */
/* Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de              */
/*     MrFluffy - Axel Conrads                   (axel@conrads-berlin.de) */
/*                                                                        */
/* Refer to TechGFX.com for detailed information on PHP-Nuke Platinum     */
/*                                                                        */
/* TechGFX: Your dreams, our imagination                                  */
/**************************************************************************/

/* Pour le module Scrolling-Messages v0.2 */
define("_MESSAGE","Message"); 
define("_VALIDATE","Valider");
define("_CONFIG","Configuration");
define("_SCROLLINGDIRECTION","Direction du Scrolling");
define("_SCROLLING","Scrolling News");
define("_NBRMESSAGESSHOWN","Nombre de Messages  Afficher" );
define("_ORDRE","Ordre d'affichage");
define("_SPEED","Vitesse d'affichage"); 
define("_CANCEL","Annuler"); 

/* Pour une nouvelle installation uniquement, si vous voulez upgrader v2.0 -> v2.1, consultez le rpertoire correspondant !*/
/* Ajouter ces lignes  la fin du fichier /admin/languages/lang-french.php */
/* Pour le module Sommaire Paramtrable */
define("_SOMMAIRE","Sommaire Paramtrable");
define("_SOMADMINTITLE","Administration Sommaire");
define("_SOMMSGNOTNUM","La valeur du champ saisi n'est pas numrique, veuillez la modifier");
define("_SOMMSGVOID","Veuillez entrer une valeur !");
define("_SOMATTNSUPPRCAT","Attention&nbsp;!!&nbsp;&nbsp; Supprimer une catgorie est dfinitif ! (Le bouton 'Annuler' ne recre pas la catgorie supprime)");
define("_SOMWEIGHT","Poids");
define("_SOMCATEGORIES","Catgories");
define("_SOMCATNAME","Nom de la catgorie");
define("_SOMIMGNAME","Nom du fichier image");
define("_SOMCATLINK","Lien sur la catgorie");
define("_SOMCATMODS","Modules dans cette catgorie");
define("_SOMNOIMG","[Pas d'image]");
define("_SOMHR","Barre horizontale");
define("_SOMCENTER","Centrer");
define("_SOMBGCOLOR","Couleur de fond");
define("_SOMEXTLINK","Lien externe");
define("_SOMMISEENPAGE","Mise en page");
define("_TARGETBLANK","Ouvrir dans une nouvelle page");
define("_SOMACTION","Action");
define("_SOMSUPPR","[Supprimer]");
define("_SOMADDCAT","Ajouter une catgorie");
define("_SOMNEWCATEGORY","Ajouter une nouvelle catgorie :");
define("_SOMCANCEL","ANNULER");
define("_SOMPOST","SAUVER LES MODIFICATIONS");
define("_SOMREMARKS","<strong>Remarques :</strong><br><br>"
	."- Le POIDS correspond  l'ordre d'affichage des catgories. [nombre entre 0 et 98]<br><br>"
	."- Vous pouvez crer une catgorie sans nom : dans ce cas, l'image ne sera pas affiche.<br>"
	."&nbsp;&nbsp;(utile par exemple si vous n'utilisez que les barres horizontales pour sparer les catgories)<br><br>"
	."- Le NOM DU FICHIER IMAGE (pour la catgorie) est une image prsente dans /images/sommaire/. Vous pouvez mettre un fichier FLASH .swf  la place."
	."<br>&nbsp;&nbsp;L'IMAGE (pour le contenu de la catgorie) est une image prsente dans /images/sommaire/categories/."
	."<br>&nbsp;&nbsp;Quand vous ajoutez une image dans ces rpertoires, elle est ajoute dans la liste droulante correspondante.<br><br>"
	."- Le LIEN EXTERNE peut tre une url complte ou bien une adresse relative  votre site.<br>"
	."&nbsp;&nbsp;Si vous indiquez une url externe (commenant par 'http://' ou 'ftp://'), le lien s'ouvrira dans une nouvelle page.<br>"
	."&nbsp;&nbsp;Si vous indiquez une url relative ('modules.php?name=Your_Account&op=new_user'), le lien s'ouvrira dans la page courante.<br>"
	."&nbsp;&nbsp;Pour ouvrir un lien interne dans une nouvelle page, indiquez l'url complte de votre site.<br>"
	."&nbsp;&nbsp;Pour ouvrir un lien externe dans la page courante, indiquez 'HTTP://' (en majuscules).<br><br>"
	."- La COULEUR DE FOND doit tre un code couleur ou un nom de couleur standard.<br>"
	."&nbsp;&nbsp;ex: 'red' : <font color=\"red\">ROUGE</font>  --  '#ff0000' : <font color=\"#ff0000\">ROUGE</font><br><br>"
	."- La CLASSE utilise pour afficher les noms des catgories doit tre une classe prsente dans tous vos thmes.<br>"
	."&nbsp;&nbsp;Les classes se trouvent dans le fichier /themes/VOTRETHEME/style/style.css.<br>"
	."&nbsp;&nbsp;Vous pouvez crer votre propre classe, par exemple en rajoutant la ligne suivante dans les feuilles de style de vos thmes :<br>"
	."&nbsp;&nbsp;<i>.sommaire		{FONT-FAMILY: Verdana,Helvetica; FONT-SIZE: 12px; COLOR: #363636; FONT-WEIGHT: bold}   </i><br>");
define("_SOMCATCONTENT","Contenu de la catgorie");
define("_SOMLINKURL","Adresse du Lien");
define("_SOMLINKTEXT","Texte du Lien");
define("_SOMIMAGE","Image");
define("_SOMINVALIDWEIGHT","Valeur Poids  invalide pour la catgorie");
define("_SOMMUSTBENUM"," Cette valeur DOIT tre un nombre compris entre 0 et 98 !!");
define("_SOMCATS","Les catgories");
define("_SOMAND","et");
define("_SOMSAMEWEIGHT","ont le mme Poids !!");
define("_SOMMODIFWEIGHT","Retournez  la page prcdente et modifiez le Poids de l'une de ces catgories.");
define("_SOMBACKADMIN","Retour  l'administration du sommaire");
define("_SOMSUCCESS","Votre sommaire a t modifi avec succs !");
define("_SOMGOADMIN","Configurer le sommaire");
define("_SOMUPGRADESUCCESS","Votre sommaire a t upgrad avec succs !!");
define("_SOMV1DETECTED","Sommaire paramtrable v.1.0 dtect !");
define("_SOMCLICKTOUPGRADE","Pour upgrader votre sommaire, cliquez");
define("_SOMHERE","ICI");
define("_SOMWARNINGDELETECAT","Etes-vous sr de vouloir supprimer la catgorie");
define("_SOMGENERALOPTIONS","Options gnrales");
define("_SOMDISPLAYMEMBERSONLYMODULES","Affichage des modules rservs aux membres");
define("_SOMCATEGORIESCLASS","Classe utilise pour le nom des catgories");
define("_SOMDISPLAYMODULENORMAL","Normal (affichs tout le temps)");
define("_SOMDISPLAYMODULEWITHICON","Affichs avec icone");
define("_SOMDISPLAYMODULEWITHICONFORVISTORS","pour les visiteurs");
define("_SOMDISPLAYMODULEINVISIBLE","Invisibles pour les visiteurs");
define ("_SOMYES","Oui");
define ("_SOMNO","Non");
define("_SOMMAIREREMARKSTWO","<br>- Vous pouvez cr&eacute;er un popup, pour cela il faut entrer ceci dans le champ 'url' du lien externe :<br>"
		."&nbsp;&nbsp;<i>javascript:window.open('http://www.url.com','popup_sommaire','directories=no,menubar=no,status=no,location=no,scrollbars=no,resizable=no')</i><br>"
		."<br>&nbsp;&nbsp;Vous pouvez modifier les options d'affichage en autorisant les scrollbars, etc...<br>"
		."&nbsp;&nbsp;Consultez <a href=\"http://www.toutjavascript.com/savoir/savoir15.php3\">Tout Javascript - les popups</a> pour plus de dtails.<br><br>");
define("_SOMMAIREHR","Barre Horiz.");
define("_SOMBOLD","Gras");
define("_SOMLISTBOX","Liste d&eacute;roulante");
define("_SOMSENDTOHAVEMORE","Sauvez vos modifications pour ajouter de nouveaux liens.");
define("_SOMDISPLAYCLASSES","Affichage :");
define("_SOMMODULESCLASS","Classe CSS utilise pour les modules/liens externes");
define("_SOMAUTODETECTNEW","Dtection automatique des nouveauts");
define("_SOMSINCE","Nouveau pendant");
define("_SOMNBDAYS","jours");
define("_SOMDYNAMICMENU","Menu dynamique");
define("_SOMJSSAVEBEFORE","Voulez-vous sauvegarder vos modifications avant de supprimer la catgorie?");
define("_SOMEDITLINKTITLE","Editer un lien...");
define("_SOMMOREOPTIONS","Plus d'options");
define("_SOMCLASS","Classe CSS");
define("_SOMATTENTIONMOREOPTIONS","<strong>Attention !</strong><br>Si vous modifiez dans l'administration du Sommaire la classe g&eacute;n&eacute;rale pour les cat&eacute;gories ou les liens/modules, ou bien la dur&eacute;e des nouveaut&eacute;s, les valeurs sp&eacute;cifiques &agrave; une catgorie ou un lien/module seront effac&eacute;es.");
define("_SOMMOREOPTIONSUCCESS","Vos modifications ont &eacute;t&eacute; prises en compte !");
define("_SOMSENDTOVALIDATE","(Validez les modifications dans la fen&ecirc;tre principale pour qu'elles soient finalis&eacute;es)");
define("_SOMCLOSE","Fermer la fen&ecirc;tre");
define("_SOMTARGETBLANK","Page ouverte dans une nouvelle fen&ecirc;tre. Pour ouvrir dans la m&ecirc;me fen&ecirc;tre, commencer le lien par HTTP:// (majucules)");
define("_SOMTARGETNONE","Page ouverte dans la m&ecirc;me fen&ecirc;tre. Pour ouvrir dans une nouvelle fen&ecirc;tre, commencer le lien par http:// (minuscules)");
define("_SOMNOTABLEPB","Sommaire Paramtrable ne peut pas accder  ses tables dans la base de donnes. Vrifiez que vous avez install correctement, et LISEZ LA FAQ !");
/* Fin des modifications de Sommaire Paramtrable v2.1 */

/********************* Nouvelles Dfinitions : NukeClan 1.0.6 *************/
define("_DEFIRECRUTEMENT","Dfi & Recrutement");
define("_CHARTE","La Charte de la Team");
define("_MATCHS","Les Matchs");
define("_RANKTITLE","Rangs & Tags des Joueurs");
define("_MEMBRESTEAMS","Membres & Teams");
define("_LESTRAINS","Les Entranements");
define("_CALENDAR","Calendrier");
define("_COTISATIONS","Cotisations");
define("_MVTEAMS","Les Teams seulement");
define("_WHATTEAMS","Quelles Teams ?");
define("_WHATGRDESC","Quelles Teams ?");
define("_TEAMSPEAK","Teamspeak");
define("_TOURNOIS","Tournois");
define("_MIRCMOD","Module IRC");
/**************************************************************************/

define("_BANINDEX","Requtes de Bannissement");
define("_DOWNLOAD","Tlchargements");
define("_ENCYCLOPEDIA","Encyclopdie");
define("_FAQ","F.A.Q.");
define("_NEWS","Articles (Page d'Accueil)");
define("_REVIEWS","Commentaires");
define("_ADMPOLLS","Sondage");
define("_TOPICS","Sujets");
define("_WEBLINKS","Liens internet");
define("_SEND","Envoyer");
define("_URL","URL");
define("_EMAIL","E-mail");
define("_FUNCTIONS","Fonctions");
define("_YES","Oui");
define("_NO","Non");
define("_REQUIRED","(requis)");
define("_SAVECHANGES","Sauvez les modifications");
define("_OK","Ok !");
define("_SAVE","Sauver");
define("_ID","ID");
define("_SUBJECT","Sujet");
define("_WHOSONLINE","Qui est en ligne ?");
define("_ARTICLES","Articles");
define("_ALL","Tous");
define("_PREVIEW","Pr&eacute;visualisation");
define("_EXTRAINFO","Autres...");
define("_YOUARELOGGEDOUT","Vous &ecirc;tes maintenant d&eacute;connect&eacute; !");
define("_HOMECONFIG","Configuration de la page d'accueil");
define("_DESCRIPTION","Description");
define("_HOMEPAGE","Page d'accueil");
define("_NAME","Nom");
define("_FROM","De");
define("_DATE","Date");
define("_SUBMIT","Soumettre");
define("_SHOW","Montrer");
define("_DAYS","jours");
define("_STAFF","Equipe");
define("_ADMINID","Pseudo Admin");
define("_ADMINLOGIN","Administration Syst&egrave;me: Login");
define("_EDITADMINS","Editer l'auteur");
define("_PREFERENCES","Configuration du Site");
define("_ADMINMENU","- Menu Administration -");
define("_BANNERSADMIN","Administration des Banni&egrave;res");
define("_ADMINLOGOUT","Sortie");
define("_LAST","Derniers");
define("_GO","Ok");
define("_CURRENTPOLL","Sondage en cours");
define("_STORYID","ID article");
define("_REMOVECOMMENTS","Effacer les commentaires");
define("_SURETODELCOMMENTS","Etes-vous s&ucirc;r de vouloir supprimer le commentaire s&eacute;lectionn&eacute; et toutes les r&eacute;ponses ?");
define("_BLOCKSADMIN","Administration des blocks");
define("_BLOCKS","Blocks");
define("_TITLE","Titre");
define("_POSITION","Position");
define("_WEIGHT","Poids");
define("_STATUS","Statut");
define("_LEFTBLOCK","Bloc de gauche");
define("_LEFT","Gauche");
define("_RIGHTBLOCK","Bloc de droite");
define("_RIGHT","Droite");
define("_ACTIVE","Actif");
define("_DEACTIVATE","D&eacute;sactiver");
define("_INACTIVE","Inactif");
define("_ACTIVATE","Activer");
define("_TYPE","Type");
define("_ADDNEWBLOCK","Ajouter un nouveau bloc");
define("_RSSFILE","URL du fichier RSS/RDF");
define("_ONLYHEADLINES","(Seulement pour les manchettes)");
define("_CONTENT","Contenu");
define("_ACTIVATE2","Activer ?");
define("_REFRESHTIME","D&eacute;lai de rafra&icirc;chissement");
define("_HOUR","Heure");
define("_CREATEBLOCK","Cr&eacute;er un bloc");
define("_EDITBLOCK","Editer un bloc");
define("_BLOCK","Bloc");
define("_SAVEBLOCK","Sauvegarder le bloc");
define("_BLOCKACTIVATION","Activation du bloc");
define("_BLOCKPREVIEW","Pr&eacute;visualisation du bloc");
define("_WANT2ACTIVATE","Voulez-vous activer ce bloc ?");
define("_ARESUREDELBLOCK","Etes-vous s&ucirc;r de vouloir enlever ce bloc ?");
define("_RSSFAIL","Il y a un probl&egrave;me avec l'URL du fichier RSS");
define("_RSSTRYAGAIN","Veuillez v&eacute;rifier l'URL et le nom du fichier RSS, et essayez &agrave; nouveau.");
define("_RSSCONTENT","(Contenu RSS/RDF)");
define("_IFRSSWARNING","Si vous entrez un URL, le contenu que vous avez &eacute;crit ne sera pas affich&eacute; !");
define("_BLOCKUP","Remonter le bloc");
define("_BLOCKDOWN","Descendre le bloc");
define("_SETUPHEADLINES","(Pour obtenir de nouvelles manchettes, s&eacute;lectionnez un site dans la liste ou choisissez Autre et entrez l'URL)");
define("_HEADLINESADMIN","Administration des manchettes");
define("_ADDHEADLINE","Ajouter une Manchette");
define("_EDITHEADLINE","Editer les manchettes");
define("_SURE2DELHEADLINE","ATTENTION: Etes-vous s&ucirc;r de vouloir enlever cette manchette?");
define("_CUSTOM","Autre");
define("_AUTHORSADMIN","Administration des auteurs");
define("_MODIFYINFO","Modifier l'Information");
define("_DELAUTHOR","Enlever un auteur");
define("_ADDAUTHOR","Ajouter un nouvel administrateur");
define("_PERMISSIONS","Permissions");
define("_USERS","Utilisateurs");
define("_SUPERUSER","Super Utilisateur");
define("_SUPERWARNING","ATTENTION: Si Super Utilisateur est coch&eacute;, l'utilisateur aura tous les acc&egrave;s ouverts !");
define("_ADDAUTHOR2","Ajouter un Auteur ");
define("_RETYPEPASSWD","Retapez votre mot de Passe");
define("_FORCHANGES","(Pour les changements seulement)");
define("_COMPLETEFIELDS","Vous devez remplir tous les Champs");
define("_CREATIONERROR","Erreur dans la cr&eacute;ation d'un compte auteur");
define("_AUTHORDELSURE","Etes-vous s&ucirc;r de vouloir supprimer");
define("_AUTHORDEL","Enlever un auteur");
define("_REQUIREDNOCHANGE","(requis, ne peut pas &ecirc;tre chang&eacute; plus tard)");
define("_PUBLISHEDSTORIES","Cet administrateur a publi&eacute; des articles");
define("_SELECTNEWADMIN","Choisissez un nouvel administrateur &agrave; qui les assigner");
define("_GODNOTDEL","*(Le compte DIEU ne peut pas &ecirc;tre effac&eacute;)");
define("_MAINACCOUNT","Admin Dieu*");
define("_ADD","Ajouter");
define("_DAY","Jour");
define("_AUTOMATEDARTICLES","Articles programm&eacute;s");
define("_NOAUTOARTICLES","Il n'y a pas d'articles programm&eacute;s.");
define("_WARNING","Attention");
define("_NOFUNCTIONS","---------");
define("_WHOLINKS","Qui place des liens vers notre site ?");
define("_DELETEREFERERS","Effacer les r&eacute;f&eacute;rents");
define("_SITENAME","Nom du Site");
define("_PASSWDNOMATCH","D&eacute;sol&eacute;, les mots de passe ne correspondent pas.  Retournez &agrave; la page pr&eacute;c&eacute;dente et essayez &agrave; nouveau.");
define("_SITECONFIG","Configuration du site Web");
define("_GENSITEINFO","Infos G&eacute;n&eacute;rales sur le Site");
define("_SITEURL","URL du site");
define("_SITELOGO","Logo du site");
define("_SITESLOGAN","Slogan du site");
define("_ADMINEMAIL","Email de l'administrateur");
define("_ITEMSTOP","Nombre d'&eacute;l&eacute;ments sur la page Top");
define("_STORIESHOME","Nombre d'articles sur la page d'accueil");
define("_OLDSTORIES","Nombre d'articles dans la bo&icirc;te des Articles Pr&eacute;c&eacute;dents");
define("_ACTULTRAMODE","Activer l'Ultramode?");
define("_DEFAULTTHEME","Th&egrave;me par d&eacute;faut pour votre site");
define("_SELLANGUAGE","S&eacute;lectionnez la langue de votre site");
define("_LOCALEFORMAT","Format local pour la date et l'heure");
define("_BANNERSOPT","Options pour les banni&egrave;res");
define("_STARTDATE","Date de mise en ligne du site");
define("_ACTBANNERS","Activer les banni&egrave;res sur votre site?");
define("_FOOTERMSG","Messages de bas de page");
define("_FOOTERLINE1","Ligne de pied 1");
define("_FOOTERLINE2","Ligne de pied 2");
define("_FOOTERLINE3","Ligne de pied 3");
define("_BACKENDCONF","Configuration syndication");
define("_BACKENDTITLE","Syndication - Titre");
define("_BACKENDLANG","Syndication - Langue");
define("_MAIL2ADMIN","Envoyer les nouveaux articles par e-mail &agrave; l'administrateur");
define("_NOTIFYSUBMISSION","Notifier les suggestions par e-mail?");
define("_EMAIL2SENDMSG","Adresse Email o&ugrave; envoyer le message");
define("_EMAILSUBJECT","Objet du message");
define("_EMAILMSG","Message");
define("_EMAILFROM","Compte Email (de)");
define("_COMMENTSMOD","Mod&eacute;ration des commentaires");
define("_MODTYPE","Type de mod&eacute;ration");
define("_MODADMIN","Mod&eacute;ration par l'administrateur");
define("_MODUSERS","Mod&eacute;ration par les utilisateurs");
define("_NOMOD","Pas de Mod&eacute;ration");
define("_COMMENTSOPT","Options pour les commentaires");
define("_COMMENTSLIMIT","Limite en octets pour les commentaires");
define("_ANONYMOUSNAME","Nom par d&eacute;faut pour les anonymes");
define("_GRAPHICOPT","Options graphiques");
define("_ADMINGRAPHIC","Utiliser des images dans le menu Administration?");
define("_MISCOPT","Options diverses");
define("_PASSWDLEN","Taille minimale pour le mot de passe des utilisateurs");
define("_MAXREF","Combien de r&eacute;f&eacute;rants voulez-vous garder au maximum?");
define("_COMMENTSPOLLS","Activer les commentaires pour les Sondages?");
define("_ALLOWANONPOST","Accepter les envois anonymes?");
define("_ACTIVATEHTTPREF","Activer le tra&ccedil;age des r&eacute;f&eacute;rants HTTP?");
define("_SIZE","Taille");
define("_MESSAGES","Messages d'Accueil");
define("_MESSAGESADMIN","Administration des messages");
define("_MESSAGETITLE","Titre");
define("_MESSAGECONTENT","Contenu");
define("_EXPIRATION","Expiration");
define("_VIEWPRIV","Qui peut le voir ?");
define("_MVADMIN","Les administrateurs seulement");
define("_MVUSERS","Les utilisateurs enregistr&eacute;s seulement");
define("_MVANON","Les utilisateurs anonymes seulement");
define("_MVALL","Tous les visiteurs");
define("_CHANGEDATE","Changer la date de d&eacute;but &agrave; aujourd'hui ?");
define("_IFYOUACTIVE","(Si vous activez ce message maintenant, la date de d&eacute;but sera aujourd'hui)");
define("_FILENAME","Nom de fichier");
define("_FILEINCLUDE","(Choisissez un block  inclure. Tous les autres champs seront ignor&eacute;s)");
define("_BLOCKFILE","(Fichier Block)");
define("_COMMENTSARTICLES","Activer les commentaires pour les Articles?");
define("_MULTILINGUALOPT","Options Multilingue");
define("_ACTMULTILINGUAL","Activer Syst&egrave;me Multilingue? ");
define("_ACTUSEFLAGS","Utiliser les drapeaux au lieu du dropdown?");
define("_LANGUAGE","Langue");
define("_EDITMSG","Editer message");
define("_ADDMSG","Ajouter message");
define("_ALLMESSAGES","Aperu messages");
define("_VIEW","Qui peut le voir ?");
define("_REMOVEMSG","Etes-vous sr de vouloir supprimer ce message ? ");
define("_MODULES","Modules/Addons");
define("_MODULESADMIN","- Administration des Modules -");
define("_MODULESADDONS","Modules et Addons");
define("_MODULESACTIVATION","Allez voir dans Modules/Addons et changez son statut.<br>Les nouveau modules copi&eacute;s dans le dossier <i>/modules/</i> seront automatiquement ajout&eacute;s avec pour statut <i>Inactif</i>  la base de donn&eacute;es quand vous rechargerez cette page.<br>Si vous voulez supprimer un module, supprimez le seulement du r&eacute;pertoire <i>/modules/</i>, le system mettra  jour automatiquement la base de donn&eacute;es.");
define("_NEWSLETTER","Newsletter");
define("_MASSMAIL","Une Massive e-mail pour tous les utilisateurs");
define("_ANEWSLETTER","Une Newsletter  tous ceux inscrit seulement");
define("_WHATTODO","Que veux tu envoyer?");
define("_SUBSCRIBEDUSERS","Utilisateurs inscrit");
define("_NYOUAREABOUTTOSEND","Vous tes sur le point d'envoyer une Newsletter  tous les utilisateurs inscrits.");
define("_NUSERWILLRECEIVE","Les utilisateurs vont recevoir cette Newsletter.");
define("_REVIEWTEXT","Merci de v&eacute;rifier votre texte:");
define("_NAREYOUSURE2SEND","Etes vous sr de vouloir envoyer maitenant cette Newsletter ?");
define("_MYOUAREABOUTTOSEND","Vous tes sur le point d'envoyer un Massive e-mail  TOUS les utilisateurs inscrit.");
define("_MUSERWILLRECEIVE","Les utilisateurs vont recevoir cette Newsletter.");
define("_MAREYOUSURE2SEND","Etes vous sr de vouloir envoyer maintenant ce Massive Email ?");
define("_POSSIBLESPAM","Merci de noter que certains utilisateurs vont se sentir abus&eacute;s par cette email peut tre non d&eacute;sir&eacute; et peuvent consid&eacute;rer ceci comme du Spam!");
define("_MASSEMAIL","Massive Email");
define("_MANYUSERSNOTE","Attention! Plusieurs utilisateurs vont recevoir cet email. Merci d'attendre jusqu' ce que le script ait fini l'op&eacute;ration. Ceci peut prendre plusieurs minutes!");
define("_NLUNSUBSCRIBE","=========================================================\nNewsletter de $sitename.\nVous pouvez vous d&eacute;sinscrire en allant sur URL:\n\n$nukeurl/modules.php?name=Your_Account&amp;op=edituser\"\n\n puis choisissez \"Non\"  la question Recevoir la Newsletter par Email; puis sauvegardez.");
define("_NEWSLETTERSENT","La Newsletter a &eacute;t&eacute; envoy&eacute;e.");
define("_MASSEMAILSENT","Massive Email a &eacute;t&eacute; envoy&eacute;.");
define("_MASSEMAILMSG","=========================================================\nVous recevez cette Newsletter parceque vous tes inscrit au site $sitename.");
define("_FIXBLOCKS","R&eacute;gler les conflits de longueurs avec les blocks");
define("_SAVEDATABASE","Sauvegarde");
define("_SAVEDATABASELINK","Sauvegarde de la Base de Donnes");
define("_DBOPTIMIZATION","Optimisation de la base de donn&eacute;es");
define("_OPTIMIZINGDB","Optimisation de la base de donn&eacute;es:");
define("_TABLE","Tableau");
define("_SPACESAVED","Espace sauv&eacute;");
define("_ALREADYOPTIMIZED","D&eacute;j optimis&eacute;");
define("_OPTIMIZED","Optimiz&eacute;!");
define("_OPTIMIZATIONRESULTS","R&eacute;sultat de l'optimisation");
define("_TOTALSPACESAVED","Espace total sauv&eacute;:");
define("_YOUHAVERUNSCRIPT","Vous avez &eacute;x&eacute;cut&eacute; ce script:");
define("_KBSAVED","Kb sauv&eacute;s depuis sa premi&egrave;re &eacute;x&eacute;cution!");
define("_TIMES","fois");
define("_CUSTOMTITLE","Titre choisi");
define("_CHANGEMODNAME","Changer le nom du module");
define("_CUSTOMMODNAME","Nom du module choisi:");
define("_MODULEEDIT","Edition d'un module");
define("_BLOCKFILE2","FICHIER");
define("_BLOCKSYSTEM","SYSTEM");
define("_DEFHOMEMODULE","Module Principal");
define("_MODULEINHOME","Module Principal charg&eacute; :");
define("_CHANGE","Change");
define("_INHOME","Dans");
define("_MODULEHOMENOTE","<b>-= ATTENTION =-</b><br>Le titre en gras du module repr&eacute;sente le module dans la page principale.<br>vous ne pouvez pas d&eacute;sactiver le module par defaut!<br>Si vous supprimez le r&eacute;pertoire du module une erreur apparaitrait sur la page principale.<br>Aussi, le module a &eacute;t&eacute; plac&eacute; avec un lien pour <i>la page principale</i> dans le bloc des modules.");
define("_PUTINHOME","Mettre en page principale");
define("_SURETOCHANGEMOD","Etes-vous sr de vouloir changer votre page principale depuis");
define("_CENTERBLOCK","Centrer le bloc");
define("_ADMINISTRATION","Administration");
define("_NOADMINYET","Il n'y a pas de compte administrateur actuellement, cr&eacute;ez un super utilisateur :");
define("_CREATEUSERDATA","Voulez-vous cr&eacute;er un utilisateur normal avec les mmes donn&eacute;es ?");
define("_NORMAL","Normal");
define("_INACTIVEBANNERS","Bandeaux inactifs");
define("_CENTERUP","Centr&eacute; haut");
define("_CENTERDOWN","Centr&eacute; bas");
define("_NOTINMENU","[ <big><strong>&middot;</strong></big> ] cd que le nom du module ne sera pas visible dans le block des modules");
define("_SHOWINMENU","Visible dans le block des modules ?");
define("_BANNERS","Bannires");
define("_ALTTEXT","Texte Alternatif");
define("_MUSTBEINIMG","Doit tre dans le r&eacute;pertoire /images/. valable pour l'impression d'article");
define("_USERSOPTIONS","Options utilisateurs");
define("_BROADCASTMSG","Activer les Messages Publics ?");
define("_MYHEADLINES","Activer Le lecteur de nouvelles externes ?");
define("_USERSHOMENUM","Permettre aux membres de modifier les num&eacute;ros des nouvelles ?");
define("_CENSOROPTIONS","Options de censures");
define("_CENSORMODE","Mode de censure");
define("_NOFILTERING","Pas de filtrage");
define("_EXACTMATCH","Mot Exact");
define("_MATCHBEG","Mot en d&eacute;but");
define("_MATCHANY","Dans tout le texte");
define("_CENSORREPLACE","Replacer les mots censur&eacute;s par:");
define("_SECURITYCODE","Code de s&eacute;curit&eacute;");
define("_TYPESECCODE","Encodez le code");
define("_UGROUPS","Groupes <br>d'utilisateurs");
define("_POINTS","Points");
define("_USERSCOUNT","Utilisateur(s)");
define("_ADDNEWGROUP","Ajouter un nouveau groupe");
define("_GTITLE","Nom du groupe");
define("_POINTSNEEDED","Points ncessaires");
define("_ONLYNUMVAL","n'utilisez que des valeurs numriques");
define("_CREATEGROUP","Valider ce groupe");
define("_NOGROUPS","Il n'y a aucun groupe pour le moment");
define("_POINTSSYSTEM","Systme de gestion des points");
define("_UPDATE","Valider");
define("_EDITGROUP","Edition d'un groupe");
define("_SAVEGROUP","Valider ce groupe");
define("_GROUPSADMIN","ADMINISTRATION DE LA GESTION DES GROUPES");
define("_GROUPADDERROR","Erreur lors de la cration!");
define("_GROUPDELETE","Supprimer un groupe");
define("_SUREGRPDEL1","Etes vous sur de vouloir dfinitivement supprimer ce groupe?:");
define("_NONUMVALUE","La valeur donne aux points n'est pas numrique. Revenez en arrire et corrigez.");
define("_GROUP","Groupe");
define("_UGROUP","Users Group");
define("_VALIDIFREG","Valid only if Registered Users are selected above");
define("_POINTS01","Journal");
define("_DESC01","Nombre d'article rdig dans votre journal. Articles publiques ou privs");
define("_POINTS02","Journal (Commentaires)");
define("_DESC02","Chaque commentaire rdig dans le journal publique d'un utilisateur");
define("_POINTS03","Recommandation  un ami");
define("_DESC03","Chaque fois qu'un utilisateur recommande votre site  un/une ami(e)");
define("_POINTS04","Articles (soumis et publis)");
define("_DESC04","Articles qu'un utilisateur vous a propos et que vous avez publi");
define("_POINTS05","Articles (Commentaires)");
define("_DESC05","Commentaires effectu dans vos articles");
define("_POINTS06","Articles (envoy  un ami)");
define("_DESC06","Chaque fois qu'un utilisateur envoie un article de votre site pour qu'un ami le lise");
define("_POINTS07","Article (vot)");
define("_DESC07","Chaque fois qu'un utilisateur vote pour un article");
define("_POINTS08","Sondages (votes)");
define("_DESC08","Chaque fois qu'un utilisateur vote dans un sondage");
define("_POINTS09","Sondages (Commentaires)");
define("_DESC09","Chaque fois qu'un utilisateur rdige un commentaire dans les sondages");
define("_POINTS10","Forum (Nouveau sujet)");
define("_DESC10","Chaque fois qu'un utilisateur ouvre un nouveau sujet dans le Forum");
define("_POINTS11","Forum (rponse  un sujet)");
define("_DESC11","Chaque fois qu'un utilisateur poste une rponse dans le Forum");
define("_POINTS12","Comptes-rendus");
define("_DESC12","Chaque fois qu'un utilisateur rdige un commentaire dans les Comptes-rendus");
define("_POINTS13","Pages Vues");
define("_DESC13","Donner des points  un utilisateur pour chaque page vue");
define("_POINTS14","Liens Web (Visite)");
define("_DESC14","Chaque fois qu'un utilisateur visiste un lien de votre annuaire de liens");
define("_POINTS15","Liens Web (valuation)");
define("_DESC15","Chaque fois qu'un utilisateur value un lien de votre annuaire");
define("_POINTS16","Liens Web (Commentaires)");
define("_DESC16","Chaque fois qu'un utilisateur rdige un commentaire sur un lien dans votre annuaire");
define("_POINTS17","Tlchargements (effectus)");
define("_DESC17","Chaque fois qu'un utilisateur effectue un tlchargemnet sur vos site");
define("_POINTS18","Tlchargements (valuation)");
define("_DESC18","Chaque fois qu'un utilisateur value un fichier disponible dans vos tlchargements");
define("_POINTS19","Tlchargements (Commentairtes)");
define("_DESC19","Chaque fois qu'un utilisateur rdige un commentaire pour fichier en tlchargement");
define("_POINTS20","Messages Publiques");
define("_DESC20","Chaque fois qu'un utilisateur compose un message dans le systme de messages publiques");
define("_POINTS21","Bannires");
define("_DESC21","Chaque fois qu'un utilisateur clique sur une bannire de votre site");
define("_AFTEREXPIRATION","Aprs expiration");
define("_SUBUSERS","Souscripteurs");
define("_SUBVISIBLE","Visible aux membres<br> du programme souscription:");
define("_IPBANSYSTEM","Panel de Gestion des IP bannies");
define("_BANNEWIP","Bannir une adresse IP");
define("_IPBANNED","Adresses IP bannies");
define("_BANDATE","Date");
define("_UNBAN","Retirer");
define("_IPNUMERIC","And IP address should be numeric");
define("_IPENTERED","Adresse IP entre:");
define("_ERROR","ERREUR:");
define("_IPOUTRANGE","IP address is out of range");
define("_IPSTARTZERO","Ajouter une adresse IP ne peut commencer avec 0");
define("_IPLOCALHOST","Vous ne pouvez bannir l'IP localhost");
define("_SUCCESS","Bannie!!");
define("_THEIP","L'adresse IP");
define("_HASBEENBANNED","a t banni de ce site");
define("_SURETOBANIP","Etes vous sur de disrer DEBANNIR l'adresse IP suivante:");
define("_IPYOURS","Vous ne pouvez bannir votre propre adresse IP!");
define("_REASON","Raison/Motif");
define("_CATEGORY","Categorie");
define("_ADDMAINCATEGORY","Ajouter une catgorie PRINCIPALE");
define("_MODCATEGORY","Modifier une catgorie");

/*****************************************************/
/* Addon - Whos Online v.0.9.1                 START */
/*****************************************************/
define("_who0a","Qui est en ligne?");
define("_who00","<b>4n Qui est en ligne?</b><br><i>Version 0.91</i>");
define("_who01","Retour vers ");
define("_who02","Heure du serveur: ");
define("_who03"," Utilisateur actuellement connects");
define("_who04","Nom");
define("_who05","Adresse IP");
define("_who06","Nom du fournisseur");
define("_who07","Temps de connection");
define("_who08","Editer le membre");
define("_who09","Rafraichir");
define("_who10","De");
define("_who11","Nouveau membre");
define("_who12","Nombre de membres:");
define("_who13","Informations sur le membre");
define("_who14","Invit");
define("_who15","Domaine inconnu");
define("_who16","Ce n\'est pas un domaine");
define("_who17","A cette heure ils sont");
define("_who18","Invit(s) et");
define("_who19","Membre(s) connect(s).");
define("_who20","Effacer membre");
define("_whocopy","4nQui est en ligne par <a href=\"http://warpspeed.4thdimension.de\" target=\"_blank\">www.warp-speed.de</a> @ <a href=\"http://www.4thdimension.de\" target=\"_blank\">4thDimension.de</a> Networking.");
/*****************************************************/
/* Addon - Whos Online v.0.9.1                   END */
/*****************************************************/

/*****************************************************/
/* Addon - Center Blocks v.2.1.1               START */
/*****************************************************/
define("_CB_CONTENT","Contenu");
define("_CB_BLOCKS","Blocs Centraux");
define("_CB_ADMIN","Administration des blocs centraux");
define("_CB_ADMIN1","Administration des blocs du haut du Site");
define("_CB_ADMIN2","Administration des blocs du bas du Site");
define("_CB_CONFIG","Configuration de Center Bloc");
define("_CB_CONFIG1","Administration des blocs du haut du Site");
define("_CB_CONFIG2","Administration des blocs du bas du Site");
define("_CB_ACTIVE","Activer Center Blocs");
define("_CB_NUMBER","Nombre de Blocs  inclure");
define("_CB_HEIGHT","Minimum du Center Bloc");
define("_CB_LIST1","Choix des Blocs du haut  afficher");
define("_CB_LIST2","Choix des Blocs du bas  afficher");
define("_CB_BLOCK","Bloc Numro");
define("_CB_TITLE","Titre");
define("_CB_FILENAME","Nom du Bloc");
define("_CB_NONE","Non");
define("_CB_SPEC","Afficher en");
define("_CB_PIX","Pixels");
define("_CB_PER","Pourcentage");
define("_CB_WID","Taille");
define("_CB_SAVE","    Enregistrer les modifications    ");
/*****************************************************/
/* Addon - Center Blocks v.2.1.1                 END */
/*****************************************************/

/*****************************************************/
/* Addon - Blocks Manager v.1.0.0              START */
/*****************************************************/
define("_BLOCKS_MANAGER","Administration des Blocs");
define("_BLOCKMGR","Gestion de l'affichage des blocs par module");
define("_BLOCKMGR_MODULEDROP","Liste des blocs du module :");
define("_BLOCKMGR_ADDNEWBLOCK","Ajouter/enlever les blocs s&eacute;lectionn&eacute;s vers/du module s&eacute;lectionn&eacute;");
define("_BLOCKMGR_ACTIVE_BLOCKS","Blocs inactifs");
define("_BLOCKMGR_INACTIVE_BLOCKS","Blocs Actifs");
define("_BLOCKMGR_ADD_BLOCK","Ajouter");
define("_BLOCKMGR_REMOVE_BLOCK","Enlever");
define("_BLOCKMGR_TITLE","Module");
define("_BLOCKMGR_POSITION","Position");
define("_BLOCKMGR_WEIGHT","Ordre");
define("_BLOCKMGR_STATUS","Status");
define("_BLOCKMGR_VIEW","Visible ");
define("_BLOCKMGR_LANGUAGE","Langue");
define("_BLOCKMGR_LEFT","Gauche");
define("_BLOCKMGR_CENTERUP","Centre Haut");
define("_BLOCKMGR_CENTERDOWN","Centre Bas");
define("_BLOCKMGR_RIGHT","Droite");
define("_BLOCKMGR_BLOCKUP","Monter");
define("_BLOCKMGR_BLOCKDOWN","Descendre");
define("_BLOCKMGR_DEACTIVATE","D&eacute;sactiver");
define("_BLOCKMGR_ACTIVATE","Activer");
define("_BLOCKMGR_INACTIVE","Inactif");
define("_BLOCKMGR_ACTIVE","Actif");
/*****************************************************/
/* Addon - Blocks Manager v.1.0.0                END */
/*****************************************************/

/*****************************************************/
/* Module - NukeC v.3.0.0b2                    START */
/*****************************************************/
define("_NUKEC","Administration<BR>NukeC 30");
/*****************************************************/
/* Module - NukeC v.3.0.0b2                      END */
/*****************************************************/

/*****************************************************/
/* Addon - Conditional Blocks v.1.1.1          START */
/*****************************************************/
define("_WHERE","Lieu");
define("_WHERE2","Visible dans quel module:");
/*****************************************************/
/* Addon - Conditional Blocks v.1.1.1            END */
/*****************************************************/

?>
