<?php
/************************************************************************/
/* PHP-NUKE: Center Arcade Block                                        */
/* ================================                                     */
/*                                                                      */
/* Copyright (c) 2004 by JRSweets                                       */
/* http://www.jeffrusso.net                                             */
/*                                                                      */
/* Originally by:                                                       */
/* Copyright (c) 2004 by Barcrest                                       */
/* http://baja.ods.org                                                  */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation                                         */
/************************************************************************/
/* PHP-Nuke Platinum: Expect to be impressed                  COPYRIGHT */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.techgfx.com                  */
/*     Techgfx - Graeme Allan                       (goose@techgfx.com) */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de            */
/*     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de) */
/*                                                                      */
/* Refer to TechGFX.com for detailed information on PHP-Nuke Platinum   */
/*                                                                      */
/* TechGFX: Your dreams, our imagination                                */
/************************************************************************/

if (stristr($_SERVER['SCRIPT_NAME'], "block-Arcade_Center.php")) {
    Header("Location: ../index.php");
    die();
}

define("_TOPGAMERS", "The Top Players");
define("_VICTOIRES", "Number Of Wins :");

global $prefix, $db, $ThemeSel;

/*****EDIT CONFIG SETTINGS*******/
/***** ON = 1  -  OFF = 0 *******/
//Top section of block
$top = 1;

//Last 5 High Score section
$last_five = 1;
//Limit of lastest highscores
$highscore_limit = 5;

//Arcade stats sections
$arcade_stats = 1;

//Who's playing what game section
$whos_playing = 1;
/*****END CONFIG SETTINGS********/

if (file_exists("themes/$ThemeSel/forums/forums.css"))
{
          $content = "<link rel=\"stylesheet\" href=\"themes/$ThemeSel/forums/forums.css\" type=\"text/css\"> ";
}
elseif(file_exists("themes/$ThemeSel/style/style.css"))
{
          $content = "<link rel=\"stylesheet\" href=\"themes/$ThemeSel/style/style.css\" type=\"text/css\"> ";
}
else
{
                $content = "<style type=\"text/css\">\n";
		$content .= "<!--\n";
		$content .= "td.row1	{ background-color: #EFEFEF; }\n";
		$content .= "td.row2	{ background-color: #DEE3E7; }\n";
		$content .= "td.row3	{ background-color: #D1D7DC; }\n";
		$content .= "th	{ color: #FFA34F; font-size: 11px; font-weight : bold;background-color: #006699; height: 25px;background-image: url(/modules/Forums/templates/subSilver/images/cellpic3.gif); }\n";
		$content .= "-->\n";
		$content .= "</style>\n";

}

		$sql = "SELECT game_id FROM ".$prefix."_bbgames";
		$total_games = $db->sql_numrows($db->sql_query($sql));
		$recent_scores = ($total_games > $highscore_limit) ? $highscore_limit : $total_games;

if ($top) {

		$sql = "SELECT arcade_catid FROM ".$prefix."_bbarcade_categories";
                $total_cats = $db->sql_numrows($db->sql_query($sql));

                $content .= "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspaceing=\"0\">\n";
		$content .= "<tr>\n";
		$content .= "<th width=\"30%\" align=\"center\"><b>Top Scorers</b></th>\n";
                $content .= "<th width=\"40%\" align=\"center\"><b>Random Game</b></th>\n";
                $content .= "<th width=\"30%\" align=\"center\"><b>New Games</b></th>\n";
		$content .= "</tr>\n";
                $content .= "<tr>\n";
                $content .= "<td align=\"center\" class=\"row1\"><marquee behavior= \"scroll\" align= \"center\" direction= \"up\" scrollamount= \"2\" scrolldelay= \"20\" onmouseover='this.stop()' onmouseout='this.start()'><center>\n";

                $sql = "SELECT COUNT(*) AS nbvictoires, g.game_highuser, u.user_id, u.username, u.user_level FROM ".$prefix."_bbgames g, ".$prefix."_users u WHERE g.game_highuser = u.user_id AND g.game_highuser <> 0 GROUP BY g.game_highuser ORDER BY nbvictoires DESC";
                $result = $db->sql_query($sql);
		
                $place = 0;
		$nbvictprec = 0;

		while ($row = $db->sql_fetchrow($result)) {
				if ($nbvictprec <> $row['nbvictoires']) {
						$nbvictprec = $row['nbvictoires'];
				}

				$place++;

                                $lastUser = $row['username'];
                                $row['username'] = '<b>' . $row['username'] . '</b>';

				$content .= "<b>$place - </b>\n";
				$content .= "<a href=\"modules.php?name=Forums&amp;file=statarcade&amp;uid=".$row['user_id']."\"><img src=\"modules/Forums/templates/subSilver/images/loupe.gif\" border= \"0\" alt=\"Jump to $lastUser's stats...\"></a> \n";
				$content .= "<a href=\"modules.php?name=Forums&amp;file=profile&amp;mode=viewprofile&amp;u=".$row['user_id']."\">".$row['username']."</a> \n";
				$content .= "<br> "._VICTOIRES." $nbvictprec <br><br>\n";

				$count = $count + 1;
		}

		$content .= "</center></marquee></td>\n";
		
		//Random Game
		$sql = "SELECT g.* , u.username FROM ".$prefix."_bbgames g, ".$prefix."_users u WHERE g.game_highuser = u.user_id ORDER BY rand() LIMIT 1";
                $row = $db->sql_fetchrow($db->sql_query($sql));
                $randomUser = $row['username'];
                $row['game_highscore'] = number_format($row['game_highscore']);

		$content .= "<td align=\"center\" class=\"row2\"><b>".$row['game_name']."</b><br><a href=\"modules.php?name=Forums&file=games&gid=".$row['game_id']."\"><img src=\"modules/Forums/games/pics/".$row['game_pic']."\" border= \"0\" alt=\"".$row['game_name']."\"></a><br> High Score set by<br><b><a href=\"modules.php?name=Forums&amp;file=statarcade&amp;uid=".$row['game_highuser']."\"><img src=\"modules/Forums/templates/subSilver/images/loupe.gif\" border= \"0\" alt=\"Jump to ".$row['username']."'s stats...\"></a> <a href=\"modules.php?name=Forums&amp;file=profile&amp;mode=viewprofile&amp;u=".$row['game_highuser']."\">$randomUser</a> </b><br>with <b>".$row['game_highscore']."</b> <br><br>Total Games <b>$total_games</b><br>in <b>$total_cats</b> categories.</td>\n";
		$content .= "<td align=\"center\" class=\"row1\">\n";
		$content .= "<marquee behavior= \"scroll\" align= \"center\" direction= \"up\" scrollamount= \"2\" scrolldelay= \"20\" onmouseover='this.stop()' onmouseout='this.start()'><center>\n";

		$sql = "SELECT game_name, game_id, game_pic FROM ".$prefix."_bbgames ORDER BY game_order DESC LIMIT 0,$recent_scores";

		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result)) {
				$lastGame = $row['game_name'];
				$lastgameid = $row['game_id'];
				$lastgamepic = $row['game_pic'];
				$content .= "<a href=\"modules.php?name=Forums&file=games&gid=$lastgameid\"><img src=\"modules/Forums/games/pics/$lastgamepic\" border= \"0\" alt=\"$lastGame\"><br><b>$lastGame</b></a><br><br>\n";
		}

		$content .= "</center></marquee></td>\n";
		$content .= "</tr></table>\n";
}

if ($last_five) {
                $content .= "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspaceing=\"0\">\n";
                         $content .= "<tr>\n";
                         $content .= "<th colspan=\"4\" align=\"center\"><b>Lastest Hi-Scores</b></th>\n";
                         $content .= "</tr>\n";
                         $content .= "<tr>\n";
                         $content .= "<td class=\"row1\" align=\"center\"><B>User</B></td>\n";
                         $content .= "<td class=\"row2\" align=\"center\"><B>Score</B></td>\n";
                         $content .= "<td class=\"row1\" align=\"center\"><B>Game</B></td>\n";
                         $content .= "<td class=\"row2\" align=\"center\"><B>Date</B></td>\n";
                         $content .= "</tr>\n";

		         $place = 0;

		         $sql = "SELECT g.* , u.username FROM ".$prefix."_bbgames g, ".$prefix."_users u WHERE g.game_highuser = u.user_id ORDER BY game_highdate DESC LIMIT 0,$recent_scores";
                         $result = $db->sql_query($sql);

		         while ($row = $db->sql_fetchrow($result)) {
				$lastUser = $row['username'];
				$row['game_highscore'] = number_format($row['game_highscore']);
				$lasthighdate = date("D M d, Y g:i a" , $row['game_highdate']);

				$content .= "<tr>\n";
				$content .= "<td width=\"18%\" align=\"center\" class=\"row1\"><a href=\"modules.php?name=Forums&amp;file=statarcade&amp;uid=".$row['game_highuser']."\"><img src=\"modules/Forums/templates/subSilver/images/loupe.gif\" border= \"0\" alt=\"Jump to ".$row['username']."'s stats...\"></a><a href=\"modules.php?name=Forums&amp;file=profile&amp;mode=viewprofile&amp;u=".$row['game_highuser']."\">$lastUser</a> </b></td>\n";
				$content .= "<td width=\"18%\" align=\"center\" class=\"row2\"><b>".$row['game_highscore']."</b></td>\n";
				$content .= "<td width=\"34%\" align=\"left\" class=\"row1\"><b>&nbsp;&nbsp;<a href=\"modules.php?name=Forums&file=games&gid=".$row['game_id']."\"><img height=\"20\" width=\"20\" src=\"modules/Forums/games/pics/".$row['game_pic']."\" border= \"0\" alt=\"".$row['game_name']."\"></a> - ".$row['game_name']."</b></td>\n";
				$content .= "<td width=\"30%\" align=\"center\" class=\"row2\"><b>$lasthighdate</b></td>\n";
				$content .= "</tr>\n";
		        }

		   $content .= "</table>\n";
                   }

if ($arcade_stats) {
                $content .= "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspaceing=\"0\">\n";
		$content .= "<tr>\n";
                $content .= "<th width=\"100%\" colspan=\"2\" align=\"center\" class=\"th\"><b>Arcade Stats</b></th>\n";
                $content .= "</tr>\n";

                //Most Played Game
		$sql = "SELECT game_set, game_name, game_id FROM ".$prefix."_bbgames ORDER BY game_set DESC LIMIT 1";
		$row = $db->sql_fetchrow($db->sql_query($sql));

		$content .= "<tr>\n";
                $content .= "<td width=\"50%\" align=\"center\" class=\"row1\">Most Popular: <a href=\"modules.php?name=Forums&file=games&gid=".$row['game_id']."\"><b>".$row['game_name']."</b> </a>with <b>".$row['game_set']."</b> plays.</td>\n";

                //Least Played Game
		$sql = "SELECT game_set, game_name, game_id FROM ".$prefix."_bbgames ORDER BY game_set ASC LIMIT 1";
                $row = $db->sql_fetchrow($db->sql_query($sql));

		$content .= "<td width=\"50%\" align=\"center\" class=\"row1\">Least Popular: <a href=\"modules.php?name=Forums&file=games&gid=".$row['game_id']."\"> <b>".$row['game_name']."</b> </a>with <b>".$row['game_set']."</b> plays.</td>\n";
		$content .= "</tr>\n";
		
		//Category Stats
		$content .= "<tr>\n";
                $content .= "<td colspan=\"2\" width=\"10%\" height=\"25\"  align=\"center\" class=\"row1\"><marquee behavior= \"scroll\" align= \"center\" direction= \"left\" width=\"100%\" scrollamount= \"2\" scrolldelay= \"20\" onmouseover='this.stop()' onmouseout='this.start()'>\n";

		$sql = "SELECT arcade_cattitle, arcade_nbelmt, arcade_catid FROM ".$prefix."_bbarcade_categories ORDER BY arcade_cattitle";
                $result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result)) 
                {
                	$content .="<a href=\"modules.php?name=Forums&file=arcade&cid=".$row['arcade_catid']."\">\n";
			$content .="<b>".$row['arcade_cattitle']." (".$row['arcade_nbelmt']." Games)</B>\n";
			$content .="</a>&nbsp;&nbsp;&nbsp;\n";
		}
                $content .= "</marquee></td>\n";
                $content .= "</tr>\n";
		$content .= "</table>\n";
}

if ($whos_playing) {
                $content .= "<table width=\"100%\" border=\"0\" cellpadding=\"0\" cellspaceing=\"0\">\n";
		$content .= "<tr>\n";
                $content .= "<th width=\"100%\" colspan=\"2\" align=\"center\"><b>Who's Playing</b></th>\n";
                $content .= "</tr>\n";

		$sql = "SELECT u.username, u.user_id, u.user_level, user_allow_viewonline, g.game_name, g.game_id FROM ".$prefix."_bbgamehash gh LEFT JOIN ".$prefix."_bbsessions s ON gh.user_id = s.session_user_id LEFT JOIN ".$prefix."_users u ON gh.user_id = u.user_id LEFT JOIN ".$prefix."_bbgames g ON gh.game_id = g.game_id WHERE gh.hash_date >= s.session_time AND (" . time() . "- gh.hash_date <= 300) ORDER BY gh.hash_date DESC";

		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result)) {
				$players[] = $row;
		}

		$nbplayers = count($players);
		$listeid = array();
		$games_players = array();
		$games_names = array();

		if ($nbplayers != 0) {
				$content .="<tr>\n";
                                $content .="<td class=\"row1\"><B>Game</B></td>\n";
                                $content .="<td class=\"row2\"><B>Users</B></td>\n";

				for ($i=0 ; $i<$nbplayers ; $i++) {
						if (!isset($listeid[ $players[$i]['user_id'] ])) {
								$listeid[ $players[$i]['user_id'] ] = true ;

								if ($players[$i]['user_allow_viewonline']) 
                                                                {
										$player_link = '<a href=modules.php?name=Forums&amp;file=profile&amp;mode=viewprofile&amp;u='.$players[$i]['user_id']. '>' . $players[$i]['username'] . '</a>';
                                                                }
                                                                else 
                                                                {
                                                                                $player_link = '<a href=modules.php?name=Forums&amp;file=profile&amp;mode=viewprofile&amp;u='.$players[$i]['user_id']. '><i>' . $players[$i]['username'] . '</i></a>';
                                                                }

								if ($players[$i]['user_allow_viewonline'] || $userdata['user_level'] == 2) {
										if(!isset($games_names[ $players[$i]['game_id'] ])) {
												$games_names[ $players[$i]['game_id'] ] = $players[$i]['game_name'] ;
												$games_players[ $players[$i]['game_id'] ] = $player_link ;
										} else {
												$games_players[ $players[$i]['game_id'] ] .=  ', ' . $player_link ;
										}
								}
						}
				}
				foreach($games_names AS $key => $val) {
                //@RJR-Pwmg@Rncvkpwo@-@Eqratkijv@(e)@VgejIHZ.eqo
						if ($games_players[$key]!='') {
								$content .= "<tr>\n";
                                                                $content .= "<td width=\"30%\" class=\"row1\"><a href=\"modules.php?name=Forums&amp;file=games&amp;gid=$key\">$val</a></td>\n";
								$content .= "<td class=\"row2\">" .$games_players[$key]. "</td>\n";
                                                                $content .= "</tr>\n";
						}
				}
				$content .= "</table>";
		} else {
				$content .="<td colspan=\"2\" align=\"center\" class=\"row1\">There are currently no games being played in the arcade.</td>\n";
				$content .= "</table>\n";
		}
}

?>