<?php

/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2002 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
/*         Additional security & Abstraction layer conversion           */
/*                           2003 chatserv                              */
/*      http://www.nukefixes.com -- http://www.nukeresources.com        */
/************************************************************************/
/*					Surveys_Only v2.2_76				*/
/*         Modification un seul vote par personne et par sondage		*/
/*                    Par Cadav0r : cadav0r@cs-dhs.phpnet.org		*/
/************************************************************************/

if ( !defined('NUKE_FILE') ) {
    Header("Location: index.php");
    die();
}

global $prefix, $admin, $multilingual, $currentlang, $db, $dbi, $boxTitle, $content, $pollcomm, $user, $cookie, $HTTP_COOKIE_VARS, $cookiePrefix, $resultTableBgColor, $resultBarFile, $Default_Theme;

if ($multilingual == 1) {
    $querylang = "WHERE planguage='$currentlang' AND artid='0'";
} else {
    $querylang = "WHERE artid='0'";
}

$row = $db->sql_fetchrow($db->sql_query("SELECT pollID FROM ".$prefix."_poll_desc $querylang ORDER BY pollID DESC LIMIT 1"));
$pollID = intval($row['pollID']);
if ($pollID == 0 || $pollID == "") {
    $content = "";
} else {
    $cookieName = $cookiePrefix.Surveys.$pollID;
    // Verification de l'existence d'un cookie
    if($HTTP_COOKIE_VARS["$cookieName"] == "1") {
	    if(!isset($pollID)) { $pollID = 1; }
	    $pollID = intval($pollID);
	    $result = $db->sql_query("SELECT pollID, pollTitle, timeStamp, artid FROM ".$prefix."_poll_desc WHERE pollID='$pollID'");
	    $holdtitle = $db->sql_fetchrow($result);
	    $content .= "<b>$holdtitle[1]</b><br><br>";
		$i = intval($i);
	    for($i = 0; $i < 12; $i++) {
		$result2 = sql_query("SELECT optionCount FROM ".$prefix."_poll_data WHERE pollID='$pollID' AND voteID='$i'", $dbi);
		$object = sql_fetch_object($result2, $dbi);
		$optionCount = $object->optionCount;
		$sum = (int)$sum+$optionCount;
	    }
	    /* cycle through all options */
	    for($i = 1; $i <= 12; $i++) {
		/* select next vote option */
		$result3 = sql_query("SELECT pollID, optionText, optionCount, voteID FROM ".$prefix."_poll_data WHERE pollID='$pollID' AND voteID='$i'", $dbi);
		$object = sql_fetch_object($result3, $dbi);
		if(is_object($object)) {
		    $optionText = $object->optionText;
		    $optionCount = $object->optionCount;
		    if($optionText != "") {
			$content .= "$optionText";
			$content .= "<br>";
			if($sum) {
			    $percent = 100 * $optionCount / $sum;
			} else {
			    $percent = 0;
			}
			$percent2 = (int)$percent;
			$aff_percent = sprintf(" %.2f%%", $percent);
			if(is_user($user)) {
			    if($cookie[9]=="") $cookie[9]=$Default_Theme;
			    if(!$file=@opendir("themes/$cookie[9]")) {
				$ThemeSel = $Default_Theme;
			    } else {
				$ThemeSel = $cookie[9];
			    }
			} else {
			    $ThemeSel = $Default_Theme;
			}
			if (file_exists("themes/$ThemeSel/images/survey_leftbar.gif") AND file_exists("themes/$ThemeSel/images/survey_mainbar.gif") AND file_exists("themes/$ThemeSel/images/survey_rightbar.gif")) {
			    $l_size = getimagesize("themes/$ThemeSel/images/survey_leftbar.gif");
    			    $m_size = getimagesize("themes/$ThemeSel/images/survey_mainbar.gif");
			    $r_size = getimagesize("themes/$ThemeSel/images/survey_rightbar.gif");
			    $leftbar = "survey_leftbar.gif";
			    $mainbar = "survey_mainbar.gif";
			    $rightbar = "survey_rightbar.gif";
			} else {
			    $l_size = getimagesize("themes/$ThemeSel/images/leftbar.gif");
	    		    $m_size = getimagesize("themes/$ThemeSel/images/mainbar.gif");
			    $r_size = getimagesize("themes/$ThemeSel/images/rightbar.gif");
			    $leftbar = "leftbar.gif";
			    $mainbar = "mainbar.gif";
			    $rightbar = "rightbar.gif";
			}
			if ($percent > 0) {
			    	$content .= "<img src=\"themes/$ThemeSel/images/$leftbar\" height=\"$l_size[1]\" width=\"$l_size[0]\" alt=\"$aff_percent\" title=\"$aff_percent\">";
				$content .= "<img src=\"themes/$ThemeSel/images/$mainbar\" height=\"$m_size[1]\" width=\"$percent2\" alt=\"$aff_percent\" title=\"$aff_percent\">";
			    	$content .= "<img src=\"themes/$ThemeSel/images/$rightbar\" height=\"$r_size[1]\" width=\"$r_size[0]\" alt=\"$aff_percent\" title=\"$aff_percent\">";
			} else {
			    	$content .= "<img src=\"themes/$ThemeSel/images/$leftbar\" height=\"$l_size[1]\" width=\"$l_size[0]\" alt=\"$aff_percent\" title=\"$aff_percent\">";
			    	$content .= "<img src=\"themes/$ThemeSel/images/$mainbar\" height=\"$m_size[1]\" width=\"$m_size[0]\" alt=\"$aff_percent\" title=\"$aff_percent\">";
			    	$content .= "<img src=\"themes/$ThemeSel/images/$rightbar\" height=\"$r_size[1]\" width=\"$r_size[0]\" alt=\"$aff_percent\" title=\"$aff_percent\">";
			}
                	$content .= sprintf(" %.2f%% (%s)", $percent, $optionCount);
      	      $content .= "<br><br>";
		    }
		}
	    }
	    $content .= "<center><a href=\"modules.php?name=Surveys&amp;op=results&amp;pollID=$pollID&amp;mode=$cookie[4]&amp;order=$cookie[5]&amp;thold=$cookie[6]\">";
    	    if ($pollcomm) {
			$numcom = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_pollcomments WHERE pollID='$pollID'"));
	    		if ($sum > 0) {
	    			$content .= ""._VOTES." : <b>$sum</b>";
	    		} else {
	    			$content .= "<b>"._NOVOTE."</b>";
	    		}
			if ($numcom > 0) {
				$content .= "<br>"._PCOMMENTS." : <b>$numcom</b>";
	    		} else {
	    			$content .= "<br><b>"._NOCOMMENT."</b>";
	    		}
    	    } else {
	    		if ($sum > 0) {
	    			$content .= ""._VOTES." : <b>$sum</b>";
	    		} else {
	    			$content .= "<b>"._NOVOTE."</b>";
	    		}
   	    }
	    $content .= "</a></center>";
    } else {
    	if (!isset($url)) {
		$url = sprintf("modules.php?name=Surveys&amp;op=results&amp;pollID=%d", $pollID);
	}
	$content .= "<form action=\"modules.php?name=Surveys\" method=\"post\">";
    	$content .= "<input type=\"hidden\" name=\"pollID\" value=\"".$pollID."\">";
    	$content .= "<input type=\"hidden\" name=\"forwarder\" value=\"".$url."\">";
    	$row2 = $db->sql_fetchrow($db->sql_query("SELECT pollTitle, voters FROM ".$prefix."_poll_desc WHERE pollID='$pollID'"));
    	$pollTitle = $row2['pollTitle'];
    	$voters = intval($row2['voters']);
    	$boxTitle = _SURVEY;
    	$content .= "<center><font class=\"content\"><b>$pollTitle</b></font></center><br><br>\n";
    	$content .= "<table border=\"0\" width=\"100%\">";
    	for($i = 1; $i <= 12; $i++) {
		$row3 = $db->sql_fetchrow($db->sql_query("SELECT pollID, optionText, optionCount, voteID FROM ".$prefix."_poll_data WHERE (pollID='$pollID') AND (voteID='$i')"));
		if(isset($row3)) {
	    		$optionText = $row3['optionText'];
	    		if ($optionText != "") {
				$content .= "<tr><td valign=\"top\"><input type=\"radio\" name=\"voteID\" value=\"".$i."\"></td><td width=\"100%\"><font class=\"content\">$optionText</font></td></tr>\n";
	    		}
		}
    	}
    	$content .= "</table><br><center><font class=\"content\"><input type=\"submit\" value=\""._VOTE."\"></font><br>";
    	if (is_user($user)) {
		cookiedecode($user);
    	}
    	for($i = 0; $i < 12; $i++) {
		$row4 = $db->sql_fetchrow($db->sql_query("SELECT optionCount FROM ".$prefix."_poll_data WHERE (pollID='$pollID') AND (voteID='$i')"));
		$optionCount = intval($row4['optionCount']);
		$sum = (int)$sum+$optionCount;
    	}
	$content .= "<br><font class=\"content\"><a href=\"modules.php?name=Surveys&amp;op=results&amp;pollID=$pollID&amp;mode=$cookie[4]&amp;order=$cookie[5]&amp;thold=$cookie[6]\"><b>"._RESULTS."</b></a><br><a href=\"modules.php?name=Surveys\"><b>"._POLLS."</b></a><br><br>";

    	if ($pollcomm) {
		$numcom = $db->sql_numrows($db->sql_query("SELECT * FROM ".$prefix."_pollcomments WHERE pollID='$pollID'"));
		if ($sum > 0) {
			$content .= ""._VOTES." : <b>$sum</b>";
		} else {
			$content .= "<b>"._NOVOTE."</b>";
		}
		if ($numcom > 0) {
			$content .= "<br>"._PCOMMENTS." : <b>$numcom</b>";
		} else {
			$content .= "<br><b>"._NOCOMMENT."</b>";
		}
    	} else {
		if ($sum > 0) {
			$content .= ""._VOTES." : <b>$sum</b>";
		} else {
			$content .= "<b>"._NOVOTE."</b>";
		}
   	}
    	$content .= "</font></center></form>\n\n";
   }
}

?>