<?php
/***************************************************************************
 *                           usercp_viewprofile.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: usercp_viewprofile.php,v 1.5.2.3 2004/11/18 17:49:45 acydburn Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

/***************************************************************************
 * PHP-Nuke Platinum: Expect to be impressed                      COPYRIGHT
 *
 * Copyright (c) 2004 - 2006 by http://www.techgfx.com
 *     Techgfx - Graeme Allan                       (goose@techgfx.com)
 *
 * Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de
 *     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de)
 *
 * Refer to TechGFX.com for detailed information on PHP-Nuke Platinum
 *
 * TechGFX: Your dreams, our imagination
 ***************************************************************************/

if ( !defined('IN_PHPBB') )
{
        die("Hacking attempt");
        exit;
}

if ( empty($HTTP_GET_VARS[POST_USERS_URL]) || $HTTP_GET_VARS[POST_USERS_URL] == ANONYMOUS )
{
        message_die(GENERAL_MESSAGE, $lang['No_user_id_specified']);
}
$profiledata = get_userdata($HTTP_GET_VARS[POST_USERS_URL]);

/*****************************************************/
/* Forum - Buddy List v.0.9.5                  START */
/*****************************************************/
$buddy_id = ( isset($HTTP_GET_VARS['b']) ) ? $HTTP_GET_VARS['b'] : 0;
$buddy_action = ( isset($HTTP_GET_VARS['buddy_action']) ) ? ( ($HTTP_GET_VARS['buddy_action'] == 'add') ? 'add' : ( ($HTTP_GET_VARS['buddy_action'] == 'remove') ? 'remove' : '') ) : '';

//
// Add to/remove from buddylist
//
if ( $buddy_id )
{
	$redirect = POST_USERS_URL . '=' . $profiledata['user_id'];
	$redirect .= '&mode=viewprofile';

	if( !$userdata['session_logged_in'] )
	{
		$redirect .= ( isset($buddy_id) ) ? "&b=$buddy_id" : '';
		$redirect .= ( isset($buddy_action) ) ? "&buddy_action=$buddy_action" : '';
		$header_location = ( @preg_match("/Microsoft|WebSTAR|Xitami/", getenv("SERVER_SOFTWARE")) ) ? "Refresh: 0; URL=" : "Location: ";
		header($header_location . append_sid("login.$phpEx?redirect=profile.$phpEx&$redirect", true));
		exit;
	}

	//
	// Do not perform actions with yourself now...
	//
	if ( $buddy_id == $userdata['user_id'] )
	{
		message_die(GENERAL_MESSAGE, 'You cannot add/remove yourself to/from your buddylist');
	}

	//
	// Check if the user exists
	//
	$sql = "SELECT * FROM " . USERS_TABLE . " WHERE user_id = $buddy_id";
	if( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not query user information', '', __LINE__, __FILE__, $sql);
	}
	if ( !$row = $db->sql_fetchrow($result) )
	{
		message_die(GENERAL_MESSAGE, 'User does not exist');
	}

	//
	// See if user is already/not in the buddylist already
	//
	$sql = "SELECT * FROM " . BUDDIES_TABLE . "
			WHERE user_id = " . $userdata['user_id'] . "
				AND buddy_id = $buddy_id";
	if( !$result = $db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Could not query buddylist information', '', __LINE__, __FILE__, $sql);
	}

	if( ($buddy_action == 'add') && ($row = $db->sql_fetchrow($result)) )
	{
		message_die(GENERAL_MESSAGE, 'User is already in your buddylist');
	}
	else if( ($buddy_action == 'remove') && (!$row = $db->sql_fetchrow($result)) )
	{
		message_die(GENERAL_MESSAGE, 'User is not in your buddylist');
	}

	//
	// Perform add & remove now
	//
	if ( $buddy_action == 'add' )
	{
		$sql = "INSERT INTO " . BUDDIES_TABLE . " (user_id, buddy_id)
				VALUES (" . $userdata['user_id'] . ", $buddy_id)";
		if( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not add the user to your buddylist', '', __LINE__, __FILE__, $sql);
		}

		$message = $lang['Buddy_added'] . '<br /><br />' . sprintf($lang['Click_return_profile'], '<a href="' . append_sid ("profile.$phpEx?$redirect") . '">', '</a>');
	}

	if ( $buddy_action == 'remove' )
	{
		$sql = "DELETE FROM " . BUDDIES_TABLE . "
				WHERE user_id = " . $userdata['user_id'] . "
					AND buddy_id = $buddy_id";
		if ( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not remove the user from your buddylist', '', __LINE__, __FILE__, $sql);
		}

		$message = $lang['Buddy_removed'] . '<br /><br />' . sprintf($lang['Click_return_profile'], '<a href="' . append_sid("profile.$phpEx?$redirect") . '">', '</a>');
	}

	$template->assign_vars(array(
		'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("profile.$phpEx?$redirect") . '">')
		);

	message_die(GENERAL_MESSAGE, $message);
}
/*****************************************************/
/* Forum - Buddy List v.0.9.5                    END */
/*****************************************************/

$sql = "SELECT *
        FROM " . RANKS_TABLE . "
        ORDER BY rank_special, rank_min";
if ( !($result = $db->sql_query($sql)) )
{
        message_die(GENERAL_ERROR, 'Could not obtain ranks information', '', __LINE__, __FILE__, $sql);
}
$ranksrow = array();
while ( $row = $db->sql_fetchrow($result) )
{
        $ranksrow[] = $row;
}
$db->sql_freeresult($result);

/*****************************************************/
/* Forum - Buddy List v.0.9.5                  START */
/*****************************************************/
if ( $userdata['session_logged_in'] )
{
	$sql = "SELECT buddy_id FROM " . BUDDIES_TABLE . "
			WHERE user_id = " . $userdata['user_id'] . "
				AND buddy_id = " . $profiledata['user_id'];
}
if ( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, 'Could not obtain buddies information', '', __LINE__, __FILE__, $sql);
}

if ( $row = $db->sql_fetchrow($result) )
{
	$buddy_id = $row['buddy_id'];
}
/*****************************************************/
/* Forum - Buddy List v.0.9.5                    END */
/*****************************************************/

//
// Output page header and profile_view template
//
$template->set_filenames(array(
        'body' => 'profile_view_body.tpl')
);
if (is_active("Forums")) {
    make_jumpbox('viewforum.'.$phpEx);
}
//
// Calculate the number of days this user has been a member ($memberdays)
// Then calculate their posts per day
//
$regdate = $profiledata['user_regdate'];
$nukedate = strtotime($regdate);
$memberdays = max(1, round( ( time() - $nukedate ) / 86400 ));
$posts_per_day = $profiledata['user_posts'] / $memberdays;

// Get the users percentage of total posts
if ( $profiledata['user_posts'] != 0  )
{
        $total_posts = get_db_stat('postcount');
        $percentage = ( $total_posts ) ? min(100, ($profiledata['user_posts'] / $total_posts) * 100) : 0;
}
else
{
        $percentage = 0;
}

$avatar_img = '';
if ( $profiledata['user_avatar_type'] && $profiledata['user_allowavatar'] )
{
        switch( $profiledata['user_avatar_type'] )
        {
                case USER_AVATAR_UPLOAD:
                        $avatar_img = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
                        break;
                case USER_AVATAR_REMOTE:
                        $avatar_img = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
                        break;
                case USER_AVATAR_GALLERY:
                        $avatar_img = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $profiledata['user_avatar'] . '" alt="" border="0" />' : '';
                        break;
        }
}

$poster_rank = '';
$rank_image = '';
if ( $profiledata['user_rank'] )
{
        for($i = 0; $i < count($ranksrow); $i++)
        {
                if ( $profiledata['user_rank'] == $ranksrow[$i]['rank_id'] && $ranksrow[$i]['rank_special'] )
                {
                        $poster_rank = $ranksrow[$i]['rank_title'];
                        $rank_image = ( $ranksrow[$i]['rank_image'] ) ? '<img src="' . $ranksrow[$i]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                }
        }
}
else
{
        for($i = 0; $i < count($ranksrow); $i++)
        {
                if ( $profiledata['user_posts'] >= $ranksrow[$i]['rank_min'] && !$ranksrow[$i]['rank_special'] )
                {
                        $poster_rank = $ranksrow[$i]['rank_title'];
                        $rank_image = ( $ranksrow[$i]['rank_image'] ) ? '<img src="' . $ranksrow[$i]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                }
        }
}
        {
                if ( $profiledata['user_posts'] >= $ranksrow[$i]['rank_min'] && !$ranksrow[$i]['rank_special'] )
                {
                        $poster_rank = $ranksrow[$i]['rank_title'];
                        $rank_image = ( $ranksrow[$i]['rank_image'] ) ? '<img src="' . $ranksrow[$i]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';
                }
        }

/*****************************************************/
/* Forum - Buddy List v.0.9.5                  START */
/*****************************************************/
$buddy_img = '';
$buddy = '';

if ( $userdata['session_logged_in'] && ( $userdata['user_id'] != $profiledata['user_id'] ) )
{
	$redirect = POST_USERS_URL . '=' . $profiledata['user_id'];
	$redirect .= '&amp;mode=viewprofile';
	$redirect .= '&amp;b=' . $profiledata['user_id'];
	
	if ( $buddy_id )
	{
		$redirect .= '&amp;buddy_action=remove';
		$buddy_img = '<a href="' . append_sid("profile.$phpEx?$redirect") . '"><img src="' . $images['icon_buddy_remove'] . '" alt="' . $lang['Remove_buddy_list'] . '" border="0"></a>';
		$buddy = '<a href="' . append_sid("profile.$phpEx?$redirect") . '">' . $lang['Remove_buddy_list'] . '</a>';
	}
	else
	{
		$redirect .= '&amp;buddy_action=add';
		$buddy_img = '<a href="' . append_sid("profile.$phpEx?$redirect") . '"><img src="' . $images['icon_buddy'] . '" alt="' . $lang['Add_buddy_list'] . '" border="0"></a>';
		$buddy = '<a href="' . append_sid("profile.$phpEx?$redirect") . '">' . $lang['Add_buddy_list'] . '</a>';
	}
}
/*****************************************************/
/* Forum - Buddy List v.0.9.5                    END */
/*****************************************************/

$temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $profiledata['user_id']);
if (is_active("Private_Messages")) {
    $pm_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
    $pm = '<a href="' . $temp_url . '">' . $lang['Send_private_message'] . '</a>';
}

if ( !empty($profiledata['user_viewemail']) || $userdata['user_level'] == ADMIN )
{
        $email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $profiledata['user_id']) : 'mailto:' . $profiledata['user_email'];

        //@RJR-Pwmg@Rncvkpwo@-@Eqratkijv@(e)@VgejIHZ.eqo
        $email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
        $email = '<a href="' . $email_uri . '">' . $lang['Send_email'] . '</a>';
}
else
{
        $email_img = '&nbsp;';
        $email = '&nbsp;';
}
if (( $profiledata['user-website'] == "http:///") || ( $profiledata['user_website'] == "http://")){
    $profiledata['user_website'] =  "";
}
if (($profiledata['user_website'] != "" ) && (substr($profiledata['user_website'],0, 7) != "http://")) {
    $profiledata['user_website'] = "http://".$profiledata['user_website'];
}

$www_img = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '&nbsp;';
$www = ( $profiledata['user_website'] ) ? '<a href="' . $profiledata['user_website'] . '" target="_userwww">' . $profiledata['user_website'] . '</a>' : '&nbsp;';

if ( !empty($profiledata['user_icq']) )
{
        $icq_status_img = '<a href="http://wwp.icq.com/' . $profiledata['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $profiledata['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
        $icq_img = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
        $icq =  '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $profiledata['user_icq'] . '">' . $lang['ICQ'] . '</a>';
}
else
{
        $icq_status_img = '&nbsp;';
        $icq_img = '&nbsp;';
        $icq = '&nbsp;';
}

$aim_img = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '&nbsp;';
$aim = ( $profiledata['user_aim'] ) ? '<a href="aim:goim?screenname=' . $profiledata['user_aim'] . '&amp;message=Hello+Are+you+there?">' . $lang['AIM'] . '</a>' : '&nbsp;';

$msn_img = ( $profiledata['user_msnm'] ) ? $profiledata['user_msnm'] : '&nbsp;';
$msn = $msn_img;

$yim_img = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
$yim = ( $profiledata['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $profiledata['user_yim'] . '&amp;.src=pg">' . $lang['YIM'] . '</a>' : '';

$temp_url = append_sid("search.$phpEx?search_author=" . urlencode($profiledata['username']) . "&amp;showresults=posts");
$search_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_search'] . '" alt="' . $lang['Search_user_posts'] . '" title="' . $lang['Search_user_posts'] . '" border="0" /></a>';
$search = '<a href="' . $temp_url . '">' . $lang['Search_user_posts'] . '</a>';

//
// Generate page
//
$page_title = $lang['Viewing_profile'];
include("includes/page_header.php");
/*****************************************************/
/* Forum - User Online Status v.1.0.5          START */
/*****************************************************/
if ( $profiledata['user_session_time'] >= (time()-60) )
{
	if ( $profiledata['user_allow_viewonline'] )
	{
		$online_status = '<b><a href="' . append_sid("viewonline.$phpEx") . '" title="' . sprintf($lang['is_online'], $profiledata['username']) . '"' . $online_color . '>' . $lang['Online'] . '</a></b>';
	}
	else if ( ( $userdata['user_level'] == ADMIN ) || ( $userdata['user_id'] == $profiledata['user_id'] ) )
	{
		$online_status = '<b><i><a href="' . append_sid("viewonline.$phpEx") . '" title="' . sprintf($lang['is_hidden'], $profiledata['username']) . '"' . $hidden_color . '>' . $lang['Hidden'] . '</a></i></b>';
	}
	else
	{
		$online_status = '<b><span title="' . sprintf($lang['is_offline'], $profiledata['username']) . '"' . $offline_color . '>' . $lang['Offline'] . '</span></b>';
	}
}
else
{
	$online_status = '<b><span title="' . sprintf($lang['is_offline'], $profiledata['username']) . '"' . $offline_color . '>' . $lang['Offline'] . '</span></b>';
}
/*****************************************************/
/* Forum - User Online Status v.1.0.5            END */
/*****************************************************/
display_upload_attach_box_limits($profiledata['user_id']);
$profiledata['user_from'] = str_replace(".gif", "", $profiledata['user_from']);

$template->assign_vars(array(
        'USERNAME' => $profiledata['username'],
        'JOINED' => $profiledata['user_regdate'],
        'POSTER_RANK' => $poster_rank,
        'RANK_IMAGE' => $rank_image,
        'POSTS_PER_DAY' => $posts_per_day,
        'POSTS' => $profiledata['user_posts'],
        'PERCENTAGE' => $percentage . '%',
        'POST_DAY_STATS' => sprintf($lang['User_post_day_stats'], $posts_per_day),
        'POST_PERCENT_STATS' => sprintf($lang['User_post_pct_stats'], $percentage),
        'SEARCH_IMG' => $search_img,
        'SEARCH' => $search,
        'PM_IMG' => $pm_img,
        'PM' => $pm,
        'EMAIL_IMG' => $email_img,
        'EMAIL' => $email,
        'WWW_IMG' => $www_img,
        'WWW' => $www,
/*****************************************************/
/* Forum - Buddy List v.0.9.5                  START */
/*****************************************************/
        'BUDDY_IMG' => $buddy_img,
        'BUDDY' => $buddy,
/*****************************************************/
/* Forum - Buddy List v.0.9.5                    END */
/*****************************************************/
        'ICQ_STATUS_IMG' => $icq_status_img,
        'ICQ_IMG' => $icq_img,
        'ICQ' => $icq,
        'AIM_IMG' => $aim_img,
        'AIM' => $aim,
        'MSN_IMG' => $msn_img,
        'MSN' => $msn,
        'YIM_IMG' => $yim_img,
        'YIM' => $yim,

        'LOCATION' => ( $profiledata['user_from'] ) ? $profiledata['user_from'] : '&nbsp;',
        'OCCUPATION' => ( $profiledata['user_occ'] ) ? $profiledata['user_occ'] : '&nbsp;',
        'INTERESTS' => ( $profiledata['user_interests'] ) ? $profiledata['user_interests'] : '&nbsp;',
        'AVATAR_IMG' => $avatar_img,

        'L_VIEWING_PROFILE' => sprintf($lang['Viewing_user_profile'], $profiledata['username']),
        'L_ABOUT_USER' => sprintf($lang['About_user'], $profiledata['username']),
        'L_AVATAR' => $lang['Avatar'],
        'L_POSTER_RANK' => $lang['Poster_rank'],
        'L_JOINED' => $lang['Joined'],
        'L_TOTAL_POSTS' => $lang['Total_posts'],
        'L_SEARCH_USER_POSTS' => sprintf($lang['Search_user_posts'], $profiledata['username']),
        'L_CONTACT' => $lang['Contact'],
        'L_EMAIL_ADDRESS' => $lang['Email_address'],
        'L_EMAIL' => $lang['Email'],
        'L_PM' => $lang['Private_Message'],
        'L_ICQ_NUMBER' => $lang['ICQ'],
        'L_YAHOO' => $lang['YIM'],
        'L_AIM' => $lang['AIM'],
        'L_MESSENGER' => $lang['MSNM'],
        'L_WEBSITE' => $lang['Website'],
/*****************************************************/
/* Forum - Buddy List v.0.9.5                  START */
/*****************************************************/
        'L_BUDDY' => $lang['Buddy'],
/*****************************************************/
/* Forum - Buddy List v.0.9.5                    END */
/*****************************************************/
        'L_LOCATION' => $lang['Location'],
        'L_OCCUPATION' => $lang['Occupation'],
        'L_INTERESTS' => $lang['Interests'],
/*****************************************************/
/* Forum - Arcade v.3.0.2                      START */
/*****************************************************/
        'L_ARCADE' => $lang['lib_arcade'],
        'URL_STATS' => '<a class="genmed" href="' . append_sid("statarcade.$phpEx?uid=" . $profiledata['user_id'] ) . '">' . $lang['statuser'] . '</a> ',
/*****************************************************/
/* Forum - Arcade v.3.0.2                        END */
/*****************************************************/
/*****************************************************/
/* Forum - User Online Status v.1.0.5          START */
/*****************************************************/
        'ONLINE_STATUS' => $online_status,
        'L_ONLINE_STATUS' => $lang['Online_status'],
/*****************************************************/
/* Forum - User Online Status v.1.0.5            END */
/*****************************************************/

	'U_SEARCH_USER' => append_sid("search.$phpEx?search_author=" . $u_search_author),

	'S_PROFILE_ACTION' => append_sid("profile.$phpEx"))
);

$template->pparse('body');

include("includes/page_tail.php");

?>