<?php

/************************************************************************/
/* PHP-NUKE: Web Portal System                                          */
/* ===========================                                          */
/*                                                                      */
/* Copyright (c) 2002 by Francisco Burzi                                */
/* http://phpnuke.org                                                   */
/*                                                                      */
/* Contact Plus V2.2 for Nuke 6.0                                       */
/* Copyright (c) 2002 by Shawn Archer                                   */
/* http://www.NukeStyles.com                                            */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/
/* PHP-Nuke Platinum: Expect to be impressed                  COPYRIGHT */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.techgfx.com                  */
/*     Techgfx - Graeme Allan                       (goose@techgfx.com) */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de            */
/*     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de) */
/*                                                                      */
/* Refer to TechGFX.com for detailed information on PHP-Nuke Platinum   */
/*                                                                      */
/* TechGFX: Your dreams, our imagination                                */
/************************************************************************/

##################################################
#              Title Definitions                 #
##################################################

define("_NSINDEXLEGAL","Legal Notices");
define("_NSABOUTUS","About Us");
define("_NSDISCLAIMER","Disclaimer Statement");
define("_NSPRIVACY","Privacy Statement");
define("_NSTERMS","Terms of Use");
// MrFluffy
define("_NSFEEDBACK","If you have any questions, comments, or suggestions about these Legal Notices, please use our <a href=\"modules.php?name=Feedback\">Feedback Form</a>.<br><br>");
define("_NSCONTACT","If you have any questions, comments, or suggestions about these Legal Notices, please use our <a href=\"modules.php?name=Contact\">Contact Form</a>.<br><br>");



##################################################
#              Index Definitions                 #
##################################################

define("_NSINDEX1","authorizes you to view, download, and interact with materials, services, and forums on this website. Unless otherwise specified, the services & downloads provided by");
define("_NSINDEX2","are for your personal and/or commercial use, provided that you retain all copyright and other proprietary notices contained in the original materials.");
define("_NSINDEX3","The materials at");
define("_NSINDEX4","are copyrighted and any unauthorized use of these materials may violate copyrights and/or trademarks.");
define("_NSINDEX5","These documents are for our protection and yours as well. Please read them carefully.");



##################################################
#            Terms of Use Definitions            #
##################################################

define("_NSTERMSUSE1","1. Acceptance of Terms of Use and Amendments");
define("_NSTERMSUSE1a","Each time you use or cause access to this web site, you agree to be bound by these Terms of Use, and as amended from time to time with or without notice to you. In addition, if you are using a particular service on or through this web site, you will be subject to any rules or guidelines applicable to those services and they shall be incorporated by reference into these Terms of Use. Please see our");
define("_NSTERMSUSE1b","which is incorporated into these Terms of Use by reference.");
define("_NSTERMSUSE2","2. Our Service");
define("_NSTERMSUSE2a","Our web site and services provided to you on and through our web site on an AS IS basis.You agree that the owners of this web site exclusively reserve the right and may, at any time and without notice and any liability to you, modify or discontinue this web site and its services or delete the data you provide, whether temporarily or permanently. We shall have no responsibilty or liability for the timeliness, deletion, failure to store, inaccuracy, or improper delivery of any data or information.");
define("_NSTERMSUSE3","3. Your Responsibilities and Registration Obligations");
define("_NSTERMSUSE3a","In order to use this web site, you must register on our site, agree to provide truthful information when requested, and be at least the age of thirteen (13) or older. When registering, you explicitly agree to our Terms of Use and as may be modified by us from time to time and available here.");
define("_NSTERMSUSE4","4. Privacy Policy");
define("_NSTERMSUSE4a","Registration data and other personally identifiable information that we may collect is subject to the terms of our");
define("_NSTERMSUSE5","5. Registration and Password");
define("_NSTERMSUSE5a","You are responsible to maintain the confidentiality of your password and shall be responsible for all uses via your registration and/or login, whether authorized or unauthorized by you. You agree to immediately notify us of any unauthorized use or your registration, user account or password.");
define("_NSTERMSUSE6","6. Your Conduct");
define("_NSTERMSUSE6a","You agree that all information or data of any kind, whether text, software, code, music or sound, photographs or graphics, video or other materials (Content), publicly or privately provided, shall be the sole responsibility of the person providing the Content or the person whose user account is used. You agree that our web site may expose you to Content that may be objectionable or offensive. We shall not be responsible to you in any way for the Content that appears on this web site nor for any error or omission.");
define("_NSTERMSUSE6b","You explicitly agree, in using this web site or any service provided, that you shall not:");
define("_NSTERMSUSE6c","<b>(a)</b> Provide any Content or perform any conduct that may be unlawful, illegal, threatening, harmful, abusive, harassing, stalking, tortious, defamatory, libelous, vulgar, obscene, offensive, objectionable, pornographic, designed to or does interfere or interrupt this web site or any service provided, infected with a virus or other destructive or deleterious programming routine, give rise to civil or criminal liability, or which may violate an applicable local, national or international law;");
define("_NSTERMSUSE6d","<b>(b)</b> Impersonate or misrepresent your association with any person or entity, or forge or otherwise seek to conceal or misrepresent the origin of any Content provided by you;");
define("_NSTERMSUSE6e","<b>(c)</b> Collect or harvest any data about other users;");
define("_NSTERMSUSE6f","<b>(d)</b> Provide or use this web site and any Content or service in any commercial manner or in any manner that would involve junk mail, spam, chain letters, pyramid schemes, or any other form of unauthorized advertising without our prior written consent;");
define("_NSTERMSUSE6g","<b>(e)</b> Provide any Content that may give rise to our civil or criminal liability or which may consititue or be considered a violation of any local, national or international law, including but not limited to laws relating to copyright, trademark, patent, or trade secrets.");
define("_NSTERMSUSE7","7. Submission of Content on this Web Site");
define("_NSTERMSUSE7a","By providing any Content to our web site:");
define("_NSTERMSUSE7b","<b>(a)</b> you agree to grant to us a worldwide, royalty-free, perpetual, non-exclusive right and license (including any moral rights or other necessary rights) to use, display, reproduce, modify, adapt, publish, distribute, perform, promote, archive, translate, and to create derivative works and compilations, in whole or in part. Such license will apply with respect to any form, media, technology known or later developed;");
define("_NSTERMSUSE7c","<b>(b)</b> you warrant and represent that you have all legal, moral, and other rights that may be necessary to grant us with the license set forth in this Section 7;");
define("_NSTERMSUSE7d","<b>(c)</b> you acknowledge and agree that we shall have the right (but not obligation), in our sole discretion, to refuse to publish or to remove or block access to any Content you provide at any time and for any reason, with or without notice.");
define("_NSTERMSUSE8","8. Third Party Services");
define("_NSTERMSUSE8a","Goods and services of third parties may be advertised and/or made available on or through this web site. Representations made regarding products and services provided by third parties are governed by the policies and representations made by these third parties. We shall not be liable for or responsible in any manner for any of your dealings or interaction with third parties.");
define("_NSTERMSUSE9","9. Indemnification");
define("_NSTERMSUSE9a","You agree to indemnify and hold us harmless, our subsidiaries, affiliates, related parties, officers, directors, employees, agents, independent contractors, advertisers, partners, and co-branders from any claim or demand, including reasonable attorney's fees, that may be made by any third party, that is due to or arising out of your conduct or connection with this web site or service, your provision of Content, your violation of this Terms of Use or any other violation of the rights of another person or party.");
define("_NSTERMSUSE10","10. DISCLAIMER OF WARRANTIES");
define("_NSTERMSUSE10a","YOU UNDERSTAND AND AGREE THAT YOUR USE OF THIS WEB SITE AND ANY SERVICES OR CONTENT PROVIDED (THE SERVICE) IS MADE AVAILABLE AND PROVIDED TO YOU AT YOUR OWN RISK. IT IS PROVIDED TO YOU AS IS AND WE EXPRESSLY DISCLAIM ALL WARRANTIES OF ANY KIND, IMPLIED OR EXPRESS, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.");
define("_NSTERMSUSE10b","WE MAKE NO WARRANTY, IMPLIED OR EXPRESS, THAT ANY PART OF THE SERVICE WILL BE UNINTERRUPTED, ERROR-FREE, VIRUS-FREE, TIMELY, SECURE, ACCURATE, RELIABLE, OF ANY QUALITY, NOR THAT ANY CONTENT IS SAFE IN ANY MANNER FOR DOWNLOAD. YOU UNDERSTAND AND AGREE THAT NEITHER US NOR ANY PARTICIPANT IN THE SERVICE PROVIDES PROFESSIONAL ADVICE OF ANY KIND AND THAT USE OF SUCH ADVICE OR ANY OTHER INFORMATION IS SOLELY AT YOUR OWN RISK AND WITHOUT OUR LIABILITY OF ANY KIND.");
define("_NSTERMSUSE10c","Some jurisdictions may not allow disclaimers of implied warranties and the above disclaimer may not apply to you only as it relates to implied warranties.");
define("_NSTERMSUSE11","11. LIMITATION OF LIABILITY");
define("_NSTERMSUSE11a","YOU EXPRESSLY UNDERSTAND AND AGREE THAT WE SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INDICENTAL, CONSEQUENTIAL OR EXEMPLARY DAMAGES, INCLUDING BUT NOT LIMITED TO, DAMAGES FOR LOSS OF PROFITS, GOODWILL, USE, DATA OR OTHER INTANGIBLE LOSS (EVEN IF WE HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES), RESULTING FROM OR ARISING OUT OF (I) THE USE OF OR THE INABILITY TO USE THE SERVICE, (II) THE COST TO OBTAIN SUBSTITUTE GOODS AND/OR SERVICES RESULTING FROM ANY TRANSACTION ENTERED INTO ON THROUGH THE SERVICE, (III) UNAUTHORIZED ACCESS TO OR ALTERATION OF YOUR DATA TRANSMISSIONS, (IV) STATEMENTS OR CONDUCT OF ANY THIRD PARTY ON THE SERVICE, OR (V) ANY OTHER MATTER RELATING TO THE SERVICE.");
define("_NSTERMSUSE11b","In some jurisdictions, it is not permitted to limit liability and therefore such limitations may not apply to you.");
define("_NSTERMSUSE12","12. Reservation of Rights");
define("_NSTERMSUSE12a","We reserve all of our rights, including but not limited to any and all copyrights, trademarks, patents, trade secrets, and any other proprietary right that we may have in our web site, its content, and the goods and services that may be provided. The use of our rights and property requires our prior written consent. We are not providing you with any implied or express licenses or rights by making services available to you and you will have no rights to make any commercial uses of our web site or service without our prior written consent.");
define("_NSTERMSUSE13","13. Applicable Law");
define("_NSTERMSUSE13a","You agree that this Terms of Use and any dispute arising out of your use of this web site or our products or services shall be governed by and construed in accordance with local laws where the headquarters of the owner of this web site is located, without regard to its conflict of law provisions. By registering or using this web site and service you consent and submit to the exclusive jurisdiction and venue of the county or city where the headquarters of the owner of this web site is located.");
define("_NSTERMSUSE14","14. Miscellaneous Information");
define("_NSTERMSUSE14a","<b>(i)</b> In the event that this Terms of Use conflicts with any law under which any provision may be held invalid by a court with jurisdiction over the parties, such provision will be interpreted to reflect the original intentions of the parties in accordance with applicable law, and the remainder of this Terms of Use will remain valid and intact;");
define("_NSTERMSUSE14b","<b>(ii)</b> The failure of either party to assert any right under this Terms of Use shall not be considered a waiver of any that party's right and that right will remain in full force and effect;");
define("_NSTERMSUSE14c","<b>(iii)</b> You agree that without regard to any statue or contrary law that any claim or cause arising out of this web site or its services must be filed within one (1) year after such claim or cause arose or the claim shall be forever barred;");
define("_NSTERMSUSE14d","<b>(iv)</b> We may assign our rights and obligations under this Terms of Use and we shall be relieved of any further obligation.");



##################################################
#             Disclaimer Definitions             #
##################################################

define("_NSDISCLAIM1","is not responsible for any of the Articles, Comments, Reviews, or User Names, as the poster of the particular Article, Comment, Review, or User Name on");
define("_NSDISCLAIM2","assumes full responsibility.");
define("_NSDISCLAIM3","disclaims any and all responsibility or liability for the accuracy, content, completeness, legality, reliability, operability, or availability of information or material displayed on this site.");
define("_NSDISCLAIM4","disclaims any responsibility for any harm resulting from downloading or accessing any information or material on");
define("_NSDISCLAIM5","contains links to other Internet sites. These links are provided solely as a convenience to you and are not endorsements of any products or services in such sites, and no information in such site has been endorsed or approved by");
define("_NSDISCLAIM6","These third party sites may also contain opinions and viewpoints of third parties that do not necessarily coincide with our opinions and viewpoints. Those sites may also have privacy policies different than our own privacy policy.");
define("_NSDISCLAIM7","All materials, information, products & services included on");
define("_NSDISCLAIM8","are provided \"AS IS\", with <b>no warranties</b> whatsoever.");
define("_NSDISCLAIM9","expressly disclaims to the fullest extent permitted by law all express, implied, and statutory warranties.");
define("_NSDISCLAIM10","disclaims any warranties for services or goods received through or advertised on");
define("_NSDISCLAIM11","All Logo's and Images are property of thier respectful owner. All HTML and Databases on");
define("_NSDISCLAIM12","are <b> Copyright 2005</b>");


##################################################
#               Privacy Definitions              #
##################################################

define("_NSPRIVACY1","We respect and are committed to protecting your privacy. This Privacy Policy lets you know how your personal information is processed and used at");
define("_NSPRIVACY2","We take extraordinary steps to use your personal information only in ways that are compatible with this Privacy Policy.");
define("_NSPRIVACY3","Information Collection");
define("_NSPRIVACY4","is the sole owner of the information collected from our website. We do not, or will not sell, share, or rent this information to others in ways different from what is disclosed in our privacy statement below.");
define("_NSPRIVACY5","Cookies");
define("_NSPRIVACY6","A cookie is a piece of data stored on the visitor's hard drive containing information about the visitor. Advertisers connected to");
define("_NSPRIVACY7","at times require cookies to tract statistics about products and locations, but at no time are these linked to any personal identification. At this time");
define("_NSPRIVACY8","uses cookies only for login convenience.");
define("_NSPRIVACY9","Log Files");
define("_NSPRIVACY10","keeps log files on broad fields to analyze trends, track user movements, and gather data for demographic locations. This is not attached in anyway to visitor's personal identification.");
define("_NSPRIVACY11","Sharing");
define("_NSPRIVACY12","At this time,");
define("_NSPRIVACY13","does not share any information with advertisers, merchants, or any other third party.");
define("_NSPRIVACY14","Links");
define("_NSPRIVACY15","Links to other sites outside of");
define("_NSPRIVACY16","do not apply to this privacy statement. We are not responsible for privacy policies of other websites linked to");
define("_NSPRIVACY17","Please read the privacy statement of each website linked to");
define("_NSPRIVACY18","for information and data use for visitor's personal identification. Our privacy statement applies solely to");
define("_NSPRIVACY19","Contests");
define("_NSPRIVACY20","At any particular time,");
define("_NSPRIVACY21","will conduct contests for our visitor's. Visitor participation for these contests is voluntary, and in no way requires the visitor to give out personal information when choosing not to enter in the contest. Collected information may include contact information and demographic information, such as name, e-mail, address, state, ect. This information will be used to notify the winners and award prizes.");
define("_NSPRIVACY22","Newsletter");
define("_NSPRIVACY23","After registering for a Membership, you are given the choice of subscribing to our Newsletter. You can either elect to subscribe or unsubscribe at any time. All information stored on our database is not shared or sold to any third party what so ever. Subscribers wishing to unsubscribe to our newsletter can uncheck the option in their account, using the 'Your Information' link.");
define("_NSPRIVACY24","Sending to a Friend");
define("_NSPRIVACY25","When a visitor chooses to send News, Articles, Reviews, ect, to a friend, the names and e-mail addresses are <b>not</b> logged.");
define("_NSPRIVACY26","will send the friend a one-time e-mail inviting them to visit our site.");
define("_NSPRIVACY27","will never send another e-mail to the visitor or friend for any purpose.");
define("_NSPRIVACY28","Changes of our Policy");
define("_NSPRIVACY29","If and when our policy statement changes, visitors with Memberships in our databases will be notified of the changes, and provided a link to this page to view the changes. If a visitor decides that our policy does not benefit them, they can use the opt-out option at anytime.");








?>

