<?php

/***************************************************************************
 * PHP-Nuke Platinum: Expect to be impressed                      COPYRIGHT
 *
 * Copyright (c) 2004 - 2006 by http://www.techgfx.com
 *     Techgfx - Graeme Allan                       (goose@techgfx.com)
 *
 * Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de
 *     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de)
 *
 * Refer to TechGFX.com for detailed information on PHP-Nuke Platinum
 *
 * TechGFX: Your dreams, our imagination
 ***************************************************************************/

/*
* Addon for the Acronym mod from CodeMonkeyX
* Originally made for PHP-Nuke 6.5 by Mighty_Y <http://www.portedmods.com>
* but then also made for phpBB standalone as an act of respect for CodeMonkeyX
*/

if (!stristr($_SERVER['SCRIPT_NAME'], "modules.php")) {
    die ("You can't access this file directly...");
}

if ($popup != "1"){
    $module_name = basename(dirname(__FILE__));
    require("modules/".$module_name."/nukebb.php");
}
else
{
    $phpbb_root_path = 'modules/Forums/';
}
define('IN_PHPBB', 1);

$phpbb_root_path = 'modules/Forums/';

include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_VIEWMEMBERS, $nukeuser);
init_userprefs($userdata);
//
// End session management
//
$page_title = $lang['Acronyms'];

include('includes/page_header.'.$phpEx);

$template->set_filenames(array(
	"body" => "acronym_body.tpl")
);
	
$sql = "SELECT * FROM " . ACRONYMS_TABLE . "
		ORDER BY acronym ASC";

if( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, "Could not obtain acronym data", "", __LINE__, __FILE__, $sql);
}

$i=0;

while( $acronym_row = $db->sql_fetchrow($result) )
{	
	$acronym = $acronym_row['acronym'];
	$description = $acronym_row['description'];
	$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];
	$template->assign_block_vars("acronym_row", array(
		"ROW_CLASS" => $row_class,
		"ACRONYM" => $acronym,
		"DESCRIPTION" => $description,
			)
	);	
	$i++;
}

$template->assign_vars(array(
    'L_ACRONYM' => $lang['Acronym'],
    'L_DESCRIPTION' => $lang['Description'],
)
);

$template->pparse("body");

include('includes/page_tail.'.$phpEx);
?>

