<?php
/***************************************************************************
*     begin                : Thu Oct 30, 2003
*     copyright            : (C) 2003 Pokemaster
*     email                : aaronboffin@hotmail.com
*
****************************************************************************/

/***************************************************************************
 * PHP-Nuke Platinum: Expect to be impressed                      COPYRIGHT
 *
 * Copyright (c) 2004 - 2006 by http://www.techgfx.com
 *     Techgfx - Graeme Allan                       (goose@techgfx.com)
 *
 * Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de
 *     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de)
 *
 * Refer to TechGFX.com for detailed information on PHP-Nuke Platinum
 *
 * TechGFX: Your dreams, our imagination
 ***************************************************************************/

define('IN_PHPBB', 1);

//
// First we do the setmodules stuff for the admin cp.
//
if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['Reports']['Categories'] = $filename;

	return;
}

//
// Load default header
//
$no_page_header = TRUE;
$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_report.' . $phpEx);

$mode = ( isset($HTTP_POST_VARS['mode']) ) ? $HTTP_POST_VARS['mode'] : $HTTP_GET_VARS['mode'];
$id = ( isset($HTTP_POST_VARS['id']) ) ? $HTTP_POST_VARS['id'] : $HTTP_GET_VARS['id'];
$submit = ( isset($HTTP_POST_VARS['submit']) ) ? TRUE : 0;
$name = ( isset($HTTP_POST_VARS['name']) ) ? $HTTP_POST_VARS['name'] : $HTTP_GET_VARS['name'];
$param = ( isset($HTTP_POST_VARS['param']) ) ? $HTTP_POST_VARS['param'] : $HTTP_GET_VARS['param'];
$explain = ( isset($HTTP_POST_VARS['explain']) ) ? $HTTP_POST_VARS['explain'] : $HTTP_GET_VARS['explain'];
//
// Output the authorisation details
//
$template->set_filenames(array(
	'body' => 'admin/report_cat_body.tpl'
	)
);


$hidden_fields = '<input type="hidden" name="mode" value="create" />';

$template->assign_vars(array(
    'S_ACTION' => append_sid("admin_report_cat.php"),

    'L_TITLE' => $lang['report_cat_title'],
    'L_EXP' => $lang['report_cat_explain'],
    'L_CAT' => $lang['report_category'],
    'L_DELETE' => $lang['report_delete'],
    'L_EDIT' => $lang['report_edit'],
    'L_CREATE' =>$lang['report_cat_create'],
    'L_SUBMIT' => $lang['Submit'],
    'L_PARAM' => $lang['report_param'],
    'L_EXPLAIN' => $lang['report_exp'])
);


if ( $mode == 'delete' && $id != '' )
{
    $sql  = "DELETE FROM " . REPORTS . " WHERE report_type = $id";
    if( !($result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not delete reports', '', __LINE__, __FILE__, $sql);
    }
    $sql  = "DELETE FROM " . REPORT_CAT . " WHERE cat_id = $id";
    if( !($result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not delete category', '', __LINE__, __FILE__, $sql);
    } else
    {
        $msg = sprintf( $lang['report_cat_deleted'], '<a href="' . append_sid("admin_report_cat.php") . '">', '</a>' );
        message_die(GENERAL_MESSAGE, $msg, 'Information');
    }
}
else if ( $mode == 'create' && $submit )
{
    if ( $name == '' or $param == '' or $param == 'finished' or $param == 'notfinished' or $param == 'finish' or $param == 'delete' or ( $row['cat_id'] == 1 and $param != 'reportpost') )
    {
        $msg = sprintf( $lang['report_no_name'], '<a href="' . append_sid("admin_report_cat.php") . '">', '</a>' );
        message_die(GENERAL_MESSAGE, $msg, 'Information');
    } else
    {
        $hidden_fields = '<input type="hidden" name="mode" value="create" />';
        // Get ID
        $sql = "SELECT max(cat_id) as max_id FROM " . REPORT_CAT;
        if( !($result = $db->sql_query($sql)) )
        {
	       message_die(GENERAL_ERROR, 'Could not query categories', '', __LINE__, __FILE__, $sql);
        }
        if ( $row = $db->sql_fetchrow($result) )
        {
            $cat_id = $row['max_id'] +1;
            $db->sql_freeresult($result);
        }
        
        $sql  = "INSERT INTO " . REPORT_CAT . "
          (cat_id, cat_name, cat_param, cat_explain)
          VALUES ($cat_id, '$name', '$param', '$explain')";
        if( !($result = $db->sql_query($sql)) )
        {
	        message_die(GENERAL_ERROR, 'Could not query categories', '', __LINE__, __FILE__, $sql);
        } else
        {
            $msg = sprintf( $lang['report_cat_new'], '<a href="' . append_sid("admin_report_cat.php") . '">', '</a>' );
            message_die(GENERAL_MESSAGE, $msg, 'Information');
        }
    }
}
else if ( $mode == 'edit' && $id != '' )
{
    $sql = "SELECT * FROM " . REPORT_CAT . " WHERE cat_id = $id";
    if( !($result = $db->sql_query($sql)) )
    {
	    message_die(GENERAL_ERROR, 'Could not query categories', '', __LINE__, __FILE__, $sql);
    }
    if ( $row = $db->sql_fetchrow($result) )
    {
        $template->assign_vars(array(
            'NAME' => $row['cat_name'],
            'TEXT' => $row['cat_param'],
            'EXPLAIN' => $row['cat_explain'])
        );
        $hidden_fields = '<input type="hidden" name="mode" value="edit" /><input type="hidden" name="id" value="' . $id . '" />';
        if ( $submit )
        {
            if ( $name == '' or $param == '' or $param == 'finished' or $param == 'notfinished' or $param == 'finish' or $param == 'delete' or ( $row['cat_id'] == 1 and $param != 'reportpost') )
            {
                $msg = sprintf( $lang['report_no_name'], '<a href="' . append_sid("admin_report_cat.php") . '">', '</a>' );
                message_die(GENERAL_MESSAGE, $msg, 'Information');
            }
            else
            {
                $sql  = "UPDATE " . REPORT_CAT . " SET
                  cat_name = '$name', cat_param = '$param', cat_explain = '$explain'
                  WHERE cat_id = $id";
                if( !($result2 = $db->sql_query($sql)) )
                {
	                message_die(GENERAL_ERROR, 'Could not query categories', '', __LINE__, __FILE__, $sql);
                } else
                {
                    $msg = sprintf( $lang['report_cat_edit'], '<a href="' . append_sid("admin_report_cat.php") . '">', '</a>' );
                    message_die(GENERAL_MESSAGE, $msg, 'Information');
                }
            }
        }
    }
    // List
    $sql = "SELECT * FROM " . REPORT_CAT . " ORDER BY cat_id";
    if( !($cat_result = $db->sql_query($sql)) )
    {
	   message_die(GENERAL_ERROR, 'Could not query cats', '', __LINE__, __FILE__, $sql);
    }
    if ( $cat = $db->sql_fetchrow($cat_result) )
    {
        do
        {
            $delete = ( $cat['cat_id'] == 1 ) ? $lang['report_delete'] : '<a href="' . append_sid("admin_report_cat.php?mode=delete&id=" . $cat['cat_id']) .  '">' . $lang['report_delete'] . '</a>';
            $edit = '<a href="' . append_sid("admin_report_cat.php?mode=edit&id=" . $cat['cat_id']) .  '">' . $lang['report_edit'] . '</a>';

            $template->assign_block_vars('catrow',array(
                'ID' => $cat['cat_id'],
                'NAME' => $cat['cat_name'],
                'PARAM' => $cat['cat_param'],
                'EXPLAIN' => $cat['cat_explain'],
                'EDIT' => $edit,
                'DELETE' => $delete)
            );
        }
        while ( $cat = $db->sql_fetchrow($cat_result) );
        $db->sql_freeresult($cat_result);
    }
}
else
{
    // List
    $sql = "SELECT * FROM " . REPORT_CAT . " ORDER BY cat_id";
    if( !($cat_result = $db->sql_query($sql)) )
    {
	   message_die(GENERAL_ERROR, 'Could not query cats', '', __LINE__, __FILE__, $sql);
    }
    if ( $cat = $db->sql_fetchrow($cat_result) )
    {
        do
        {
            $delete = ( $cat['cat_id'] == 1 ) ? $lang['report_delete'] : '<a href="' . append_sid("admin_report_cat.php?mode=delete&id=" . $cat['cat_id']) .  '">' . $lang['report_delete'] . '</a>';
            $edit = '<a href="' . append_sid("admin_report_cat.php?mode=edit&id=" . $cat['cat_id']) .  '">' . $lang['report_edit'] . '</a>';

            $template->assign_block_vars('catrow',array(
                'ID' => $cat['cat_id'],
                'NAME' => $cat['cat_name'],
                'PARAM' => $cat['cat_param'],
                'EXPLAIN' => $cat['cat_explain'],
                'EDIT' => $edit,
                'DELETE' => $delete)
            );
        }
        while ( $cat = $db->sql_fetchrow($cat_result) );
        $db->sql_freeresult($cat_result);
    }
}

$template->assign_vars(array(
    'S_HIDDEN_FORM_FIELDS' => $hidden_fields)
);

include('./page_header_admin.'.$phpEx);

$template->pparse('body');

include('./page_footer_admin.'.$phpEx);

?>
