<?php

// ######################################################################
// # PHP-Nuke                                                           #
// #====================================================================#
// #  Copyright (c) 2003 - Francisco Burzi                              #
// #  http://phpnuke.org/                                               #
// #====================================================================#
// # Paladin's Web Links                                                #
// #====================================================================#
// #  Copyright (c) 2003 - Darren Poulton (paladin@intaleather.com.au)  #
// #  http://paladin.intaleather.com.au/                                #
// #                                                                    #
// #  Developed from the PHP-Nuke 6.5 Standard Web Links Module         #
// #  Copyright (c) 2003 - Francisco Burzi                              #
// #  http://phpnuke.org/                                               #
// #====================================================================#
// #  Use of this program is goverened by the terms of the GNU General  #
// #     Public License (GPL - version 1 or 2) as published by the      #
// #           Free Software Foundation (http://www.gnu.org/)           #
/************************************************************************/
/* PHP-Nuke Platinum: Expect to be impressed                  COPYRIGHT */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.techgfx.com                  */
/*     Techgfx - Graeme Allan                       (goose@techgfx.com) */
/*                                                                      */
/* Copyright (c) 2004 - 2006 by http://www.conrads-berlin.de            */
/*     MrFluffy - Axel Conrads                 (axel@conrads-berlin.de) */
/*                                                                      */
/* Refer to TechGFX.com for detailed information on PHP-Nuke Platinum   */
/*                                                                      */
/* TechGFX: Your dreams, our imagination                                */
/************************************************************************/

// ######################################################################
// # Web Links Preferences
// ######################################################################
// #
// # $perpage:                          How many links to show on each page?
// # $popular:                          How many hits need a link to be listed as popular?
// # $newlinks:                         How many links to display in the New Links Page?
// # $toplinks:                         How many links to display in The Best Links Page? (Most Popular)
// # $linksresults:                     How many links to display on each search result page?
// # $links_anonaddlinklock:           Lock Unregistered users from Suggesting New Links? (0=Yes 1=No)
// # $anonwaitdays:                        Number of days anonymous users need to wait to vote on a link
// # $outsidewaitdays:                     Number of days outside users need to wait to vote on a link (checks IP)
// # $useoutsidevoting:                Allow Webmasters to put vote links on their site (1=Yes 0=No)
// # $anonweight:                          How many Unregistered User vote per 1 Registered User Vote?
// # $outsideweight:                       How many Outside User vote per 1 Registered User Vote?
// # $detailvotedecimal:               Let Detailed Vote Summary Decimal out to N places. (no max)
// # $mainvotedecimal:                     Let Main Vote Summary Decimal show out to N places. (max 4)
// # $toplinkspercentrigger:           1 to Show Top Links as a Percentage (else # of links)
// # $toplinks:                            Either # of links OR percentage to show (percentage as whole number. #/100)
// # $mostpoplinkspercentrigger:1 to Show Most Popular Links as a Percentage (else # of links)
// # $mostpoplinks:                        Either # of links OR percentage to show (percentage as whole number. #/100)
// # $featurebox:                          1 to Show Feature Link Box on links Main Page? (1=Yes 0=No)
// # $linkvotemin:                         Number votes needed to make the 'top 10' list
// # $blockunregmodify:                Block unregistered users from suggesting links changes? (1=Yes 0=No)
// # $viewrightblocks:                        1 to Show Right Blocks (1=Yes 0=No)
// # $show_links_num:                        1 to Show Number of Links in Each Category (1=Yes 0=No)
// # $show_links_info:                        1 to Show Latest and Top Links (1=Yes 0=No)
// # $show_links_inum:                        Number of Latest and Top Links to Show
// #
// ######################################################################

$perpage = 10;
$popular = 100;
$newlinks = 10;
$toplinks = 25;
$linksresults = 10;
$links_anonaddlinklock = 0;
$anonwaitdays = 1;
$outsidewaitdays = 1;
$useoutsidevoting = 1;
$anonweight = 10;
$outsideweight = 20;
$detailvotedecimal = 2;
$mainvotedecimal = 1;
$toplinkspercentrigger = 0;
$toplinks = 25;
$mostpoplinkspercentrigger = 0;
$mostpoplinks = 25;
$featurebox = 1;
$linkvotemin = 2;
$blockunregmodify = 0;
$viewrightblocks = 1;
$show_links_num = 1;
$show_links_info = 1;
$show_links_inum = 10;

?>